;---------------------------------------
; Sudoku,  Version 2.0.0
; By: Paul Brennick

    .386                                ; Minimum requirement
    .model  flat, stdcall               ; 32 bit memory model
    option  casemap :none               ; Case sensitive

    include \GeneSys\include\Windows.inc
    include \GeneSys\macros\macros.asm
    uselib  user32,kernel32,shell32,gdi32,GeneSys

AbtDlgProc          PROTO :DWORD, :DWORD, :DWORD, :DWORD
AboutDlgProc        PROTO :DWORD, :DWORD, :DWORD, :DWORD
AsciiBase           PROTO :DWORD, :DWORD
ErrorCheck          PROTO :DWORD
GameCheck           PROTO :DWORD
GameDlgProc         PROTO :DWORD, :DWORD, :DWORD, :DWORD
HyperLinkWndProc    PROTO :DWORD, :DWORD, :DWORD, :DWORD
MakeBar             PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeBox             PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeButton          PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeEditBox         PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
MakeWorkSheet       PROTO :DWORD, :DWORD
PossibilityCheck    PROTO :DWORD, :DWORD
Random              PROTO :DWORD
Report              PROTO
SaveSettings        PROTO
ShowBoard           PROTO :DWORD, :DWORD
ShowHighLight       PROTO :DWORD
ShowHint            PROTO :DWORD
ShowSolution        PROTO
Solver              PROTO :DWORD
StatusCheck         PROTO :DWORD
TimerProc           PROTO :DWORD, :DWORD, :DWORD, :DWORD
WinMain             PROTO :DWORD, :DWORD, :DWORD, :DWORD

.const
;---------------------------------------
IDB_BITMAP      equ 100
IDM_MENU        equ 200
IDI_ICON1       equ 500
IDM_EXIT        equ 501
IDM_ABOUT       equ 502
IDC_URL         equ 505
IDC_EXIT        equ 506
IDM_NEW         equ 507
IDM_VEASY       equ 508
IDM_EASY        equ 509
IDM_MEDIUM      equ 510
IDM_HARD        equ 511
IDM_RESTART     equ 512
IDC_OK          equ 513
IDC_CANCEL      equ 514
IDC_GAME        equ 515
IDD_GAME        equ 516
IDM_LOAD        equ 517
IDC_PREVIEW     equ 518
IDC_EDT1        equ 519
IDC_STC1        equ 520
IDC_STC2        equ 521
IDC_STC3        equ 522
IDD_HELP        equ 523
IDC_TITLE_1     equ 524
IDC_TITLE_2     equ 525
IDC_EDT2        equ 526
IDC_NOTES1      equ 527
IDC_NOTES2      equ 528
IDC_CLOSE       equ 529
IDM_HELP        equ 530
IDM_SAVE        equ 531
IDM_GET         equ 532
IDM_CHECK       equ 533
IDM_CLEAR       equ 534
IDM_TOP         equ 535
IDM_MIDDLE      equ 536
IDM_BOTTOM      equ 537
IDM_UNDO        equ 538
IDM_BLANK       equ 539
IDM_BEGIN       equ 540
IDM_CURRENT     equ 541
IDM_PRINT       equ 542
IDM_HELPER      equ 543
IDM_SOLVE       equ 544
IDM_ERRCHECK    equ 545
IDM_HINT        equ 546

.data
;---------------------------------------
ClassName   db  "GameClass", 0
AppName     db  "  Sudoku", 0
MenuName    db  "IDM_MENU", 0
szString    db  ".", 0
AboutName   db  "AboutDialog", 0        ; About Box Name
szOpen      db  "open", 0               ; Action to perform
szTitle     db  255 dup (0)             ; Overkill, just in case I have a brainfart
Flag        db  0
CurrentDir  db  256 dup (0)
GameDir     db  256 dup (0)
WorkSheet   db  256 dup (0)
szSection1  db  "Most Recent", 0, 0     ; .ini file content
szSection2  db  "Saved Game", 0, 0      ;
szSection3  db  "Window", 0, 0          ;
szKey1      db  "Level", 0, 0, 0        ;
szKey2      db  "Game", 0, 0, 0         ;
szKey3      db  "Level", 0, 0, 0        ;
szKey4      db  "Game", 0, 0, 0         ;
szKey5      db  "Board", 0, 0, 0        ;
szKey6      db  "Vertical", 0, 0        ;
szKey7      db  "Helps", 0 ,0, 0
szKey8      db  "Show Solution", 0, 0, 0
; ********
szReport    db  512 dup (0)             ; Room is reserved for long Reports
szError     db  "There is an error in ", 0
szInvolve   db  " involving the use of the number ", 0
szCRLF      db  13, 10, 0
szRow       db  "Row #", 0
szColumn    db  "Column #", 0
szSubGrid   db  "Sub-Grid #", 0
szMessage   db  30 dup (0)              ; Again with the extra padding
szLocus     db  "0", 0
szResult    db  3 dup (0)               ; One extra NULL for future use
szBoard     db  82 dup (0)              ; Data from the current Puzzle
szSolution  db  82 dup (0)              ; Solution for the current Puzzle
hDocking    db  1
; Never separate the next 2 lines because the Undo buffer could overflow if you do
szUndoBuffer    db  324 dup (0)         ; 81 dwords is allowed
szTopOfBuffer   db  4 dup (0)
WorkBuffer  db  12000 dup(0)             ; Work Buffer for building the HTML file
szHeading   db  "<html>", 13, 10, "<head>", 13, 10, "<title>GeneSys Sudoku</title>", 13, 10
            db  "</head>", 13, 10
            db  "<body>", 13, 10, "<br><br><center>", 13, 10, "GeneSys Sudoku Worksheet<br>"
            db  13, 10, 0
szHeading2  db  "<br><br><table  border=0 cellpadding=0 cellspacing=0>", 13, 10, "  <tr"
            db  ">", 13, 10, "    <td>", 13, 10, "      <table  border=0 cellpadding=2 cellspacing=0>", 13
            db  10, "        <tr>", 13, 10, 0
szEnding    db  "        </tr>", 13, 10, "      </table>", 13, 10, "    </td>", 13, 10, "  </tr>", 13, 10, "  <tr>", 13
            db  10, '    <td align=right>', 13, 10, '      <font face="arial" size=-2>', 13
            db  10, '      <A href="http://pbrennick.freehosting.net/">GeneSys Sudoku</A></fo'
            db  "nt>", 13, 10, "    </td>", 13, 10, "  </tr>", 13, 10, "</table>", 13, 10, "<"
            db  "/center>", 13, 10, "</body>", 13, 10, "</html>", 13, 10, 0
szPrefix    db  "          <td>", 13, 10, "            <table  border"
            db  "=1 cellpadding=0 cellspacing=0 bordercolor=black>", 13, 10, "              <"
            db  "tr vAlign=center align=middle>", 13, 10, 0
szMiddle    db  "              </tr>", 13, 10, "              <tr vAlign=center align=middle>"
            db  13, 10, 0
szTriplet   db  "        </tr>", 13, 10, "        <tr>", 13, 10, 0
szLeftCell  db  "                <td width=33 height=33 >", 0
szWhite     db  "<font color=white>", 0
szBlack     db  "<font color=black>", 0
szFontEOF   db  "</font>", 0
szCellData  db  "0", 0
szRightCell db  "</td>",13, 10, 0
szSuffix    db  "              </tr>", 13, 10, "            </table>", 13, 10, "          </t"
            db  "d>", 13, 10, 0
szNotes     db  "The aim of the puzzle is to enter a number from 1 to 9 in each cell of the g"
            db  "rid. That is the simple answer. It gets complicated because the order of the"
            db  "se numbers must comply to certain, specific rules. Each Row, Column and Regi"
            db  "on must contain only one instance of each number (1-9). The following is an "
            db  "example of a puzzle showing the 3 entities involved here:", 13, 10, 13, 10
            db  "                    -      -----------------     -----", 13, 10
            db  "    4 9 1 6 2 6 5 8|3|    |4 9 1 6 2 6 5 8 3|   |4 9 1|6 2 6 5 8 3", 13, 10
            db  "    2 6 3 5 4 8 1 9|7|     -----------------    |2 6 3|5 4 8 1 9 7", 13, 10
            db  "    5 7 8 9 3 1 2 4|6|     2 6 3 5 4 8 1 9 7    |5 7 8|9 3 1 2 4 6", 13, 10
            db  "    1 3 4 8 5 9 7 6|2|     5 7 8 9 3 1 2 4 6     -----", 13, 10
            db  "    7 2 5 3 6 4 9 1|8|     1 3 4 8 5 9 7 6 2     1 3 4 8 5 9 7 6 2", 13, 10
            db  "    6 8 9 1 7 2 4 3|5|     7 2 5 3 6 4 9 1 8     7 2 5 3 6 4 9 1 8", 13, 10
            db  "    9 1 6 2 8 5 3 7|4|     6 8 9 1 7 2 4 3 5     6 8 9 1 7 2 4 3 5", 13, 10
            db  "    3 4 2 7 9 6 8 5|1|     9 1 6 2 8 5 3 7 4     9 1 6 2 8 5 3 7 4", 13, 10
            db  "    8 5 7 4 1 3 6 2|9|     3 4 2 7 9 6 8 5 1     3 4 2 7 9 6 8 5 1", 13, 10
            db  "                    -      8 5 7 4 1 3 6 2 9     8 5 7 4 1 3 6 2 9", 13, 10
            db  "          Column                  Row                  Region", 13, 10, 13, 10
            db  "As you can see from the above, there are 9 Columns, 9 Rows and 9 Regions. Ea"
            db  "ch of these entities (if you will) need 9 (unique) numbers. This 'interplay'"
            db  " or relationship between the three entities is what makes this game a fun-ha"
            db  "ir puller. It is for that reason 4 levels are available to you. You need to "
            db  "start somewhere, so start with the very easy puzzles. That expression, by th"
            db  "e way, can be very misleading. There are few puzzles that are truly very eas"
            db  "y. The expression merely means that using though logic a number can always b"
            db  "e found to fill a square. The medium and hard puzzles rely on thought proces"
            db  "sing, also; but, they also require some guessing. So the need to guess is th"
            db  "e determining factor here.", 13, 10, 13, 10
            db  0
szInfo      db  "Sudoku ...", 13, 10, "----------", 13, 10
            db  "Sudoku (pronounced soo-dough-coo with the emphasis on the first syllable) is"
            db  " a simple number-based puzzle/game played on a 9x9 grid that is divided into"
            db  " 9 3x3 subgrids. The goal of the game is to enter a number from 1 to 9 in ea"
            db  "ch cell so that each number appears only once in each row and column. In add"
            db  "ition, each 3x3 subgrid may only contain one of each number.", 13, 10, 13, 10
            db  "At the start of a new game, Sudoku chooses a game at random and fills some o"
            db  "f the cells for you. Cells filled in this manner cannot be changed by the us"
            db  "er and working around that fact is the challenge of the Game. You focus on a"
            db  " cell by clicking it and then you can enter a number from 1 to 9. If you mak"
            db  "e a mistake, you can, either, enter another number or press 0 to erase the c"
            db  "ell. When you have successfully completed a puzzle, the entire puzzle is gra"
            db  "yed until you select a new game. Other ways of changing the focal point (the"
            db  " box with the bold outline) is to use the TAB, BackSpace, SpaceBar, NumberPa"
            db  "d Keys or Arrow keys. The TAB key functions in the same way as the Right Arr"
            db  "ow key. The BackSpace is the same as a Left Arrow key. The SpaceBar is the s"
            db  "ame as pressing the Zero key. The NumberPad keys function as expected, with "
            db  "NumLock on, they are numbers; with it off, the Arrow keys will function. Pre"
            db  "ssing the Right Arrow will move the focal point one cell to the right. If th"
            db  "e new cell is not a playable cell, the process will continue moving to the r"
            db  "ight until a cell that is playable is found. If the right boundary is reache"
            db  "d, the focal point will move to the first cell in the next row and so on. If"
            db  " the bottom right cell is reached, the next focal point will be the cell on "
            db  "the very top left of the Puzzle. The Left Arrow works in the same manner but"
            db  " in reverse. The Up and Down Arrow keys will always keep the focal point in "
            db  "the same column and will wrap from the top to the bottom (Up Arrow) or from "
            db  "the bottom to the top (Down Arrow). No matter what motion key is pressed, th"
            db  "e current highlighted cell will have its highlight (the bold outline) remove"
            db  "d and the new cell that is to receive focus will become highlighted. Data en"
            db  "try can only be performed in a highlighted cell and only cells that are not "
            db  "filled with default values can become highlighted. At the start of a game a "
            db  "playable cell is chosen at random to be the first focal point. After that, y"
            db  "ou choose where the focal point will be.", 13, 10, 13, 10
            db  "Sudoku includes the following Menu Options:", 13, 10, "---------------------"
            db  "----------------------", 13, 10, "New Puzzle:", 13, 10, "-----------", 13, 10
            db  "This option will randomly select a Puzzle from any of the 500 Puzzles in the"
            db  " current Level and builds the GameBoard for you. There are 2000 Puzzles divi"
            db  "ded into 4 categories; Very Easy, Easy, Medium and Hard.", 13, 10, 13, 10
            db  "Restart:", 13, 10, "--------", 13, 10, "This option merely clears all entrie"
            db  "s you have made from the grid allowing you to start over playing the same Pu"
            db  "zzle.", 13, 10, 13, 10, "Load Puzzle:", 13, 10, "------------", 13, 10
            db  "With this option you can choose a specific Puzzle by using a number from 0 t"
            db  "o 499. Be sure to select the correct playing level before you do this. There"
            db  " is a Preview Button that allows you to see a simplified grid containing the"
            db  " selected Puzzle so you can be sure you get the one you want.", 13, 10, 13, 10
            db  "Save Current Puzzle:", 13, 10, "--------------------", 13, 10
            db  "The complete state of the current Puzzle (excepting the Focal Point) is save"
            db  "d to an INI file so that you can complete it in another session. The Registr"
            db  "y is NOT used for this.", 13, 10, 13, 10, "Get a Saved Puzzle:", 13, 10, "--"
            db  "-----------------", 13, 10, "If you have saved a Puzzle previously, you can "
            db  "use this option to reload it in the state of completion you had reached."
            db  13, 10, 13, 10, "Notes:", 13, 10, "------", 13, 10, "The Registry is not use"
            db  "d by the Game at all. There is an Uninstall program that can be used if you "
            db  "no longer wish to use this Application but, you can just delete the files an"
            db  "d directory without worrying about the Registry. Doing this, however, can ca"
            db  "use an unused Registry entry IF, while installing, you choose to add a Link "
            db  "to the Right-Click Menu. This entry is stored in the Registry because it nee"
            db  "ds to be handled by the Operating System. The other two Shortcut options do "
            db  "not use the Registry. Using the Uninstall option is the best way of cleaning"
            db  " up and it is recommended that you make use of it.", 13, 10, 13, 10
            db  "Another use of the Save and Get options is to use them when you are about to"
            db  " guess as to what to do next. Before you guess, it is a good idea to save th"
            db  "e current state of the Puzzle. If things go out of whack in terms of your ch"
            db  "oices, you can always restore the Puzzle to the way it was before you starte"
            db  "d guessing.", 13, 10, 13, 10, "Difficulty:", 13, 10, "-----------", 13, 10
            db  "These four options enable the selection of the Sudoku difficulty rating.", 13
            db  10, 13, 10, "Very Easy has the easiest configuration.", 13, 10, 13, 10
            db  "Easy and Very Easy has the biggest number of entered digits when compared to"
            db  " the others.", 13, 10, 13, 10, "Medium has the biggest number of entered dig"
            db  "its when compared to Hard. Requires guesswork.", 13, 10, 13, 10
            db  "Hard requires more guesswork than Medium does.", 13, 10, 13, 10, "Undo:", 13
            db  10, "-----", 13, 10, "This feature allows you to erase your entries. Use it t"
            db  "o remove mistakes that have you confused. The Undo Buffer is the same size a"
            db  "s the Puzzle which means that it can almost never overflow. You can Undo your moves"
            db  " right up to the start of the game. Of course, Undo works in reverse of the "
            db  "data entry. The Undo option clears the cell of any contents, it does NOT rep"
            db  "lace any previous value that may have been there.", 13, 10, 13, 10, "Excepti"
            db  "ons (of course :)", 13, 10, "------------------------", 13, 10, "The Undo bu"
            db  "ffer is sized so that, in most cases, it will not become full. Whenever you "
            db  "undo any moves they are removed from the buffer. But, if you continually go "
            db  "back to a certain Cell and change its value that cell location is stored eac"
            db  "h time you do this which can cause a problem. Working on difficult Puzzles c"
            db  "an cause this to happen as a lot of guesswork is involved. So, if the buffer"
            db  " becomes full, the 10 oldest entries are lost. Chances are, this is of no co"
            db  "nsequence. Also, if you repeatedly change the value of a cell without moving"
            db  " to a new cell, it is counted only once in the Undo Buffer. For the most par"
            db  "t, you can ignore this paragraph.", 13, 10
            db  13, 10, "Clear The Report Window:", 13, 10, "---------"
            db  "---------------", 13, 10, "This option erases any text in the Report Window."
            db  13, 10, 13, 10, "Check For Duplication Errors:", 13, 10, "----------------------", 13
            db  10, "During the course of the Game, occasionally, you may wish to know if the"
            db  "re are any duplication errors. You can use this option to do thi"
            db  "s, the results are written in the window to the right of the Puzzle.", 13, 10
            db  13, 10, "Check the Puzzle for Data-Entry Errors:", 13, 10, "-----------------"
            db  "----------------------", 13, 10, "It is possible that an invalid entry can b"
            db  "e made that will pass the duplication test but will cause the Puzzle to be u"
            db  "nsolvable. This option will search for and report these type of errors. In a"
            db  "ction, you would repeat this test after making changes until the Puzzle repo"
            db  "rts that there are no errors.", 13, 10, 13, 10, "Show A Hint:", 13, 10, "---"
            db  "---------", 13, 10, "Insert the correct character into the Cell that current"
            db  "ly has the Focus. The Cell must be empty or an error message will be display"
            db  "ed. Before this happens, the Puzzle is checked for errors. If there are erro"
            db  "rs, a report on the first error is made and a Hint is NOT shown.", 13, 10
            db  13, 10, "Docking:", 13, 10, "--------", 13, 10, "This is a feature that was a"
            db  "dded primarily for those people who wear bi-focals. I discovered that center"
            db  "ing the Application on the screen made it difficult for me to play the Game."
            db  " This option allows you to choose docking to the Top, Middle or Bottom of th"
            db  "e screen. Your choice is saved in the INI file and will persist session to s"
            db  "ession unless you choose to change it.", 13, 10, 13, 10
            db  "WorkSheets:", 13, 10, "-----------", 13, 10, "The next three options will al"
            db  "l create an HTML file named Sudoku.html.", 13, 10, 13, 10, "1. Create a Bla"
            db  "nk WorkSheet.", 13, 10, "------------------------------------------", 13, 10
            db  "This option creates an empty Grid that you can use to work out your own Puzz"
            db  "les.", 13, 10, 13, 10, "2. Create a WorkSheet with Start Values.", 13, 10
            db  "------------------------------------------", 13, 10, "This option creates a "
            db  "WorkSheet of the current Puzzle; but, it does not include any user data.", 13
            db  10, 13, 10, "3. Create a WorkSheet with Current Values.", 13, 10, "----------"
            db  "--------------------------------", 13, 10, "This option creates a WorkSheet "
            db  "of the current Puzzle and includes all data input by the User.", 13, 10, 13
            db  10, "Display WorkSheet For Printing", 13, 10, "------------------------------"
            db  "------------", 13, 10, "This option will use Internet Explorer to open the H"
            db  "TML file so the Grid can be printed.", 13, 10, 13, 10, "Show Possibilities."
            db  13, 10, "------------------------------------------", 13, 10, "This option is"
            db  " your helper. When it is enabled, The small window below the Report Window w"
            db  "ill display the possible numbers that can be enterred into the cell that has"
            db  " the focus. Click on another cell and the values will be updated to show the"
            db  " new possibilities. This option is enabled by default. The Menu option is a "
            db  "toggle used to turn it on and off. The current setting will persist Session "
            db  "to Session and/or Game to Game. The status is saved in the INI file and is s"
            db  "et when the program starts.", 13, 10, 13, 10, "NOTE:  If you click on an emp"
            db  "ty cell and no values show in the Possibilities Window; this means there is "
            db  "an error in the Grid's data entry. Use 'Check Game For Errors' to obtain spe"
            db  "cific information as to the error.", 13, 10, 13, 10
            db  "That's about it, enjoy the Game. The following is the list of defined Contro"
            db  "l Keys, etc.", 13, 10, 13, 10
            db  "Ctrl + 1	Create a Blank WorkSheet.", 13, 10
            db  "Ctrl + 2	Create a WorkSheet with Start Values.", 13, 10
            db  "Ctrl + 3	Create a WorkSheet with Current Values.", 13, 10
            db  "Ctrl + E	Select an Easy Puzzle.", 13, 10
            db  "Ctrl + F	Check the Puzzle for Data-Entry Errors.", 13, 10
            db  "Ctrl + G	Check the Puzzle for invalid repetitions.", 13, 10
            db  "Ctrl + H	Select a Hard Puzzle.", 13, 10
            db  "Ctrl + I	Show A Hint.", 13, 10
            db  "Ctrl + L	Allows you to choose a specific Puzzle.", 13, 10
            db  "Ctrl + M	Select a Medium Puzzle.", 13, 10
            db  "Ctrl + N	Randomly select and load a Puzzle using the current Difficulty setting.", 13, 10
            db  "Ctrl + P	Get a saved Puzzle.", 13, 10
            db  "Ctrl + Q	Quit the Game (without saving).", 13, 10
            db  "Ctrl + R	Restart the current Puzzle (all data entry is lost).", 13, 10
            db  "Ctrl + S	Save the current Puzzle.", 13, 10
            db  "Ctrl + U	Undo any numbers you enter, one at a time.", 13, 10
            db  "Ctrl + V	Select a Very Easy Puzzle.", 13, 10
            db  "Ctrl + W	Display WorkSheet For Printing", 13, 10
            db  "Ctrl + X	Clear the Report Window.", 13, 10
            db  "Alt + F4	Same as Ctrl + Q.", 13, 10
            db  "F1	This Help Window.", 13, 10
            db  "F2	Show Possibilities", 13, 10
            db  "F3	Show Solution in the Report Window", 13, 10, 13, 10
            db  0
DataVEasy   db  ".6.2..8...4...82.332.165..4....4.5..635.2.49...........1.7.234...3...7.18..4.3.5."
            db  "..543...24..17.9...2...9..3...7...36.349.....6.8..5.2.38...12.479.....515.1.6...8"
            db  "1....93.27..26...82.63..95....73....8.....1...67.482..34..875..9....1.36.759....."
            db  "64.......9..34.8.7.78....42.9.4...2.48..1.9561..6.9...8...942.....53.6.....86.7.9"
            db  "..273...1.....5.9.4.6.....3.27.5.8.6.85..1..4....6.7.5..95..47.7..4.23..26......8"
            db  ".2.3.74...938.....4....9315...96.7..3.51.....9..7....4..159..2.2..416.3..39...5.1"
            db  ".93..8....5.4.9..846..37.9...6...1428.....9......238.7571...6......562.4...38.7.."
            db  "32.5.8..9.593....8.......3....259..6..6..73..5...3..97..812..5.134.9....2..7648.."
            db  "6129....784...2..........26..5.28.7..396..548.7.5.42...81...7......5..3....4..851"
            db  "...358..45..1.698.....79.657..4..2..4....78...13...6...8.73...29.....3.63729..5.."
            db  "1.5436..826..9..3.7......96.739..6.1...1...4...956.7..5.7.4.........2..4..6...5.7"
            db  ".8..1..7..3..274..7....4..1..6.5.1...7..6.92.2..3.85....8.....6.9.2...4342.13.8.5"
            db  "....62..7..2.3..45.6..1....27....59613..5..8.8..9.7134.97...8..3...75....483...7."
            db  "34.7...9..6....41.2.7.4..6...89.17..7....4..9.2987...35.2....74...56...2.7..92531"
            db  ".57.31.94.....4..3..2..6....43..26....8...342...5....1...26..1.2.5.1873686...5..9"
            db  "..8....6.5..3.72499..26.51....14..8.....7512..85.9.4..........28.17.965..7.52.83."
            db  "...5817.6697.23.5......7.....18....5.8..7.9617.3....842.61.....81...6542..5......"
            db  "....5....12..9453..93..6..7..2.31......5...7...8.69214...1.89624..6...58.....5.4."
            db  "3...987..........884.3.7..1.3......7.2....41.58671.......58....6149.23.5.58.6...2"
            db  ".5.9..4.69.......38.6..1.25..82.47.12........167.5.2.9.7...85.....42..87...39...."
            db  "..6...2181...584..4.8...7.6.15.6.....674.....8.3.91.....9.4.827...7..3......2.195"
            db  "..9...4....3..9...5.2.4..7.8.7.91.....48..91..517...2..96..21453..5....2.1..7...."
            db  ".7..4....951.286.74.....8...39.7......7..2.9...5.9..137...1.5.8...9.7.248.4..31.9"
            db  ".8..3695....4..7.2.9..8...18.3....2.1..29..43.2..51..8...17.....16..4.379......1."
            db  ".6...84...1.76.8..2.3.......5.1....7.2.94.16.1..35.28......1....74.2963.591..4..."
            db  "..8.......26.7.4...3149.5.6.1.2.37.....7......5..4..8.8.....379.43...8..1...396.2"
            db  ".6...5.1..9..6..82..713...59.....23...4.72.9...2.4.6573..52...8..84.71.3.2.3....."
            db  ".72.3....365..8..4.985.23..7.9..52.....8..96.5....9.4...1...6.7...9..41..4.62..5."
            db  ".58.....4.3....6...71846...843..2...9.2....6.5...342.81....9..67.642.9353..68.1.."
            db  ".19....3...275.4.18.7..326.9...7........98..3361.2..7.1......9..9...78.6.26..4.1."
            db  "56.9.18..41.....59..8..547.6.5...7.8.4...832....7..5....6.2.....736..2.59....7.6."
            db  "8.14..7.....8.3.....37.1698.123.......85.7.14.769.2.3.......5.132.......1.96..32."
            db  "...7361..29.45..8..73..2645..4......7.....231.5.9.8.7...1.7..6..6.18.9....5.....8"
            db  "8.92.3..7.71...62......1...9....2.6.3.89.....2.5.3..14.9...47.2.2468.5..1..7....."
            db  "5...8.96...75.3.8....61.2.3..214.....3..6.1..1..9.2875.24..16.9....7.5.23..4.6..."
            db  "27..93..4.....4397.3.15.8..35..4......12.......9.7..688..5..6....7.3..8..93.862.5"
            db  "..46.1.....189..3...57.4.6...341..2.8..5....619..824.56.......3.1....9..5...4.6.."
            db  "4....6.7..7...1....69735..42...5.7.63.71..8...5.8.29.3....4...27.451.6...16.2...."
            db  "19...8.....5..9...3645.2....4975.8.35.....9.4..8.3.652.73.8...1...69723.6.2.....9"
            db  ".2..7.5466.32.1...57.6..2313..1.29....67...8.15....4..4..58..1.8159..67.7....6..."
            db  ".4.5...1...1267.....59..73..7.65...........4..837.1926.68...3.9..9..82...1.39.85."
            db  "..9....6..8.2...1...7..952..5..7..9.9.158...342.9.1.7...84.57...3..9.1.46..71..8."
            db  "71....284.5..42...2....7...1..35.8.2.6..9.3...4.2.1....93...5......63...4.7.25963"
            db  ".1..62..7.....1.89...9854.6......8..1..7..36.5..82..91.....8..324..3.15.893.....4"
            db  "4....693..5.....626.2.854173...2.69..81.....4..4...5.3......3..5....7..81.35682.."
            db  ".682..3...3.6...459.73..8....9.....2.........8.3..54.12741...835...38.6......4.9."
            db  "85.149..2.376.81.....3.7..87.9...82..1..9.643....6.9.7.24....8.1...........475.16"
            db  "......347..41.7....2..45.81..5..3.6949..5173.1...72...9...3...53.27....8.47...2.."
            db  "9.567.3...72.98....4...3...5...12674.26...8..4.1....93...2.7...1.7.36.28...9..4.."
            db  "...32....6.7..8..225.9.....82..473.......3.48..46.2..1..1.3....3...54..7.792..4.3"
            db  "9........42..5.19...6...74.73.9.1...5..827.....163.9.739.2.4.......1..32.82..645."
            db  "..14.6..9...8275.6.....9..3..27..38.9...184.2.836...5..24.7.6...96......7.8...23."
            db  "...9...646...139.....54.81..94.62....3..85296.2....43.3....4..1....3..5...9....4."
            db  "...7.2.3..9.61824.2..3596..42.5.13..5..4....2.19.7...88.5.6..........874..4.....6"
            db  "2...93...37.4158..9....2....8..76.3..9..51.6...3.24.5.6.9..8..5..5...18...1.6..24"
            db  "31...28....5.76.316.84.3.......2....7349.1.5....3.8..9.41...68...6.......5.649.7."
            db  ".79.4.382.8...5....6.9..145...5.1.73.9..6...1...3782..1....9.2.....1...77546....."
            db  "531...692.....2...9.25..14..4.63..193.7....5...8.5.3.67.4.8.26.6...4.......2..43."
            db  "..9.8547...2....8..381.62.....657..161..2..59.....98.489......7.4.9.8.3..2...1..8"
            db  "..94173.8.4..82.61.2..63.4....2...1.....9.5..69..752..7..8...93.5.3..1.6.......5."
            db  ".2.31..7.5...4..1.97.5.84..6...8.1..1..9..8.7.84.....3......36489..34.....6..198."
            db  "...3986..92..1..5..4..5.9.1.64..5.8.7.2..6415.9.....264..5..1....1.7..98.....9.7."
            db  ".9.4.....7....91.22346..85..4.265..7.57.1..8....3...9..167...34..2.4.5.....596..."
            db  ".735...9..1.6.3.......49..7..74.5........2.416..7312..2.....4388..1...767..3.61.."
            db  "8.5...6.3.732....516..5...8...8....7...7.596..92.4..8....91..5.6.4.8.3.....6.741."
            db  "......198...6.1473..3.8..2...9218..7.5.3.7.692..5......1.87495.42...........2...6"
            db  "....2..1..2...4...3..618472.75.9.32........47..2781..969.8..5......6.79...73..2.."
            db  "....6.8....2.75914...9182.7..8.96.....4.51793.5.......421...58.........6.9.1...72"
            db  ".9.81...6..7...5..6..4.71...7.92....8.61......12.5867.38.6..29....58......17.98.."
            db  ".1..52.49.8.413...5.6...31.3..1.42......9.47.86.72.....3...9...4.82...3.9....1.64"
            db  "72..6...5.3.5.....18....769..4.5..3.36...1..2.5...4...578.....36.298...19...2..84"
            db  ".3.1..5..5.......4.67.59.2.75.493..1..87.13........69..2....4.63.1..6..8......732"
            db  "..5.23..8..2......4...91.2...145...9.4....3..2.9.7.4...849.....96..35...52.184.67"
            db  ".73.6...1...5..6.2.....24...3....51.9....3.2.6..1...3.75.3..19.391..42...267....5"
            db  "...3.12..7..9....5.......47..2.....3.5...3.98.39.4...19.78..5....8..2369..5419..2"
            db  "..4....875..39.....37.825.6.9.2487.147.5.....2...39.4.7.1.2683.8...5...9...8.4..."
            db  "8..243..51....8..3.....1.47.3....5..5......29.96.8.1..6..1...5..59..2.713.247.6.."
            db  "....6..4..1.973.6.9...2...1.....852...7..619.249....3.63.5..7.2.9....4..42..1..59"
            db  "5.9.1324.2.1..986.73......9..314.79.4..2..3.....6..1..89...642..5.92.67....7....."
            db  ".5....2.7472.5..1.1...8..94..37.645.7.9..832.24..3.8.6.....4...3....2...62..1..4."
            db  "3...6219.......34..28.14..7...7.1......6.95.35.9.43..6.83497...264..5........6.34"
            db  "7....169..1...24.8289.7.15.6...9.5...2..1....195..3.4.8.3..7..59...487....1.2...."
            db  "...21...35.369....6.1..38...........9..75..28.36....7116...4...497..52...8...2..7"
            db  "71.2.4.8.35.6......28....37.6...2...94....3...3.9..12.6...1.2....3..7591.74......"
            db  "2....7.81.....57..67.8.94....5.63.7..47.5.2..3.....1...34.8...6.1......49.2...81."
            db  "...5.62......4..6.7.......8.6813..79.23.67..1...8...2.48.72...5..9.54.8...568.7.4"
            db  "..3...7..1.936..48.52..7.6..1..9..7.286.1...4.9........31..52...4.2.81.79...7.4.."
            db  "....3.687.1..58....78.2....15...7......5...2..6....8..8.5.7..13...19375...1.8529."
            db  ".586..9..1..4..56..9.......8.2..135..6..5314..1.748....84..7.......3.4.567..2..3."
            db  "..6.8.7.4.386..2...92.7.18....5.6...2.9.3..4.867.4.3..1...9.56....8......7...289."
            db  ".5618..2...1.3....9..6........7.431..1...8.7538.51.....78...1...2....83.16...274."
            db  "...2..9..1..5.3..8..2.67.....7....2...8.715...15....83.7.4.26.93.47...528.9356..."
            db  "..89137...3..26..1........59.1..8..7.8...4...47..5.829127.6...88...72..6....8.4.."
            db  ".82.........13..42.9.8...5.....753.1.2.3.86...7.61...8..956..8.76.....15...7.29.3"
            db  "31........25.3...479.156...9....1...87..........7.38.9..63..74.1....23..539.8762."
            db  "7.82.1...6..9.84..5.2.4.1..1..8..3959..13...8.....6..1...48.673...5.7...8.9....1."
            db  "........9897.4...3.5.7.1...93...76...8...4...1...8.7.2.18.7..6.3...6528...4.231.7"
            db  ".1....69.7.865....3.....5.25873...1.63.89....9.4.17....6...9..51..768..9....4.1.3"
            db  ".3...1...69.32..8..4.9...5..7.8..4....517...98.3......2.17.8.......6..177.9..4328"
            db  "2..61584.....4..9..48.79..3..3...9..75....2319...2..6.3..4...78..578..19.......2."
            db  "........4..72.39.513.9...8.....31..6.8.72.45...2.48.......15...2.3.6.14..4.39...7"
            db  "63.....4..5.42..6.9....8.7.176.........91...63.96.2..5..3.9..8.7923..6.141857...."
            db  ".1..7.29.5.2...8719.41..5.....8...2.....65..8681..9..3..74.1..2...72....24.6.89.."
            db  ".....6..93.6..5.....8..7..38....241.....1..36.61.....7237..1...1..6.438.6..3..57."
            db  ".....6.473.49...269....1....12..3...5.....4.1.4.....7....6975....135.689..9.2.73."
            db  ".65.4..8.8.296..7.9..85.2....9....23...2...5...83.4..162.7.......3..1..2....259.6"
            db  "8..5...9...34..7.65.6..18.2...6.4..8.819.2...6.5..7.......1.46.26...5..1197...3.5"
            db  "82...5..15672......318.....3.97.6.....81.9.76.16....98.....34..47.69....69..1.2.."
            db  ".7.5..2.41..7..59.4...6.7139.2.17.6...145....7...89....9..746....6..53.951...3.4."
            db  "...5.......6.79..81..8...293....287...1.5...37..6..591.8...4....7...5.366.4293..5"
            db  ".8.7..31.2..4....7......485....4.79.86.27...33.765..2..93.82...4..1..2....6...15."
            db  "5..3.8..94....1....8..29...7..25.63.643..75..2...9...83..1.29.7.5...6.4...2.3.18."
            db  ".......7.69..5....3..96785.219...4.5...6....95.34..2...8.5..7.37.62...1..2.743..."
            db  "1.9...5...6.3.749......23.1.9.1.82.3..594...63.....97.621.8...5..3..1..9...6...8."
            db  ".39...1.4...61....7.1.4.5.346.....29..8.67...2.5.......5379....8....179.9...5.3.8"
            db  "95..2.84.782...59...4..8.......9.1..........41.9.4..3.3261..4.5.71.......9.765.13"
            db  "621..8.........6....97..5.4.561..7....3275.8..1..6.43...7.14..3..46.295.56..3...."
            db  "1....9.7...45.73......6.95.78..45.1...5791.....32...9..68...42734......99....41.6"
            db  "...9.5.3..126.....9.3..7..2.3..7.....5...4.931783..4.5.4....2.....89..5...5246..8"
            db  "3..87.29.8.2.46.7.5..19...8.43..1.6.......5...6.......9..413.5.6...2.349.3..5.82."
            db  "59.32.71..3.1...6.461.58.9.3........645.....2.2.9654..2.......8..42.....9..6.41.7"
            db  ".....74.8.7.4.........1..977436..2.5..5248...8..3.59.62...3....5..1..6349..854..1"
            db  ".9.31...6.2..45..835...69..1.9.....7....6....2.3..46155..4.7.6....13.85...46.97.."
            db  "..7.....4.5...813.......76.2.8.3..564...86.2.....19...7.3.94...59.36.47...617..9."
            db  ".8....271..74..9...6.7.85....6..2.49...93.85739......2..4..9.6.2.8....9...9541..."
            db  ".94...1.2.2.7.56......92478.86.2.....5...82....1..4..56..8..9..935...78.812......"
            db  "....7....9..46..21.61..247.5...4.79.3....6...2..8..5.3..4...2..7853....662951.3.."
            db  "..85.69.......9876.4.37....2..7...198........193.45.8..2....1.....6372..9861..73."
            db  "3.6...2.8.1.........52..7.3.7.6...3.623978.5.1.9..58..93....4.5..48...71.5.7....9"
            db  "6...4.2...4.86.7.98...3..4.......5.7.67...4.8.8..1...2....5.324..5.23..12.84.1.6."
            db  "...13.4..158..6923.7..5.6.88....9......2.389.63....5.29.1.2..8..4.7...6..8......5"
            db  "..2..5..7....76....7..1...3.26.8749539..2..76.47.......8926.1.4.1.....696....1.2."
            db  ".......2...1.4.568..89.73......892.1.894..6.5372..184..5..7...686...47..9..6....."
            db  "3..5.1...18.4..679..2..65.1..7..9.6..9..68..2.2.345......6..295.6.18.74........16"
            db  ".8....97.....714.246.2.....24.1.56.7.3.9....4....8625....7.93..75.36.12...3....4."
            db  "9...1..8.825.....1...2.95.659...8.1..4.1...98......7..6.49.28..3..7.61...7.....54"
            db  "5.......7.3....2.8...8341......1.78..48.72.1.197...6.3.1.6.9.4.9....387...3..5.6."
            db  "...9..3..8...3....6.4.8..97.62..81537.13...4.....1....17.64.....231..46.496...73."
            db  "2....68....345.9.154....6......14.6747..9.5.81.57.8.2.31....7.....3.1.8..58....4."
            db  ".5....872892....6.3.71....46...5.9...7.21..584.5...3.1....28......4....62.8.9..1."
            db  "2.8.7..453.6......54......8.629......3.85....1..6.47.96..14..57..7.3.82...1...4.."
            db  ".2451.7.67...48..56...3.1.....8.4.9...........681.2.73...7.3.19.1..2.45828...1.6."
            db  "....9....7....6..595..1.4.8.4.7...6.2..13985..384..7..68...2371...8..9..491..3.8."
            db  ".8.32..6...4..1.82...6.4.192..4.........67.......38254.6..42..5.45.....1.1..5374."
            db  "..3.7.5....68.9..7..2..6..81.874...66....5.8..24.689........8...4..87..186.3547.9"
            db  ".3..1....1...539.89.5..43..5.9.3.1...86..15.....8..73..9..268.1.5.19.4..61.3.8..."
            db  ".94.5..16.2.19.8......6.....3.67.2.85.8.3.1.74.2.8...3..67..3..719....5.8...1...."
            db  "9.6.....51.....4.825839.6....9.3....581.497....7..5.4..9.8.2.1.6.....8..83...79.."
            db  "..3.8.5.21.625..3.2...7186....4.67....4...2.9....97.435.1...4...67.4.......16.375"
            db  "63.89..1....6...8997...4.3.7..3..8...14..76...5..48..2.....9.....9..5428...12...7"
            db  "....35.26.9276..51........8..1....3.2.6..38...5.192.471.78.....3.9.2.78.58.3...9."
            db  "...7.8..171...249.32.91...8.83.....6...68.....5..9.2..53..2..498.2..631.6...5...."
            db  "2...7.9.6..9.65..3......1246.5..18....13...9.3.27.8......51..68..3..2475.8.6..2.9"
            db  "7....3.....3..7158598216..4...86..2.65.......8.4...93..8..74.....715..434...927.."
            db  "..763....2694.8..35....98....1742.89684....32......41...5.6.97.7...1.5..49.....2."
            db  ".98..3.....1582....6....85....397.68.4.12.5..38.4....7....4.31....2.69.5..37.1..."
            db  "9...7..8.....4...18.3.219...275.....4..8.21...3.7162943.1.6......9.5..1.2.5...46."
            db  "3......2..7...289..941786.5.5..6....92..13...6.12..5......472.18....1..3...8.5..."
            db  "34.....82.5..9..47.....7.....17..43...283.6.143.9....59..2.........1352.1.3...864"
            db  "8.7....4..31..875..9.74.18.2739..41..4.5...2...52..9.736..7...1..8...6....9.61..."
            db  "8.3.....554..9....2..86.14..614....27.2..1..8.8...251..39..6..167..1.3..1...8...4"
            db  "3.4....2..6.3.58.4.8.9.2.1.2..13.4....1.58....487.69....75..362.5..6...........49"
            db  ".8..73..62.78.541..1...2.7.....5...1..9..1.8..61....4.4.26..5....37..86...65...9."
            db  "5.784.63..612......3..651......2.89.....83..18745.......5....69.89.....3.2.19...."
            db  "...8..2.6...734519.519....3.1..7.38.8.....6.72.....4.....6.89..49.1....5.63...1.."
            db  "..83.7.4.4.289...6.5..6..9.16.9.2.5...........3.4...82..1.3.8.75.36....998..7...."
            db  ".7.......9.15.7.426.43.1...43...592621.9..8......8...7........91..428.65..267.4.."
            db  ".18....2....56..37..53...1..2189.3..6....49..4.7..568...9.....81.465..9.8..2197.."
            db  ".95..1...37..28..6.8....325.....6..7.287..9..76.4..532.4..3......2..4653......748"
            db  "..5..73...3.95..7.....42.81.5972.4..4...15..33....6...5...8.1.29....1..4.8...49.."
            db  "...4.5...4...3..9531.....746.459....253..1..9...3....7..6.73..2.8.15.7....7.6.84."
            db  "1...2783.5..84..16..8..3.9.8..1.69...26.8.35..3..9.6......62.7..4...1..871.....63"
            db  "72..3.95...1256....8........596...82.348..1........6.....9..4..5.8..1.2.417382..6"
            db  "7...5......1342...........48..469.31....7.48.4..1..7.66.2....53..892...7.7.583.6."
            db  ".6.9...2.7...4...8351.2......4..1..5...869..1..35..2..2...5..8.9..6..34.8...92.16"
            db  "...1.3...3.546.7.2.12..5.3...6.59.2..5.....688..63....9..2.65.4.2......1.845...9."
            db  "24....1...5..19.4...15...8...9...23147...1...5.......41...2857..2..974.673..6.9.."
            db  ".....29...3.6...2.87294...6......519....94..8.97....4.31.52.8...5..6....7...8149."
            db  "...37.4.....96....637.4..1..627.9..4.8...4.394..1...6.2.3...7.88752..6...9..8..52"
            db  ".2.9.81.7......8.4.48.12.699..6.5.83.....74..5...9...61...5.6.2....89.7.47.....5."
            db  "..8....5.651.8.2.7.23..5...5.....3.6.647.1.....7....48...8.79.........2.7921548.3"
            db  "4.6.5..3.7.9....5..1.2.....67.34..95.....63....3.2.47.84.59.1...3...4.279..132..."
            db  ".9...4.........8.341.82.......7.8.6156....7...835...9...6.8..148..39...5..5.6728."
            db  "6..53.14.74.69....9...........786....2.94...1..53...9.3.8.5.7.6..62.84...7.1.39.5"
            db  "6.1.....2...1486..8........1547...36..7.6...9.....5.........265..23....8578.2.3.4"
            db  "..4......37.4.26...1837..4..45.61.....27.8.1.......27...1.2..6..6......12..13.584"
            db  "1.7..2.53.9.63......81.52....6.8.43....36.19..4....58..7.8.....25974...8..12.39.."
            db  "......6.772.9.4.......25.3..4...3519..6..97...8......6......4.546..7.2.11.95...63"
            db  ".4....6.9.....51...7.........26.984.49.8.37....7.5....9.61..458.14.6...378...42.."
            db  "....9.84.....4..753..5.12..6.182.3...8...7.....21...6.834.75..9.1.6....476....53."
            db  "51............8.4..4...3589...78.....95...4...74956..332..6.9..9.6..57..4..89213."
            db  ".3.4.589......83.2.816.97.5..781...4..47.3...3....497..62....53.7..8162..5.3....."
            db  ".7..1..681.37......45...7..3.....217.....6.43..92...56..1975...794....8..5..4817."
            db  "...49..52.....2.1383..5.9..3...41.......68521...7....448.2.5.9...6..7...1.36.42.."
            db  ".12.3.7..6...1....4..2.8.3..9.84..511.........35.9..8..8..25.969.43....8...4..3.7"
            db  ".2.....874.67.852....6....1....29..89.8.7..1..42..6.5.29.86...4.....73...57.1...2"
            db  "51...8...3.2.....167..1.5.2..3.67..9...2951..2.6...4..9....2..8.6.3..2.5827..4.1."
            db  "1..2.7..49..45..78.43......8.5...74...4.823.1..75.4.29..9...46..7.....15...649..."
            db  "..6.83.494.8..152.7.26...3.6.....485.195..2..34......1........7.8.765..25.3......"
            db  "...17..36.3..5..2.8.4.3.1..6..9.....513.6.2947...4.36.3764...8.9....7...4..61...."
            db  "2.7.1..5.6..2...41.....497...9.2..8.35..47....186.5..7...75.......1.9526....86..."
            db  "1..9........7....23.8.2...5.9.15.38..5...812..4......7..7261.486.253.7.....87.2.."
            db  ".62...9.54.7..5.16.9.2.3..4...85.39...9...4.117.4....27...26...6...9.7.8....1..4."
            db  "9.4......23..1....7..3.......3.8.7..54..7698...6..4521.57..38..3.175869....621..."
            db  ".......28.6.152..712...7..3.875.......69.18...126...9.4....6.5...1735..4..5..42.9"
            db  ".95......4.75..3626...8.4.......621..1..586.4.3.4.1.78..3....2...8.37...2.9.6.835"
            db  ".8.9....2.4..1..9....38.7...342.95.1..1...8.76.78...39.76....2.2..69.4.5..3....8."
            db  "..3..52..7..96...3...14..781..326...4....76.5.3....127.7....46..1..38...6.52....."
            db  ".132.6.......3.4..62......1.3..598.71.837..9...4.18.3..8.74....7..9..5.83..8....."
            db  "...71.8..8.14....9....5.13432.64...147..9.3.29.......7..9236..56...7....74.58.9.3"
            db  ".....17...215...3.5.3.97...2..41.9..17..2.....94.5628...56..1..9.73.5...4......73"
            db  "..4.....8.8.16...53.59.8..142.....5...3.42.696...85..27...5.9...1...632....49...."
            db  "6.42.5.83.32....7558.47......794..5...6.8.2.989..1.......8.4.1.....3.7..413.2...."
            db  "7...........32..1....17.2893.6852.742.9.1....8..4931...7..4...3......6.24.3269.5."
            db  "..75.3..66...1..5.3..9..1.4....32...8.3.6..75..145...9..42..7.31.....5....5341.62"
            db  ".4..75.23..6.9.81.3.9.....72.54.9.8.68.5..27...3.....6........5.1...3.62....2.49."
            db  "73...4..194..813..8...7.54.4...5.8....9..3..5.8...9.233..9...52.51..2....9..357.4"
            db  "89...2.......9.3..35.67..9...3.6124.....53.89..82....67..1.65...6.9.....482...9.1"
            db  ".74.6..5..86.572.9.2........4..95.3...34.16..7.123...5..7....6.96..1.873.1.6.3..."
            db  "9..7.1..6..3..2745.743..9.....6..5.7.6593428...9.17....4..69.....8.7.......2..1.."
            db  "...9..1.5951..2.3.7...1...6.16.27....82.6.5.1......8..835....27.97..34..1........"
            db  ".2.38.4.1.4...157.71..4...22.5...3........86..8.....2..9215.74.6..278....374....8"
            db  "..96..41.6.87.4...2...9....7..9.1....954....3314.5..6......9245.2.185379........."
            db  "..4..68.559..713.4.824..6.1..........5..14..88...92.169....8.....8..9.674.13..2.."
            db  "6..98.7..3.25.4..1.4..2.93.....6.257215.....44...3.8....9..74.6.23.4......4...19."
            db  ".67..54...586..179....8.6.2.932.6..17.641..3.42.8.........2..98....6........31..."
            db  ".9.62..41........2.12...56...589..23...2.41....41.6..8..678..15837..2...5....93.."
            db  "..52..6.9..63....47.8..1.3.13.5.2..68...9.4..9......274297...61...9.5348.....49.."
            db  "26.....7443.7..8..18......26.....25.5...9..83.42...9.17..8..195.58...3......49..."
            db  "16.4.8923.39...75.742.5...16.3.1....4....6.1.51....8699....12..............38..46"
            db  ".67..........7.8568526.4.71.2.89.34.7..46.......35..6.....2.6.7.7..1.49...6..3..."
            db  "1...6.2597.5..4.3......8.1...8.....4.17...39.56.4917.2...21.6...71.4...38..7..9.."
            db  "5.7..9.1.2.....9......375....874..32.2.8....93...1.6..13....4677.4.21....56.748.."
            db  "........1.697......526.34.....82..9.9.1..5.3768...9..53....8712....16..48..37.6.."
            db  ".5.1...98.2..7635.6..3..2.......14....156.7.95..2...1.19.4..5.3.7...9..2238...9.7"
            db  "....34..965......4..4...23.327..96.....2...1..4.6..92748.....56.75.1...8...7...4."
            db  "4.....876....37.5..5.2..9...8.72.3.5521....94.7.....2...31..5....73.8..96..974..."
            db  ".1..8..65...5.173...5926..4..9..364.1238.4...467..5..8..2..9...8..7...1....45...."
            db  "..26..71....239....3....26..67..2.....8..1.45.9..4682....7234....31..9.86..5.8.3."
            db  ".2..8.....87...6.51..3.52.9..8.3275..6....92.2..1.83..852..4.....4.1.87.7..8....4"
            db  ".71.28.9....3..562......8....913.7.61...7.38..36589..4.8.96..4.4.2....7...5.4...."
            db  "..1....6.3..1.5.2..5.2...4.9....6.3...2389...5..7.41.9..54....62.3..1.54.9.8572.3"
            db  ".9....67.26.9..1.3....514..6...45.82.12..9...8...73916...736...473..2....2..1...."
            db  "36...2...25..7.8.....8.3.9..1.5..26..32..7.5....92...1.7.2.53..825...4.74..7.85.."
            db  "...57.1..374.9.8.2.65..87..7193.25.8...1.73...8........9..4.21.....234.7.....6..."
            db  ".4.3....26.3..9.1...75.4....7.....6.....28..5..9716.4.4.1......7658..1.4832..579."
            db  "6....53..9......86.....8...17.23.845.92.8...18..7..9...4...367..386.7.92....9...4"
            db  "............1.239..6..4...523.45....1.8....76.496..2..41..8.9..69.73..8..859.4.67"
            db  "...9.3.256....213.28.15..6479162.4....2....5.5.8.3...143...8.....65...9..27.1...."
            db  ".1.9...2.6..32..7.4...7856..9...64.37.3....5.5.48.29..9.8..3..53..6.7..21........"
            db  "6.15.9.28.85....3...3......4....6352.69....8.5..4..6..2...918...9.752.1..57...26."
            db  "..547.8..4.85......13...65.......94..9...51....723.......38..1.681..4.9.2.4..17.5"
            db  "24...5.76....7.3.....894.1.1....743.732....8.....29...5.32.1....91..3....27.6...3"
            db  ".....3916.3.......9.7...8..7692.1..5..5.6..792...57...6.132.7...8..1.6....36....4"
            db  "78625..9.........6....6.5...913.46..3.8....426..8..3.7.6.1...7..1..92.....3.871.5"
            db  ".968.1.25..49...7...5.6..3.9..3...6..7.28......31..74..5...92..81.5.3...4.......3"
            db  "..6.851...3...14...5.4..97....3.9.81......3.58....729.78....6.2...298517.217....."
            db  "175.9.8....2.18......5.374...9..45........6.3.21.374............5.3491..79..6528."
            db  ".67.89..11...4.96......13877..26514...3..8....1...3..2.9.7..2.8..1....3....8.4.7."
            db  "3.....6.7.17....95.85.4.2..5.9.824.32.4...57.17....9..74....3...5.436.8.....79..."
            db  ".8..9.7..7...1.45..3.64.82....7.2...5...3.2.82....4.9.9..35...23..4.6.8..2.17..65"
            db  ".79.13..53.....74.6....2....8.95..1....2..86.93..4.572..7...38..48.7......3..42.."
            db  "..1..7.2486..94...74...6.....86..39.153..84.7.....3......3....16..47.58..27.5...."
            db  "67..19..5.4..56.3..9.32.6.1...48.91.92..75....8....4.2.5.9..7..4.726.....3..4..2."
            db  "..9...4..5.4.7..9.....8...6713..2..59.85.6.....6.1...91.2.67.53.9..24.71.3......8"
            db  ".2.6...94.41...867.7.9.1.....6579.21..4...6........7.....7.3.1.31.2..94..8519..7."
            db  "..6.5.4122....1..3..7.....95..32..64..3.14.759....8...7...3.19......6.4714.87.5.."
            db  "..4182....5..63..9....9.4..6.8..4..59.13.5.872..8.....5.36..17.86.2.......9...2.3"
            db  "2165.49.889...3..7.....96..1.9..546.5..6..1.....917..3..1...3...52....1...8.217.."
            db  "9..3.5.......1.3.44.8.27.59..215.8.6..9...7...6..89.31......58.84653..1.....7...3"
            db  ".74...96.9.34...52....9.3.75..9...7.7.8..36..3.65.4..8...2....9.5.6..13.48...1..6"
            db  "18.5...6....3.9...549......3......9.8..415..2.52.6..8.9.8.3.....35.96..146.8.2.73"
            db  "...7..3.9.5...3.......9564..18.....6.62..1.7..9.53.2...89...12..75.6.8.442.1...65"
            db  "..8.6..1....2.493.39..1....5......86.69...1758.7..1249.13....97...14..53..5..84.."
            db  "..64.8....4.13.28.1.3...5.........3.93..51.6.8.5....2....523.41.219.4...3..61..5."
            db  "8.9...3.55..3.162....87.....9..8.4.22.5......13.2..59..2..5.7..7.....2.6.5.62.9.1"
            db  "....73..5..82.614...1...9.3..9.3..5.....48216.2..1.389.....1.7236.......2.5...4.."
            db  ".74.6....1...5.46....48....3..5...8...27.9.46..723.15..8.1.....2.36...95945...61."
            db  "483..7...2.5.1..79.....5..26..1...3.......1.857..289.4..4.86...3...7.8.5...5..641"
            db  "..9.........57..167.5..832..6.9.58..2.3........8...1.29..487..18.42..6.712.36.48."
            db  "......28418.3..5....28.6.7.......6..316...8..75.4.13.9.......6.52....9...649327.5"
            db  "....7.8.6.....2..9..98431...9...7643...6..59.52..3...1938.14.....42....86....891."
            db  ".5..6..1..8..5.4..7.9...5...18..26.3.7..8..4252.39....1.3..7..5.9.6....48671..2.."
            db  "....931.2..5.72...926...7..2.15.4.8.4..1..3..6.32.94....2..89...9...62.3.6....5.."
            db  ".34.768.16...2..7..........87.63.4.939...12....5....6..2..69..5...358.2...94...3."
            db  "87...5..9.5.62..71.9.....529..4...171.7....3.3.5...2.8....4.1.3234....86.....89.."
            db  "45.89.7..9..1432.8.8...6..4....7534..9....8...134.85.6...56....6.8.......4.3.7.2."
            db  "3.7..15..425...9.....4.5..364.2..7591..5...3......618....3...1.9.4.8...22....48.."
            db  "3194.....87..1.9.46..7.8..1.6..7...8....5.21.54...1....3.5.....1....6.7.49..3.62."
            db  "7..6..91.12...9...94.7...232......81.1.....4.68.4..5.......7.....1.85.7.875342.6."
            db  "18..2...42.49.3.5........828...9..7..39.784......3419...2.6..49.5..428...7....2.3"
            db  "1.25..9...6..8...4.34621..7...7..8.67.8.3.1...9.1......194....8....1.4.28..9...7."
            db  "9...2.37.2..39.56...74.....5..73.942.24..8.5...6...1.7..2.8...5.......1..8365..2."
            db  ".4.7..81..1.983.5.85...2...4.1.7.5...7..2...6..8...72...936.275........123...5..9"
            db  ".47.3689.25..87......5......9.......7..9...263..8.45....634..5.9.56283.7......1.8"
            db  ".9....4.33.7642....28.1.....43....7.16...7.48..5.63.12....38.5.5...26..1.1..94..6"
            db  ".3.9.6...6..2..87..2..7..9...5.8..29.....37.6...5..38.2.6..15..1...65.4.8..3.21.."
            db  ".........4.9..67.8.31.28.95.4...75.2..245.8..8.....3.7.8...5.7.21..3965.35.....8."
            db  "36..9...2..1.5..3..9.3.251.....13.6...8.4.15.2...6..98..257......39...8.75.438..."
            db  ".....2.7.1.29...6.65.74.....816..7....7....8.39..7...2...38.6.7.49.56.28...2..51."
            db  ".........2.9.17.8.68..2..45.1.5.69.........51.9....67.132.5....9..2.8137.74...5.."
            db  ".9.....35.1685.7.4...2....964.3.19.2.3.......1...4...87..46.1..4..51....52.79...."
            db  ".58....37.4.6......294..5..2...179.4.......5.9862451....1.2..4..7.5316.93....4..."
            db  ".....38.7.7956..13312...9..293.56.....72....6.8..19.72.6..2.7.1..43.............8"
            db  "9.8..314.2.4.68.9.....54.834.......1....47...6...1..25845...3..31.4...69....2...."
            db  "4.527..199........8.2916...7.65..3213..6.....2...34..7......57.....5198..78.....4"
            db  "21.....6....25..8.7...619528....7.2..2.94.81..5..8..49..1..........9.63..6952.1.4"
            db  ".......1.23781.4.6...52..87693........24..53....3.816.18....7.......63983...856.."
            db  "....4..3.....8.....315..89...34.5.7.4.2....8..5.812..9..8...5.39.72.3...3.5..8.27"
            db  "3.9....17..6471.....1.2.58.8......5.69....2.....1..8.4..2.4.17.1672.3..8.38......"
            db  ".....73289.3...67.2..31...4...8.615...625...3.1..3......4.82....7159..6.....73.1."
            db  "6.1..5.7.795...86..2.....53162.4.....735........17.69....497..58......1...7.184.."
            db  ".9..348..7...9.15...51...6.4.821..........2.69276.83.....46593...4.....7.8...15.."
            db  ".6.9......9285.34..4......7...47.8..37....92.4..3.8175...7...59....1.....842.5.16"
            db  ".5.8.9...3..5.1..69...3...1...9.32..146....73.9.64...8..9....255...9.4...32...81."
            db  ".5..7..2..8..95.36.341.6...9..6.7..8.7635...2...2...4.5......191...3...449.....7."
            db  "2.85...9.4..8.2..3....465..1.3..72.45.......1864......6.2.1...9.354...7.74.2....5"
            db  "4.89.....9.......75..7.3..415.6..94..8.19.....9.34.16.....39.7.2...148........2.1"
            db  "..3..5..7..8..39..5.6.7..3..7...964..8..4...295.26187.......3..1..538.2....7..16."
            db  ".4..3.8..8..97...2.71.4...6..87.3....17684....6.2.9.81......4..725.....3436..7.9."
            db  ".21.96.8.....2.4..4..7.5.9..5214..3......38.17..8..5.4...5..2...6..3.1.823..8...7"
            db  ".4.69.....927.8....5....8.6..9...6.78.54....3276........312....16.3...45...56.1.."
            db  "657.8..4241....7....3.576...........931..64.5......263..2.7.83.1.68......7.6..5.4"
            db  ".51.6...7....57....8.24.16..3842...992.8...3.4..9.....1..68..4..9.7.23..3.2...8.."
            db  "...8593..8..........2.64..7724.1.9.86..2..75...5.8..26..14..6........2732576..1.."
            db  ".......2.64.58..137..2.36.88.631954......2...91.....3.28..7.36.3.58....917...5.8."
            db  "..5..816..28.345..6....1...941.2...6.627.38.1.8.1469........73.83...7...4....26.."
            db  "..5..2..94269...5.7.8.1..2..5......31.7.538.4.83..4.7....5...47...8..532..9......"
            db  "9.8...6..15..6.....64.2918...62.5......1...5.....468...8..1..2974..58.6....4325.."
            db  "4..3..5.86....5.3...9....71.......59.25.8.1...76...84.1.3.6...2..8142.95.94...7.."
            db  "6....1.97197..........6...25.2...9.6.3.795....7.6...5.9...7..31.63...5..25..8.7.4"
            db  "3...9.7.6..6..3.9279......18......1.27.851..9.6497.3....5369.....71..5...8......."
            db  ".......8..91......5....4137375.....9...32.746.6.91.....572..4...1.84......2.53.61"
            db  "72..4....5....74.........199..18436..1.9...5....5.31.2..94..2...6.7.2.41243....78"
            db  ".....91...98.7..36...5.14.834.156.2..2...7...876........5..4...6.4.287.1.1..6.28."
            db  "8......43.1...3.7....5.1.......7.65...84...29...83.4...823..5.6531..72..69425..3."
            db  ".24....9.67..821...9.4.38.243.5.7.8...62...3..1......72...6.37..4875....16......4"
            db  ".8.5..4.....4...2.74.....81...9...5..287.1.495.......2..7..3.6.8.6.4.5.32398..174"
            db  "65.142......9.....1748.3.2.7.2..51.3.........36......928.53..6.5..2..3..9317...8."
            db  "32.6.589.9.6.4.12.4....2.36..5....812.....6.9......2...4.517.....9..8712..7.6...."
            db  "3..1.6..8421....5.8.9..57.3.3...4127.....8....1..3..65..284..7.1...59.8..8.2.15.."
            db  "3..479.....1...27...8.52..3.3.8.47.9....31.....4.65.8.9..51...6.52...1.46.3..8..."
            db  "..914...2...2.3...3..8...1.92.7.6.4.5.39....146.5.892.79....1.5..8.7...42.53..8.."
            db  "129457.38.43.8.....6..1..9..........71..6..45....9.17.375..2....8...5..7.9..764.."
            db  "2..4.....65.1.7..4....3.....1..7..2.52.9..3.7967...85.345..2......59...3.92..86.."
            db  "....2.7....4.6..811.35.....7..24.853...9.8..6.5.7.........9....649..31...826..4.."
            db  "56....8..9...3.1.242.....79.......811453...9.....64..3...24361..14.7...56..5.9..7"
            db  "89..4.2.........68..2....977......2.518.9...6264.73..9...489.7...6.5....9476325.."
            db  ".9.6...3.13...5...8..7.19.....3...6..2.51.4..7..4...8.51.8.6..9...273...376.5...4"
            db  ".....2..94..7.381..78.612...6.1.4.933.1.2.6.89..6371.2..3.......29......8..2....."
            db  "......9741.63...5.847...1........64...8274..9..5869.376....8...5...3.79..2.59...1"
            db  "9..7.4.....36........58..1.......4...7..5....324.689...96.....3832.7...175..43689"
            db  "....83...5.3......48.17635279.21.....5.......6.1....2..4.7615...6...8..48...24967"
            db  ".4...9..2.1...5.7..5.76.4.8...6...91.29.81....7...4...4.8.7.1.3..7.2.58.....48..9"
            db  ".324..5.7.1687.2..7......18..7..1.32.4..52..9...63.7......83..6.5...7824...5..3.."
            db  ".1..283..2.....8..7.36.41..47..85...3.51.2...86...7925....4.7...38......94..1.283"
            db  "1.8......952...31.36....5..7...1.4...89..7......256..92..5..63783....124.7.4.3.9."
            db  "25...6.1.917...56..6.7.1..4...3..2...2.5.8..9.7.69.......28.69..3.1...478.6..5..."
            db  "..61..4..1..946.8....3......354.2..1.21..95...6.5.7.2....2..1.4..9.5...33..681.52"
            db  ".896..31..3..8...6.74...9..7..9....1..315.4.9.2.846.....6..1........8..521...3.7."
            db  "839.62....7.3.1.8.2.5...3.6.6....85...32.5.4..9..4.7.31....759494...8.....791...."
            db  ".53.218...8.47.9...6.58....3..1......14.526.......748.2.8.9........16.49691......"
            db  "..53.76.9.4....2177.6.1.3.5.7.9.2.....16....4.3457....1..........9...87.45.2381.."
            db  ".7..34.2.2.46.8.7..35.........75..69.....62...9....14.38..2...654.8....2...175.34"
            db  "..3.7....7.8...2..46.9..8.568.32..49...5.9.......64.5..5.2..6....6.45982..7.1.5.."
            db  "4...5.12..7...1...9...843....912...42....9....4673.....9..1354.6...4.7.3.14..6..."
            db  ".254....1.3.5.8..44......6.51.6.39783........98..15..27.89..4..1...3.6....3..7..9"
            db  "6541...288..5.....37...4.59..2.3.51.93.65.7..5.67..........6..7.63.7.2.4.....8.6."
            db  ".9.837..5.2.1..8638..2.....9.8....12.62..34...7..8.3...4.52678..1.....26...7.1..."
            db  "8..1......1.86.4.29.2..4...4...2581.3516....4...9......7....3451...7392...4...17."
            db  "47.28....9...3547..2..749...5.9...18...8..25..9.527...74..1........9....3......67"
            db  "19..5....5....842.6....49.....1..2.....439.654.9.8...73825..7.676..2.58.......1.2"
            db  "..8..7...24..5.7.69....43.1..17...94..4.........4.387.5.9.62.....794.2.3.2.3....."
            db  ".......13.9.4..2.5.32.9..8..7..598....13.8.2..63..41..68...7..2...84....4.7.3256."
            db  "...9....4......61.32.54..8.9.715.8..2.....3..863.92.....4.7.2..71286..53.3.2..7.8"
            db  ".....972..9...3...861...493.1283.95...9.6784.78.9.2..6.2.346.7....2...84.7.....6."
            db  ".......19.582..46.....5.8..5.37...8.167985.34..9....5...6.....7932.67....75.1.62."
            db  "3.1968..748..7.3...7......17...56.1.5........2..3.476.6.2..34.8.542..63.83....1.."
            db  "...2.47..3.7.1.6.2.2.3.98..2........8..645...7.4.....85.2.8.9....819.2..63.7524.."
            db  "..1..95.372....8....3.8....23.4......4..6........7...891.8.472.48275.39.3.5...6.4"
            db  ".51.8.....6...1..5...67.2.9..35..46...9...52....2347....4.....6..6..714.532.4..8."
            db  "35...27.12...615..6..4.......52.83..193...2.64.86.39...7............54.8..17...25"
            db  "4....856..12...9....3.92......2......76.4.3..3.1.597.8...16429.6.9.8.1...5...38.6"
            db  "5..234....96....54..3.9....7.....83..396..5..6.5...97..67.85..3...1.9.87.4..7..1."
            db  "....95137...4...8.17..326495.1.63....83.4.7..9........492.81.......749...1...63.."
            db  "4.5....17....6.9..2...193.8581.92...67.....3..3.64...5....3...6.26..4....5..8..73"
            db  "64...8..793....2.6.2..564.....6.7.4.79....16..1.39.72827....8.1..4...63...8...9.."
            db  ".6..2...515..4..2.2..1.7.8..19.3...8.83..46.2...9.6.3....4681...4...1...73.59..6."
            db  "2....3..61...7......61..973...5.4...53.2.7.98.4.8...35.5.9...81......6.4..4.5.72."
            db  ".....891...932...5...9.1.7376.8.2.59...7168..1.........71.89.4...5..432....56...1"
            db  ".4.....6.1..45..23..9168.5723.8...4.......7.2..8.......527..634.9.5...1..61...57."
            db  "...7834...38.6.791....4..5.28.5....4914.3..8...7......39..765...4..1.8.9.2....1.."
            db  ".512...8.9...6...2..49.........8.5.1.2753...45.9..4.3...2..386..9...21....345..79"
            db  ".....7..21...4..892...81...59..163..7...5.241...7.869..24..58..61...3.2...3...15."
            db  ".91428.7...6..3...4..1.....7.9.3.85181.69....5..7...3....81..94.4.57.......3.95.."
            db  ".28.....4......2.7.7.2.49...54.183..71..92.5...3..5..28....9.21.9..63...4.752...9"
            db  "....23..79..6..8..62.98....3...674.94.1..8.....8..4.53..684..71.7.35..9...9.1.5.4"
            db  ".1...8....7.365.4.2...1.9866...7.....2754.1.8..1..2.3.1........948...3....52.1..."
            db  ".....536...6..94.8.381.4.57.1..5....39..7.1..5.4.31.2.8...9.57.26..1..4...58....."
            db  "..4.....13.6...5...7.2.1.8..89..32....352487.2.79..1.....3.6....3...5.12..17.23.6"
            db  "....56.3.67......5......6.9.8.9....6.5.681....1..23..484.19...3..5.6..983...4572."
            db  ".....3824..8.4...9...8...1.8.41...6.369...74.1.7.649.56.3....989.1...5..24.93.1.."
            db  ".26.1...4.79.6.5.35....7.6929....63.......9.116.3.2....3.9.6.....5.8..9.....237.."
            db  "64518...3....375.4.9.5....88..79.65.9..6..4..5.1.2.9..4.2..91.6..........3.4.1..."
            db  ".7.391......4..276.5.6..1..28..36.14...7..8..43.15.6....9..7.4.7.85...2.1.3.....7"
            db  ".963....7....6724.....8.93.173..6.95.5.1.....2....3618..4....6......8..38...5.7.4"
            db  "8...45.7...7.....53..7..1..2.....4399.5..38.71.3....5....29.5..56..38.9...8.1..62"
            db  "..4.83...52.4...9..1.....429..1....31..5....7.728.......93..251..8...4694.1.6..3."
            db  "......79..19.52..8..5.946....84...2..47.8356...65.9..15.18........92...4..43..2.."
            db  "..251..846.....195.....96..8....14.77.1..29...3.758.6.27.4....6.461.3........7..2"
            db  "86...94513...1.2.....2.83.....425.3..9..87.1..54.9..8.....5374..1...48...36...1.."
            db  "5.....9..2....9635.....3.7..327..8.9.94..1756....9842....8.53414....65..3.5......"
            db  "..5.9..2..47..5...38962.7..97...836.4....695...6..2..7.....15.4.2....6..7....328."
            db  "..29..5....3.......1.7.429...92.......4...86.185..7.3..276.8.594..5.23...6..934.."
            db  "58.12...947..8....2.35..64.........3.943..1...6784..92.5...8.1.7..495....4.2...35"
            db  "....3976.6.......935....4..2..9..8..1.437.95.5...1.3.6...5.32..7.51.2...43.....8."
            db  ".867.....2...3.89.43...1.....3....21...4..9..81..7.36514...5....52346..8.68.9...."
            db  "8..4.91...917....54.2..1......8652172.......65..3....9...69..34.53..89.2.4...37.."
            db  "...4.9.71.4.81....35....4...2.1.3647.1...2.8..3.75.9...65..1..9.....4.3.27...8..."
            db  "9...34.128.7.9...4.2.6.8.977...6398.3..48....69.5714..57........1....5..2......4."
            db  "439.2..1.6.....25..27.1..48.....2..9..51....2...7..3.1.4.6.5.3.8........7.394.82."
            db  "7...9.8....1.....2.9..5..6.9.438...6.8..1.3....62.4.58148.2.6....5.41...2.976...."
            db  "7.39....1.9.1..6.851..83.4..6.....8.1.8364.9..4..2....9..71.8.......5.13.5....7.."
            db  "873......6....3.8.4...785.929..3.7...614..3....5..7.41.....2..3..83..47....89..26"
            db  ".6....243....63.7..2.1.5......95.13..54....2.291......9....84..4327.6..8.18....6."
            db  "2...79.....14........8632.77892..6....3.54..95.46.8....6...2.5..4.5....2.52.87.36"
            db  ".2371..45.574.3628..9...1..39..46...7.......4..43....6.7...15...3..7.......28.43."
            db  ".2.81.73..4.2371...3..5......4..6.1.3.2........6923..456738......9....5....7.5.62"
            db  "431....2.....2.4.1.2.8..36...85..2.33....78.627..89..5.8.1....46..47.5....9..8..."
            db  ".918.67...8....95.5...3......3..5.2...8.7..6.6.4.12..7.79..48..13......4..6591..3"
            db  "5..41..86...3..75.4....6..3.7...2.416.47...9....9.56...3.27.8...4..89.1.89..5...."
            db  "82..5..74........3....3.9...1.6.7.5.2.53...6..4.....1..3.7.2..56..1.47.247.583..."
            db  ".831962.4..2....1...4.7.3.9...254.8......714.9.5......5.67....1.794...23...3...7."
            db  "....9.3........814.3875....42.6..1.9.5.....3...94....2.731..2585.2.7..919...26..."
            db  ".23.9.......8.6..99....4.51.7..238.4..246..1..459..6.3...142.7...6....4.4.76...8."
            db  "32.8..7......751..65.3.94......5..9.572.9..4.9..1.3..8...7...2..9....837.4398...5"
            db  ".15......46.2589.7...6318.....9..6.2..8.....3.....5...5.4.291.8.86..4..9..7...245"
            db  "4....169.5....37...8...7......3.61..16...4.2.8.95..34..4.67...99.6....5...514.8.."
            db  "...49...57...5....852.3.149..93....2..8..4.....16.58.....1.7..81..5..2.6.85.43.7."
            db  ".....2....3..6759..768...2.......96.....7.134.946.1...4...5.....5198...696312...8"
            db  "25384...6.68...75474..6.2...3.6....54...9.16...24.5.....63.4.........8....9..26.."
            db  "964......8...74..35.7.6..1..1..8...67....2..4.86..37.9..932..453....5...1.2...93."
            db  "9.7.315.8.3..261..86....34.14........53.......8974.......1.34294.25...3....26..5."
            db  "...6829....6..375.2....14....5.1.2..72...68..9..327.......9.6486...3...9....68325"
            db  "3418....66.......97..3461..2........8.56...1.9...7...35...2.6.4..6.9.......56782."
            db  "..8....7..6........251.8..91765.42..2...9..8..3...645......3.4.3.27.9.15..1..5.3."
            db  "...98....81....963.97..14...5.6.9.2..4.13...59.18.5......2.8.3.....9.6..4.3.5.1.."
            db  ".7...46....6.2.7.3.3..75..4792......1.3.67..56..38......751......1..853..48..3.2."
            db  "2.8..43.....7....9.64.3.2........7...9.5..46.413267..88.7....3.329...18..51.8...2"
            db  "71..4..8.....5.7..4.28.3..1.7498..2..89...45......78..3..79....5..1..962.6...4.73"
            db  ".7...5..441.827...6.....3....4.71..6.6...8793...9..4....51.2..7.2.3569.89....41.."
            db  ".41...3.9.8.3...7.37.6......2..6.9..4..9..5.1....186...59..4.6..16759.8....82...."
            db  "..46......8.52...6.3.74182....457.688....3.......1..5..2..7.4815.93.4...4......39"
            db  "59.4...2....7..4352.3.6.9....9.2.87.8.2.5.1.......7.5462..3......5.46....3.2.8..6"
            db  "4.678..19..5..9.63..1.62..86.857....9..83..2..53.......4.6.3.....9..8.75.6..9..8."
            db  "...674...485.139.....5981437..3.18...93.4....6...8....326.5...11..86.4........6.."
            db  "...8.273.432.16...8..49....38.....29..........6.1.5.4...6.3819.52.....87.9..7...5"
            db  "56.....9.3..1....7.....8.3..8.65....4.....6.36..4.7.8113.7..426294...3...7..2.51."
            db  "8......93...3..5.1........643.19.2..59.6.4.3.6.1..3..8.8.7563.2.......59.579.16.."
            db  "5..14....32.6....17.1.....6.45.6.31.2839.4.57..7538.2....8..93......31....2...8.."
            db  ".1.98....95.7.14.684.3....15....9.1..9...674.17..3.5.943.6...7.7..2....82..1....4"
            db  "7.....5..6.241.73..912...8.43......882.13..5.....46.9...4..7.13..73..9.69...8...."
            db  ".2....4...5.3...16....6952.4..836..77..94..3..61.5...9.1.6.2.8.2.....3....8.7.291"
            db  "..53..8973....9..1.64.....34.....17...8.42.59.9.5.72346.9.2.3..5.19......2.7....."
            db  "3..84.76..2....43....97...8....9.173.....482..836.1..4...3...42..6..79..49..56.1."
            db  "..318.5.4.8.29....62.3.4....65...41989.......142.......16.3278.7...45.92........3"
            db  "9.37.82....4.63....5..1.93.73.1...........1.7.....68.......148.2.6...37131842...."
            db  "6578.9.2.9...6.........2..1..8.5.4.35.3...7..4..7..1.6.4..37.1.2...9.6...3..25..9"
            db  ".....351.6..548....5.1..4.88.6.1..3.....8.6....4.3728.56...194..1.7.6....8...4.7."
            db  "7.2..4.8........23..593....9.....37...73....118..9.64..68.1...4..4.2879..7....81."
            db  ".6.....5135..47....9.86....9...13.6...7..42..14...25.9.1.....3...63..1944.85..62."
            db  "4..5..7.1591.2...8..8.1.9.........6.75.1.42.3..4.5.81.....73....8....1.9....6.35."
            db  ".648.....3....1..4218..5.7.9....8.....7.14532.2.75....176..28..8.3....57...3.7.1."
            db  ".29...6.3.7.9.4.5...53.2.787615..43..8.......93.62718.8..7.9.......4......7..3..."
            db  "...7.34...341....6..6.2.8.1...4..92..4.85..6.6...795..5....7.189.8..1....1.6..27."
            db  "..7..54.953.14....984.....1.6..5....4..9....3.1.6..8..35..942.6....16.48....7.19."
            db  "3.58..1.91....35..2..9514..5.6384.2..98.65..44.........5....74.......6.1.3.4.7.8."
            db  "6.....1...54.38.6....7694.2.....4.1.84....7.6..1...38.42.8...71.7..56...98.4.15.3"
            db  "8..9.5..7..2.3.....71....39.5...9..6..9.8...1264.5.97.3.6..75......9.7......416.."
            db  "41.85....2.64.....3..71.6............7256...46..9.........91856..9....728.5274.19"
            db  "47.19.8...9638....31...4....6.4.......7.......5.7.1.9.....1....831572..6...8.9713"
            db  "5642.97..2......5..8974.6.1....71..38...32..5.3....2.7.2..84......1..38.6.....9.2"
            db  "....8..97..3...2...6..1.384....3....1.2.54....891..56..75.....83...62.5...8.79.36"
            db  "7...5.38285421....2.96.8...6...3.75....5..4.35....6.2.18.7........8..29..9......8"
            db  "....3486.1.7..2..484...7..532..4..8.5...1...2.19.2.4566..8......3..76....5.293..8"
            db  "..5.63...8762..5.394..5..2.5.....39......7.14.6..1....7.21......9.....61.18.2473."
            db  "..432.1...3..5....9.8.41.....12..7.8.....925.2.567.9.3..759..4.5..4...268.3......"
            db  "...9..3.141...3...8......6.9.7.3.2....1.9.438.4...8.973..4.91565.2..7...1.......9"
            db  ".7....5...1.5.4...4.5.9.6811.4.7.8.6...4.69..38......52....3.6...17..3.2.53.2.4.."
            db  "..46.7.256.9..348......5....984...1.5..2.....2.1.7..3.47...29..91...82.....9543.."
            db  ".5....69...96...478.27....36.....4..12.9.73..7385.6...9..35....2..8..51...1..273."
            db  "...2..8...5...4137786..95......1.6...713...5....85....1.9.6.72.5.7.2.4.8.38...96."
            db  "..21.3...9...4.8155.6.....2.4....1..17.4..35.325.18.64..4.3......1.27....9....67."
            db  ".6...5.9743...9.2....4..8...82.713....1.92..66978.31....41..5...5.9.82...7......3"
            db  ".39....2.4.18..695....623....62....35..3..17.312.7..86......2..24.1....7897....3."
            db  "15..3..8.932..1.674.8.....38....7316.....94.....2...5.2..18.9..........17.15....2"
            db  ".......7..4.25.9.19.5..34...5.6.7.1227....6.91364.9.......3..64..49.8.2...3.4.1.7"
            db  ".6..3..75..7...6..2..647.....63.9.14743.8.95.....6.23..5...61.2.18.....9.7......."
            db  "...23...414.59.68..8..1..3.72..5..1...18.3...8..1....5.1..465.32..3.5...36......7"
            db  ".7.385.9..5.2.........1.84.5..67..28......15.2.....63..29.5..8.7.5.3.4..8134...6."
DataEasy    db  "...2..8...4...82.33..16...4....4.5..635.2..............1.7...4.......7.18....3.5."
            db  "..54....24..17.9...2...9......7....6.3.9.....6.8....2.38....2.4.9......15...6...8"
            db  "1....93.27..26...82..3..95.....3....8.....1...6..4.2..34..8....9....1....7.9....."
            db  "64.......9.....8...78....42.9.4...2.48..1..5.1..6.9.......94.......3.6.....86...9"
            db  "...73.........5.9.4.6.......2....8...85..1..4......7.5..95..4..7..4..3..26......8"
            db  ".2...74.....8.....4.....31....96.7..3.5......9..7....4..15...2.2..4.6.3..3....5.1"
            db  "..3..8......4.9..846..37.....6...14.......9......23..7571...6......5...4...38...."
            db  "32...8..9.5......8.......3.....59..6..6..7...5...3..9...81...5.134.9........648.."
            db  ".1......784...2..........26....28....396......7.5.4....81...7......5..3....4..851"
            db  "...358...5..1.6.8.....79...7..4..2..4....7....13...6...8.73...2......3.6..2...5.."
            db  "1.54....8....9..3.7......96.73.........1...4...956....5.7.4.........2.....6...5.7"
            db  ".8.....7..3..2.4..7....4..1..6.5.1...7....9..2.....5....8.....6.9.2....3...13.8.5"
            db  "....62..7..2.3..45.6..1..........5.6.......8.8..9..134..7...8..3....5....483...7."
            db  "34.7...9..6....4....7....6...89.17.......4..9.2..7...35.2....74....6.....7..9.531"
            db  ".57.31.94........3..2..6....43...6....8...342...5....1....6..1.2.....7..86...5..."
            db  "..8....6....3.7..99..26..1....14..8.....75.2...5..............28.17.965..7.5..83."
            db  "...581..6697.2..5......7......8......8..7.9.17.3.....42.61.....81....54.........."
            db  "....5....12...4.3..93.....7..2.3.......5.......8...214...1.8.624..6...58.......4."
            db  "3...9.7..........884...7..1.3......7.2....41.586.........58.....14..23......6...2"
            db  ".5....4.69.......38....1.25..8..47..2........1...5.2.9.7....5......2..8....39...."
            db  ".......1.1...5.4..4.8.....6..5.6......74.....8.3.91.....9...82....7..3......2.195"
            db  "..9...4....3..9.....2.4..7.8....1......8..9...5.7...2...6..214.3..5....2....7...."
            db  ".7........51...6.74.....8...39.7.........2.9...5.9..13....1.5.8.....7.2.8.4..3..9"
            db  "....3695....4..7...9..8...18.3......1..29..4..2..5...8...17......6......9......1."
            db  ".6...84.....76.8....3.......5.1........9...6.1..35.2.............4.2963.591..4..."
            db  "..8.......2....4......9.5.6.1.2.37.....7......5..4..8.8......79.43...8.......9..2"
            db  ".6...5.......6..8...713...59.....23...4.72.9........573..5....8..84.71...2......."
            db  ".72......36..........5..3..7.9..5......8..96.5....9.4...1.....7...9..41..4.62..5."
            db  ".58.....4..........71846...843......9.2....6.....342.8.....9..67...2..3.3..68.1.."
            db  "..9..........5.4.18.7..326..............98..33.1.2..7.1.........9...78...26..4.1."
            db  ".6.9.1...41.........8..547.6.5...7.8.....832.......5......2......36..2.59....7..."
            db  "8.14..........3......7.169....3.......85...14.769.2.3.......5..32.......1.9...32."
            db  "...7.61...9..5..8..73..2..5..4......7.....231.5.9.8.......7..6....1..9....5.....8"
            db  "8.92......71...........1........2...3.89.......5.3..14.9...47.2.2.68.5.....7....."
            db  "5...8.96...75.3.8.......2....214.....3..6.1..1..9.2..5.24...6.9........23..4....."
            db  "2....3..4......397....5....35..4......12.......9.7..68......6....7.3..8..93.8.2.5"
            db  "..46.......1.9..3....7.......341..2.8..5....6.9...2..56.......3.1....9..5.....6.."
            db  "4....6.7......1....69.35..42.......63.7...8...5.8.29......4...27..5..6....6.2...."
            db  ".....8.....5......3645.2....4.75.8.35.....9.4..8.3.6.2.73.8........972..6.......9"
            db  ".2..7.546..32.1....7....2..3..1.29....6....8..5....4..4..5...1..159..67.7....6..."
            db  ".4.5...1...12.7.....59..73..7..5...........4..837.1926.6....3.9..9..8............"
            db  "..9....6....2...1...7..952..5..7..9.....8...342...1.7....4.5....3..9.1.46..7....."
            db  "71.....8..5..4....2....7...1...5.8.2.6..9.3...4.2.1....9...........63...4...2.9.3"
            db  ".1..6.........1.89...9.5...............7..36.5..82..9......8..324..3.15.89......4"
            db  "4....693..5.......6.2..541.3...2.69..81........4.....3......3.......7..81.3.6.2.."
            db  ".6.2........6...459..3..8....9.................3..54.127.1....3....38.6......4.9."
            db  "85.1....2..7..8......3.7..87.........1..9.643....6.9.7.24....8.1...........475..6"
            db  "......347..41......2...5.81.......6949..5..3.1...7....9...3...5..27....8.47......"
            db  "9.56..3...72..8....4.......5...1.6.4.26........1....93...2.7.....7.36..8...9..4.."
            db  "...32....6.7..8....5.9......2..473.......3..8..46.......1......3...5...7.792..4.."
            db  "9.........2..5.19...6...74.7..9.1...5..82......163.9.....2.........1..32.8...64.."
            db  "..14.6..9...8275.6.....9.....27..38......84.2.8.6...5..2........96........8....3."
            db  "...9....46....39.....54.81..94.62.......85..6.2.......3.......1.......5...9....4."
            db  ".....2.3..9.618.4.....596..42...13..5.......2.1..7...88.5.6..........8.4........6"
            db  "2....3....7.41.8..9....2.......76.3..9...1.6.....2..5.6....8..5..5...1....1.6..24"
            db  "31...28......7......84.........2.....349...5....3.8..9.41...68...6.......5..49.7."
            db  ".79.4.382.8...5.........14........73.9......1...3782..1....9.2.........7..46....."
            db  "..1...69......2...9.25...4..4..3..193......5...8.5...67...8.2..6...4.......2..43."
            db  "..9..547...2.......381..2......57...6...2..59......8..89......7.4.9...3..2...1..8"
            db  "..9.1...8.4...2.6..2...3.4....2.........9.5..69..752..7..8...93.5....1.6........."
            db  ".2.31........4..1.97.5.8...6.....1.....9..8.7..4.....3........489..3......6..198."
            db  "....98...92..1..5.........1.6...5.8.7.2..6..5.9.....264..5..1....1....98.....9.7."
            db  ".9.4..........91..23.6..85..4..65....57.1..8....3...9....7...34..2.4.5.....5....."
            db  ".735...9..1.6.........49.....7...........2.416..731.........4.88..1....6...3.61.."
            db  "8.....6.3..32....516..5...8........7...7.59...92....8.....1....6.4...3.....6..41."
            db  ".......98...6.1.73..3....2...9.18..7.5.3...692..5......1...4.5.4............2...6"
            db  "....2..1..2...4...3..6.84......9.32........47..2781..96..8..5......6..9...7......"
            db  "....6.8......7591.......2.7..8.96.....4.51.93.5.......42....5..........6...1...72"
            db  ".9.81......7...5..6..4..1.....92....8.61......1..58.7.38.6..29...............98.."
            db  ".1..52.4..8...3...5.6....1.3..1.42......9.47..6........3...9...4.82...3.9......6."
            db  ".2..6.....3.5.....1.....7.9..4.5....36...1..2.5...4...578.....36...8...1....2...4"
            db  "...1.....5.......4.67.59....5.4....1..87..3........69..2....4.63.1..6..8........2"
            db  "....23..8..2......4...9..2...1.5...9.4....3....9.7.4...8.......96...5...5..18..67"
            db  ".73.6.......5..6.2.....24........5..9....3.2....1...3.75....1...9...4....267....5"
            db  "...3.12..7..9....5.......47..2...........3.98.3..4....9.78.......8...369...41...."
            db  "..4....875..39.....37..25.6.9...87..47.5.........3..4.....2683.8...5...9.....4..."
            db  "8..2.3...1.......3.....1..7......5.........29.96.8....6..1...5..59..2.7...247.6.."
            db  "....6..4..1...3.6.9.......1.....852...7..6...249....3..3.5....2.........42..1..59"
            db  "..9.1.24...1..986.7.......9..314.79.4..2..3.....6..1..8....642..5..........7....."
            db  ".5....2..47..5..1.....8..94..37..4....9..8.2.24..3.8.6.....4...3........62..1...."
            db  "3...6219.......34..28.1...7...7.1.........5.35.9.....6.83.97...2.4...........6..4"
            db  "7.....69..1...2..8.89.7....6...9.5...2..1......5....4.8.3..7..59...487......2...."
            db  "...21...35..69..........8...........9..75..2..3.....7116...4.....7..52...8......7"
            db  "7..2...8..5.6.......8.....7.6...2....4....3.....9..12.....1.2....3..7.91.74......"
            db  "2....7..1.....5........94....5.63.7..47...2..3.....1....4.8...6.1......49.....8.."
            db  "...5..2......4..6.7.......8.6813...9.23.6...1.......2.48.72......9.........68.7.4"
            db  "......7.....36..48..2..7.6..1..9..7.2.6.1...4.9............52...4...81.79...7...."
            db  "....3.6.7.....8....78.2....15...7......5...2..6....8..........3.....375...1.8529."
            db  ".586..9..1..4...6..9.......8.2..13......5314......8........7.......3.4.5.7..2..3."
            db  "..6.8.7.4.3.6..2...9..7.18....5.6...2.9......867.4....1......6....8..........28.."
            db  ".5.18..2...1.3....9...........7.4.1........7.38.51.....78...1...2........6...274."
            db  "...2..9..1..5.3.....2.67..............8.71....15....83.7...26.93.4.....28..35...."
            db  "..8913....3..26..1........59.1..8..7.....4...4.....82.1.7.6....8...72.........4.."
            db  ".82.........13..4..9.....5.....753.1.2.3..6.....61...8..9....8.76......5.....2..3"
            db  "3.........25.....479.15.........1...87..........7.38.9......74.1.....3..539.8..2."
            db  "7.8.........9.84....2.4.1..1..8..3959...3...8.....6.......8..73...5.7.....9....1."
            db  "........9897.4...3...7.1...93...76...8...4...1.......2.......6.3...6..8...4..31.7"
            db  ".1....69.7..6...........5.2.8.3...1.63.89....9....7....6...9..5...768..9......1.3"
            db  ".3...1...69.32.....4.9...5.......4....51....98.3........1..8.......6...7..9...328"
            db  "2..6158......4..9...8..9..3..3......7.....2.19...2..6.3..4...7...5.8..19........."
            db  "...........7...9.513.9...8......1..6.8....45...2..8........5.....3.6.14..4.39...7"
            db  ".3.....4..5.42..6.9....8.7.176.........91...6.....2..5....9..8.7.23....141.5....."
            db  ".1..7..9...2...87...41..5.....8.........65..86.1..9.....74.1..2...7.....2..6.89.."
            db  "........93.6..5.....8..7........241.....1..36.6......72.7......1....438....3..5.."
            db  ".......4.3.49...269....1....12..3...5.....4.1.......7....6.75....1...6.9..9.2...."
            db  "..5....8.....6..7....85.2....9.....3.......5...83.4..162.7.......3..1..2....2.9.6"
            db  "...5...9...3...7.65.6..18.2...6.4..8..1..2...6.5..7.......1.4..2....5....97.....5"
            db  "82...5..1..72......31......3.9.........1...76.16....98......4...7.69....69..1.2.."
            db  "...5..2.4......59.....6.71.9.2..7.6...145....7...89.......746....6...3.9.1...3.4."
            db  "...5.......6..9...1..8...293....287.....5....7..6..5...8...4..........36..4293..5"
            db  ".8.7..3..2..4....7......485....4.79.....7...3...65..2..9...2...4..1.......6...15."
            db  "5..3....9.....1....8..2....7..2...3.64...75..2...9...83..1.29.7.5...6.........18."
            db  ".......7.6...5....3..9.7...219...4.5...6.....5.34..2...8.5....3..6....1..2.74...."
            db  "1.9.......6...74.......23...9.1.82.3..594...6.......7...1.8...5..3..1......6...8."
            db  "..9.....4...61....7...4.5.346.....29....67...2...........79.........179.....5.3.8"
            db  "95..2.84.78....59..............9............41.9....3..2.1..4.5.7..........765.13"
            db  "621............6.....7..5.4...1.......3275.8.....6.43...7.1...3...6.29..56..3...."
            db  "1....9.....4..73......6..5.78..4......5791......2......68....2.34......99....41.6"
            db  ".....5.....26.....9....7..2.3..7.....5...4.9.1783......4....2.....8...5...52.6..8"
            db  "3..8..2....2..6.7.5..19...8.43..1.6.......5...6.......9..413.5.6.......9....5.8.."
            db  "59.3..7.....1...6.4.1.58.9.3........645.....2...9654..2.......8............6.4..7"
            db  "......4.8.7.4.........1..977..6..2....5.48...8..3....6....3....5..1..6.49..854..1"
            db  ".9......6.2..45..835....9..1.9.....7....6......3..46..5....7......13.85...46..7.."
            db  "..7.....4.5...81........76...8.3..56.......2.....1....7.3.94......36.4....617..9."
            db  ".8....2.1..74......6.7.85....6....4.....3...739......2..4..9.6.2.8....9....54...."
            db  "..4...1.2...7.5.......92478.86.2.........8........4..5...8..9..93....7..812......"
            db  "....7....9..4...2..61....7.....4.79.3....6...2..8..5.3..4...2..7..3....6629.1...."
            db  "..85.69.......9876...37....2..7...1..........19..45.8..2....1.....6.....98....73."
            db  "3.6.......1.........52..7.3.7.6...3.62.97.........58..93....4.5...8....1.5.7....9"
            db  "....4.2...4.8..7.98...3..4.......5.7.67.....8.8..1........5.3.4..5.23........1.6."
            db  "...1..4...5...6923.7..5...88....9......2.3.9..3.......9.1.2.....4.7...6..8......5"
            db  "..2..5..7....76.......1......6.874.539..2..76..7.......8.26.1...1......9.....1.2."
            db  ".......2...1.4..68...9.73......8.2.1..9...6..37...18...5..7....86...47..9..6....."
            db  "3..5.1...1..4...79..2..65....7..9.6..9...8......34.......6..295...18..4........16"
            db  ".8.....7.....71..246.2.....2..1..6.7.3......4....8.2.....7.93...5..6.12...3....4."
            db  "9...1....8.5.........2.9..65....8.1..4.....98......7..6.49.2...3..7..1...7.....5."
            db  "5.......7............834.......1.78..4...2.1..97.....3.1.6.9.4.9....38....3..5.6."
            db  "...9..3..8...3....6...8..97.62..8.5.7.13...............7.6......231..46.49.....3."
            db  "2....68....345...154....6.......4.6..7.........57.8.2.31....7.....3.1.8...8....4."
            db  ".5....8.2.9.....6...71....4....5.9.....21..584.....3......28......4....62...9..1."
            db  "2.8.7..4..........54......8..29......3..5.......6..7.96..14..5...7.3.82...1......"
            db  ".2451.7.67...48..56.....1.........9...........681...73...7.3....1..2.4582........"
            db  "....9....7....6..595....4.8.4.7...6.2...3985...84..7...8...237...........91..3..."
            db  "...32......4....8....6...192..4.........67.......3825..6......5.45.....1.1..537.."
            db  "..3.7.5....68.9.....2.....81..74...6.....5.8..24.6.9........8.......7..18..3.47.9"
            db  ".........1...5.9.89.5...3..5...3.1...86..15.....8...3..9..26..1....9.4..61.3.8..."
            db  ".94.5..16.2.19.8..............6..2.85.8.3...74.......3...7..3...19....5.....1...."
            db  "9.......5......4.825..9........3.....81.497....7..5.4....8.2.1.6.....8...3...79.."
            db  "....8.5.21.6.5....2...718.....4.67....4...2......97..35.1...4...67............375"
            db  "6..89..1........89.7...4.3.7..3.......4..76...5...8..............9..542....12...7"
            db  "....35....9.76..51........8.......3.2.6..3....5.19..47..78.....3.9.2..8.58.....9."
            db  "...7....171...2...32.9....8........6...68.....5..9.2...3..2...98....631.6...5...."
            db  "....7...6..9..5..3......124..5..18....13...9.3.2.........51..6...3..24...8.6..2.9"
            db  "7....3.....3..7158.9.216......8...2.65.........4....3..8..7.......15..43....927.."
            db  "..763.....694....35....98....1742..968.....32.......1.....6.9..7...1.....9.....2."
            db  ".98..3......5.2....6....85....39..68.4.12.....8......7....4..1....2.69....37....."
            db  "....7..8.....4...18...219...27......4..8..1......1.2943.1.6......9.5......5...46."
            db  "3......2..7....8...94.7.6...5..6....9...13...6..2..5......47..18.......3...8.5..."
            db  "34.....82.5..9...7.....7.....1....3....83.6..4..9....59..2.........1..2.1.3....64"
            db  "8.........31.......9.74.18..7.9..41..4.5...2...52..9.736..7......8...6....9..1..."
            db  "..3.....554..9.......86.1...614....27.2.......8...251......6...67..1.3......8...4"
            db  "3.4....2..6....8.....9.2.1.....3.4....1.58....48..69....75..36..5..............49"
            db  ".8...3..6.....541..1...2.7.....5......9..1.8..61......4.26..5....37..8.........9."
            db  "5..84.6...612..........51......2.89......3..18.45............69..9.....3.2.1....."
            db  "......2......345.9..19....3....7.38.8.....6..2.....4.....6.8....9.1....5.63...1.."
            db  "..83.7.4...2.9........6..9.16.9...5...........3.4...82..1...8.75..6.....98......."
            db  ".........9.15.7.426..3......3...59..2..9..8......8...7........91..42..65..267...."
            db  "..8....2.....6..37..53...1..2.89.3.......4...4.7..5.....9.....81..65..9.8...197.."
            db  "..5..1...37..28..6.8...............7.28...9...6.4..532.4..3......2..4.53......7.8"
            db  "..5..7....3.95..7......2.81.59.2.4..4...1.........6...5...8.1.2........4.8....9.."
            db  ".............3..95.1.....7.6.459....2.3..1..9........7..6.73....8.15......7.6.84."
            db  "1....7.3.5..84......8..3.9.8..1..9...26.8.35..3..9.6.........7..4...1..8.1.....6."
            db  "7...3..5....25.....8.........96...82.3.8..1........6.....9..4..5.8..1....17382..."
            db  "7...5......134............4...469..1......48....1..7.66.2....53...9......7..83.6."
            db  ".6.9.....7...4....351........4..1......86...1..3...2..2...5..8.9.....34......2.16"
            db  "...1.....3..4..7.2.12..5.3...6.59....5......8...63....9..2.65.4..........84....9."
            db  ".4....1.......9.....15...8...9...23.47...1...5.......4....2.57..2..9.4.673..6...."
            db  "......9...3.....2.8.2.4...6......519....94..8..7......31.5......5..6........8149."
            db  "....7.4.....96....637.4..1..62..9....8...4.394......6...3...7.88.52......9......2"
            db  ".2...81........8.4.4..1..699..6..........74..5........1...5.6.2....89.7.47.....5."
            db  "..8....5.65..8.2...23..5...5.....3...6.7.1.....7....48...8.7.............921.4..3"
            db  "..6.5..3.7.9....5..1.......6...4..95.....6.....3.2.4..84.59.1...3......79..1.2..."
            db  ".9...4.........8.341.82.......7...6.5.........835.......6....14...39......5.672.."
            db  "6..53..4..4.6.....9............86....2.94...1..53...9.3.8...7.6...2..4...7.1.3..."
            db  "6.......2...1.8...8........1547...3.....6...9.....5..........65..23....8.7..2...4"
            db  ".........37.4..6...1837..4..45.61.....2..8.........27...1.......6......1......584"
            db  "1....2.53...6.......81.52....6.8.4.....3..19..4....58..7.......25.74......1..39.."
            db  "......6.772...4.......2.........3.19..6..97...8.............4..46..7.2.1..95....3"
            db  ".4....6.9.....51...7.........2..98...9.8.37......5....9..1...58.14.6...3.8......."
            db  "......84.....4..753..5.12..6.182.3...8...7..........6..34.7.......6....476......."
            db  "51............8.4......3589...7......9....4...7.956..33...6....9.6..5...4..8..13."
            db  ".3.4..89.........2.8.6.97.5..781...4..47.3...3.....97..62....5.....8..2..5.3....."
            db  ".7..1..681.37......45...7..3.....21......6..3..92...5....9.5...7.........5..481.."
            db  "...49...2.....2.1.83..5.9..3...4........685.1........44......9...6..7...1.36..2.."
            db  "..2.3.7..6...1.......2.8.3....84..511.........3.....8.....2..969.4.........4..3.7"
            db  ".2.....874.67.85.....6....1....29..8..8....1..42.......9......4......3...57.1...2"
            db  "51...8...3.2......6...1.5....3.67..9...2.51..2.....4..9.........6.3..2.5..7..4.1."
            db  "1..2....49...5..78.43......8.5........4.8.3.1..7..4.2...9....6..7......5...649..."
            db  "....83..9.....15..7.26...3.6......8..195.....34......1........7.8..65..25.3......"
            db  "...1....6....5....8.4.3.1.....9.......3.6.2947...4..6.3764...8.9....7......61...."
            db  "..7.1..5.6..2....1.......7...9....8.35..4.....186....7...7........1.95.6....86..."
            db  "1..9........7....23.8.2...5.9.1..38..5...812..4...........61.486..5..7..........."
            db  ".62.....54......16...2.3......85.3....9.....117.4.....7...26...6.....7.8....1..4."
            db  "9.4.......3..1....7..3.........8.7..5...7698...6..452..57..38....1..869....6....."
            db  ".......2....15...712........875.......6..18.....6...9.4....6.5...173...4..5..42.9"
            db  "..5......4.75..3626...8.4.......621..1...86...3.4...7...3....2...8.37...2.......5"
            db  ".8......2.4..1..9....3......3...95.1..1.....76.78...39.76......2...9.4.5.......8."
            db  "..3..5...7..9....3...14...8...3.6...4.....6...3....1.7.7....46..1..38.....52....."
            db  "..32.6.........4...2......1.3..5.8..1...7..9...4.18.3..8.74....7..9..5..3........"
            db  "......8..8.14....9....5.134...64....47..9.3.29.......7..9.36..56........74.5..9.."
            db  ".....17.....5...3.....9....2..41.9..17..2......4.5628...56.....9.73.....4.......3"
            db  "..4.....8....6...53..9.8..142.....5......2.6.6...85.......5.9...1....32....49...."
            db  "6..2.5.83.3......5.8.47......79...5...6.8.2..89..1.......8.4.........7..41..2...."
            db  "7...........32..1....17.2.93.68.....2...1.......4931...7..4...3......6..4.3.69.5."
            db  "..7..3...6...1..5.3..9..1.4.....2...8...6..7...145...9..42..7..1..........5.41.6."
            db  "....75..3..6.9..1.3.......72.54.9.8..8....27.........6........5.1...3..2....2.4.."
            db  "73...4..1....8.3..8...7.54.4.....8....9.....5.8...9......9....2.51..2....9..357.4"
            db  ".....2.......9.3..35.67......3..124.....5..89..82....67..1......6.......482...9.."
            db  ".74.6..5...6.5.2.9.2........4.....3......16.....23...5..7....6.96..1.873.1...3..."
            db  "9..7.1..6..3....45..4...9.....6..5.7.6593..8...9..7....4..6......8.........2..1.."
            db  "...9....5951..2.3.7...1...6.16..7.....2.6.5........8..8......2..9...34..........."
            db  "...38...1.4...157.7...4...2..5...3........86........2..921..7..6..2.8....3.4....8"
            db  "...6..41.6.87.4...2...........9......954....3.14....6......92.5.2..853.9........."
            db  "..4..68.55...7...4.82...6............5..14..8....92.1.9....8.....8..9.6...13..2.."
            db  "6...8.7..3.25.4....4..2.9........25.215.....44...3......9..7..6..3.4..........19."
            db  "..7..54...586...79....8.6.2..32....17......3.42.8.........2..98..............1..."
            db  "...62..41........2..2...56.....9..23.....4.....41.6..8..678..1..37......5....93.."
            db  "..5...6.9..63.....7.8..1.3.13.5.2.......9.4.........274297...6......5..8.....49.."
            db  "26.....7..3.7..8..1.......26......5........83.42.....17..8...9..58...3......49..."
            db  "16.4.8.2...9...7..7.2.5...1..3......4....6.1..1....8699....12..............38..4."
            db  ".............7.856.526...71...89.34.7..4.........5........2...7.7..1.49...6..3..."
            db  "1...6.2.9..5..4........8.1...8.....4......39.56..9.7.2...2..6....1.4...38..7..9.."
            db  "5....9.1.2............375....874..3..2......93...1.6..1.....46......1....56.748.."
            db  "..........697......52..3.......2..9.9.1..5.3..8...9..53....8.1......6..48..37.6.."
            db  ".......98.2..7635....3..2.......14.....56.7..5..2.....19.4..5...7...9..2.38.....7"
            db  "....3...965.............23.3....96.........1..4.6....748.....56.75.1...8...7....."
            db  "4.....876....37....5.2..9...8....3.5521.....4............1..5....7..8..96...74..."
            db  "....8...5......73...5.26..4..9...6..123..4...4.7..5..8..2..9...8..7...1....45...."
            db  "..26..71.....39....3....26...7..2.....8..1.45.9..468.......34.....1.....6..5...3."
            db  ".2.............6.51..3.5..9..8.327...6....92....1.83..852..4..........7.7..8....4"
            db  ".71.28.9....3..562...........9.....61...7..8..3.5.9..4.8.96..4.4.2....7.........."
            db  "..1....6.3..1.5.2....2...4.9......3...2.89...5..7.4..9........62.3..1.5..9.8..2.3"
            db  ".9....6...6....1.3....514..6......8...2..9...8...7391....736...473.......2..1...."
            db  "36.......2...7.......8.3.9..1.5...6...2..7......92...1.7...53..825...4.74....8..."
            db  "...5..1...74.9...2..5...7...1.3.25.8.....73...8........9..4.21.....234.......6..."
            db  "...3....26....9.1...75.4....7.....6.....28..5....16.4.4.1......765...1...3...5.9."
            db  "6....53..9......86.....8...17..3..4...2.8...1...7......4...3.7..386.7.......9...4"
            db  "............1.2.9..6......5.3.45....1.8....76.4.6..2..41.......6..7...8..859...67"
            db  "...9.3..56....213.2..15..647..62......2....5.5.......1.3...8.....65...9...7.1...."
            db  ".1.9...2....32..7.4...7.........6..37......5.5..8.29....8..3..53..6.7..21........"
            db  "6.15.9.2..8.........3......4....63.2.69....8.5..4.....2...9.8......5..1..57...26."
            db  "..547.8..4.........13...65.......94..9...5......23........8.....81..4.9......17.5"
            db  "24.....76....7.3.....8.4.1.1.....43.7.2..........29...5.32.1........3.....7.6...."
            db  ".....39.6.3.......9.7......76.2....5..5.6...92....7.....1.2.7...8..1.6....3.....4"
            db  "78.25..9.........6......5...913.4...........2...8..3.7.6.....7..1..92.....3.8.1.5"
            db  ".9.8.1.2...4....7...5.6...........6..7.28......3...74..5...92..81.5.............3"
            db  "..6.85....3...14...5.4..9.....3.9..1......3.58....7.9.7.....6......98.17.2.7....."
            db  "1...9......2..8......5.374...9...5........6.3.21.374............5..49....9..6.28."
            db  ".6......1....4.96.......3877..265.4......8....1......2.9.7..2.8..1.........8.4.7."
            db  "3.....6...17....95.85.4....5.9.82..32.4...5...7.............3.....436.8.....79..."
            db  ".8....7..7...1.45..3.64.........2...5...3.2..2....4.9.9..35.........6.8..2.1...65"
            db  "..9.13..5......74.6....2....8.95..1.......86.....4..72......38..4..7......3...2.."
            db  "..1..7.2.86..9.....4.........86...9.1.3..84.7.....3...........16..4...8..27.5...."
            db  "6...19........6.3..9.32...1....8.91.92...5.........4.2.5....7..4.726.....3..4..2."
            db  "..9...4....4....9.....8...671......59.85.6.....6........2.67..3.9..24.7..3......8"
            db  ".2.6...94..1...867.7.........657..21..4...6................3...3..2..94..8.19..7."
            db  "..6.5..1......1..3..7......5..3...64..3.14.759....8..........9......6.471..87.5.."
            db  "..41.2....5...3..9....9....6.8..4..59....5..72..8.....5..6..17.8..2...........2.3"
            db  ".1.5..9.88....3..7.....96..1.9..546.5..6..1.....9.7.........3...52........8.2.7.."
            db  "9..3.........1.3.44.8.27.5...2.5.8....9...7...6..8..31......58..46.3............3"
            db  ".7.....6.9..4...52....9.3.75..9.....7.8..36....65....8...2....9...6..13..8...1..."
            db  "18..........3.9...54.......3......9.8..4.5..2.5..6..8.....3......5.96..146.8.2..3"
            db  "...7....9.5...3.......9.64..1......6.62..1.7....53.....8....12..7..6.8..42.1....5"
            db  "..8.6..1....2.49..39..1....5.......6.69...17.8.7....49.13.....7....4......5..84.."
            db  "..64.8....4..3.28.1.....5.........3.93..51...8.5....2......3.41.219........6....."
            db  "8.......5...3.162...........9..8.4....5......13.2...9..2..5.7..7.......6.5.62.9.1"
            db  "....7......82.614...1...9.3....3........48.16.2.....89.....1.7.36.......2.5......"
            db  ".74.6....1...5.4......8...........8....7.9.46...23.15....1.....2.3....959.5...61."
            db  "483..7.....5....79........26..1...3.......1...7..289......86...3...7.8.5...5....1"
            db  "..9..........7..167.5..83...6.9.58..2.3..............29.......18.42.....12.36.48."
            db  ".......8418.3..5....28.6.7.......6..3.6.......5.4.1..9..........2....9....4.327.5"
            db  "....7.8.......2..9....43....9...7.43...6..59..2..3...1.3..1......42....86....891."
            db  ".5.....1..8..5....7.9........8..2..3.7..8..425..39....1.3..7..5.9......4.671....."
            db  "....931.2....72...9.6........15...8.4..1..3..6.3..94.......89...9......3.6....5.."
            db  ".3..7.8..6...2..7..........8..6..4.9.9...12....5....6..2...9..5...3.8.2...94....."
            db  "87...5..9.5.62...1.9.....5.9..4.....1.7....3.........8....4.1..2.4....86.....89.."
            db  "45.......9..143..8.8...6.......7534..9........13...5.6...56....6.8.......4...7.2."
            db  "..7..1...425...9.......5..36..2....91......3......618....3...1.9.4.....22.....8.."
            db  "3..4.....8.....9.46..7.8..1........8......21.54...1....3.5.....1....6.7..9....62."
            db  "7..6..91..2...9....4.7...232......81.........6..4..5.......7.....1.85.7...53.2..."
            db  "18..2....2..9.3..........8.8...9.....39.784.......41....2.6..4..5..4.8...7....2.3"
            db  "1..5..9...6..8...4..4.2...7...7..8.67.8.3.....9.1......19.....8......4.2...9....."
            db  "......37....39.5....74.....5..73.9.2.24..8.....6...1.7....8...5.......1..836....."
            db  ".4.7..8.....983....5.......4.1.7.5..........6..8...72....36..75........123...5..9"
            db  "....368..25..87......5..............7..9...263..8.4.....634..5.9....8..7......1.8"
            db  ".9......33.7.4.....28.1......3....7.16...7..8..5.6..12.......5.5...26..1....94..6"
            db  ".3...6...6.....87..2..7..9...5.8..29.....3.........3..2....15.......5.4.8..3.21.."
            db  ".........4.9..6....31.2..95.....7..2..245....8.....3...8...5.7.21..39.5.3......8."
            db  "3...9...2..1.5.....9.3..5......13.6...8...15.2...6..98...........39...8.75.4.8..."
            db  ".....2...1.29...6.65.74..........7.........8.39..7...2...3....7.49..6.2....2..51."
            db  ".........2.9..7.8.....2..45.1.5.69............9....67.132.5.......2.81.7..4......"
            db  ".9.....35...85.7.4...2.....6....19...3.......1...4...87...6.1.....51....52.7....."
            db  ".58.....7.4.6......29......2...179.........5..8.24.1....1.2..4..7.53...93....4..."
            db  ".....38.7.79.6..13.12...9...9..56.....7.....6....19....6..2.7....43.............8"
            db  "9....314.....6..9.....5...34.............7...6...1..258.5...3..31.4...69....2...."
            db  "..52...199........8.2.16...7.6....213..6.........34..7......57.....5.....78.....4"
            db  "21.....6....25..8.7....195.8....7....2.94.....5..8......1..........9.6...695..1.4"
            db  ".........23..1.4.....52..87.9.........24..53....3.81..1.....7.......63983...85..."
            db  "....4..3.....8......15..89...34.5...4......8..5..12.....8...5.39.72.....3.......7"
            db  "..9....17...47......1.2.58.8......5.69....2.....1....4..2.4.17..6...3....3......."
            db  ".....73.89.....67.2...1...4.....6.....625...3.1..3......4.......7159..6......3.1."
            db  "6.1....7.7.5...86..2.....53.62.4......35........17.69.....97...8............1.4.."
            db  ".9...48..7...9.1....5....6.4.821............6.276.83......6..3...4.....7.8...1..."
            db  ".6.9......9285.3..........7...47.8..37....9..4.....1.........59....1.....842.5..6"
            db  ".5.8.9...3..5....6....3...1...9..2..1.6....73.9.64......9......5.....4...32...8.."
            db  "....7.....8..9..36..41.6...9..6....8.76.....2...2...4.5......19....3....49.....7."
            db  "..8....9....8.2..3....465..1....72.45........864......6.2.1...9.3.....7..4.2....."
            db  "..8......9.......75..7.3..4.5.6..94..8.1.........4..6.....39...2....48........2.1"
            db  "..3.....7..8...9..5.6.......7...9.4..8..4...295.2..87.......3.....538......7..16."
            db  ".4..3.8..8..97...2..1.4...6..87.......768.......2....1......4..725.....3.36....9."
            db  ".2..96.......2....4..7...9..52.4.........38.17..8..5.....5..2...6....1.823......7"
            db  ".4..9.....927......5....8.6..9...6..8..4....3.76........3......1..3...45....6.1.."
            db  "6.7.8..4.41.........3.57............93...64.5......263..2.7.8..1.6............5.4"
            db  ".5......7.....7.......4.16..3......992.8...3.4..9.....1..68..4..9.7.23..3.....8.."
            db  "....593..8............64..7.2..1...86..2..75...5.8...6..14..6........2..257...1.."
            db  ".......2..4.58...3...2.36.88.6.1.54......2....1.....3..8..7.36...58....917...5..."
            db  "..5..816..2...4........1...9.1.2.....627.38...8.1.69........73.83.......4....26.."
            db  ".....2...4.6......7.8.1..2..5......31...5.8...8...4.7....5...47...8..532..9......"
            db  "..8...6...5........64.2918...6.........1...5.....468......1..2974..58......43...."
            db  "4..3..5.......5.....9....71........9..5.8.1...76....4.1...6...2..8.42.9..94...7.."
            db  "6....1..7197..........6...25.2...9...3........7.6...5.9......3..63...5......8.7.4"
            db  "3.....7.6.....3.9.79......1.......1....851..9.64.7.......369.....71..5...8......."
            db  ".......8..9.......5....413737......9....2.746...91.......2......1..4......2.53.6."
            db  "72..4....5....74.........199..1.4.6....9...5....5.31.2..94......6.......243.....8"
            db  ".....91....8....36...5.14.8...1.6.2......7...876........5..4...6.4..87.1.1....2.."
            db  "8.......3.......7....5.1.......7.65...84...29....3.4....23....65.1..7...69425...."
            db  ".2.....9.67...21...9.4.3..24..5.7.8...62......1......72...6..7...8.5....1.......4"
            db  ".8.5........4...2.........1...9...5...87.1.495.......2..7..3.6...6.4.5..2.98..1.4"
            db  ".5..4.......9.....1748...2.7.2...1.3.........36......9.8.53..6....2.....9.17...8."
            db  "32.6..8..9...4..2.4......36..5....8.2.....6.9............51......9..8712..7.6...."
            db  "3..1.6..8421......8.....7.3.....4127.....8.......3..65..2....7.1...59....8...15.."
            db  "...479.....1...27...8.....3.3...47.9...........4.65.8.9...1...6.52.....46....8..."
            db  "....4...2...2.3...3......1.92.7.6...5..9....1.6.5.8.2.79......5..8.7...42.53....."
            db  "1..457.38.............1..9..........7...6..45....9.17.375..2....8......7.9...64.."
            db  "2.........5.1.7..4....3.....1..7..2.5..9..3.7......8..34...2......5....3.92..86.."
            db  "......7....4.6..81..35.....7..2....3.....8..6.5.7.........9....649...1....2...4.."
            db  "56....8..9...3.1..42.....7..........1.53...9.....64..3...2..61..14.....56....9..7"
            db  "89..4.2.........6...2....977......2.5...9...62.4..3......489.7...6......94..325.."
            db  ".9.6...3.13...5...8....19.....3...6....5.....7......8.51...6..9...2.....376.....4"
            db  ".....2..94....381..78..12.......4..33.1...6.8...6.7..2..3.......29......8..2....."
            db  "......9.....3...5.84....1........6....8274.....58.9.376....8...5...3.7...2.59...1"
            db  "9..7.4.....36.........8..1.......4...7..5....3.4..8.....6.......32.7...175...3.89"
            db  "....83...5.3......4...76.5279..1.....5.......6......2....7615...6...8..4....2.9.7"
            db  ".4......2.1...5.7..5.76.4..........1.29.81............4.8.7...3..7.2.5.......8..9"
            db  "..24..5.7.168..2..7.......8..7..1.3..4..52..9...6..7......8.....5...7..4...5..3.."
            db  ".1..2.3..2.....8.....6.41..47..85.....5..2...8....7.2.......7...38......94..1.283"
            db  "1.8.......52...31..6....5..7...1.....89..7......25....2..5..6.7......124.7...3.9."
            db  "25.....1.9.....56....7.1..4......2...2...8..9.7.6.........8.69..3.1....78.6..5..."
            db  "..61..4..1..9.6.8...........354.2..1.....9....6.5.7.2....2..1....9.....3...681..2"
            db  ".8.6..31...........74...9..7..........315.4.9.2..4......6...........8..521...3.7."
            db  "8.9.62......3...8.2.5...3.6.6....85...32.5.4..9..4.........75..9....8.....791...."
            db  "..3.21....8.47.9...6.5.....3..1......14...........748.2...9.........6.496.1......"
            db  "..5...6.9.4....2....6.1.3.5...9.2......6....4.3457....1..........9...87.45.2.8..."
            db  ".7...4.2.2..6.8.7..35.........75..6...........9....14.38......65..8........17..34"
            db  "..3.7....7.....2..46.9..8.5.8.3...49.....9.......6..5..5....6......45.82..7.1...."
            db  "4...5.12..7...1.......84.....9.....42....9......73.....9..1.54.....4.7.3.1...6..."
            db  ".2.4....1.3.5.8...4......6....6.39.83.........8..15..2..89..4..1...3.6.......7..."
            db  "6.41....88..5.....37...4..9..2.3.51..3....7..5..7.............7.6..7.2.4.....8.6."
            db  ".9...7......1...638........9.8....12.62..34...7..8.3...4..2678..1.....26........."
            db  "8.........1.86...29.2..........2.81.3516....4...9...........3.5....7392...4....7."
            db  "47.2.........35....2...49.........1....8..25..9..27...74..1........9....3......67"
            db  "....5....5....842.6....4......1..2......3..654.9.8...7382...7.676....5........1.."
            db  "..8..7...2...5...69.....3.1..1....9...4.........4.387.5...62.......4...3.2.3....."
            db  ".......13.9.4....5.32.9..8.....5.8.....3.8.2..6....1..6....7..2...84......7.32.6."
            db  "...9....4......61.3..54....9.715....2.....3..86.........4.7.2..7...6..53.3.2..7.8"
            db  ".....9.2......3...8.....49...2...95...9.67.4.78.9.2..6.2.346.7....2...84.7.....6."
            db  ".......19.582..46.....5......37.....16..85.3...9....5...6.....7932..7.......1.62."
            db  "..1968...4...7.3...7......17...56...5.............476.6.2..34.8.5.2..6..83......."
            db  ".....47..3...1.6.2.2.3.9............8..645...7.4.....85.....9.....1..2..63.75.4.."
            db  "..1..95.372....8....3......23.4......4..6........7....91.8..7..4..75..9.......6.4"
            db  ".51.8.....6...1.......7.2.9..35...6.......52.....3.7....4.....6.....71...32.4..8."
            db  "35....7.12...6.5..6..4........2.83..1.......64.....9...7............54.8..17...25"
            db  "4....856..12...9.......2......2......76......3.1.5.7.8...1.4.9.6.9.8.1.......3..6"
            db  "5..23......6.....4....9....7......3...96..5....5...97..6..85..3...1.9..7.4..7..1."
            db  ".....51.7...4...8.17...26495.1.63....83...............4.2.81.......7.9.......63.."
            db  "4.5....1.....6.9..2.....3.8581..2....7........3.64........3...6.....4....5..8..73"
            db  "64...8...9.....2...2..56......6.7.4.79....1...1.3..7.8.7....8.1..4....3...8...9.."
            db  "........5.5.....2.2..1.7.8..19.......83..46.2...9.6.3.....681...4...1....3.59...."
            db  ".....3..61...7......61..9.......4...53...7.9..4.....35.5.9...81......6.4....5.7.."
            db  ".......1...93....5...9.1.7376.8.2..9...7.68..1............89.4...5....2....56...1"
            db  ".4.......1..4...23..9.68..723.8...4.......7....8.......52...634.9.5...1..6......."
            db  "...78.....38.6.7......4..5.2..5....4.1..3..8...7......3...765...4..1.8.9......1.."
            db  ".5.2...8.....6......49.........8...1.2753...45.9..4.....2....6..9....1....3.5..79"
            db  ".....7...1...4..892...8....59..163..7...5...1...7.86....4..58..6....3.....3...1.."
            db  ".91.2..7...6..3...4..1.....7...3.851.1.69....5......3....81..9..4..7..........5.."
            db  "..8.....4......2.7.7....9...54...3..7...92.5...3..5..28.......1.9..63...4..52...9"
            db  ".....3..7...6..8..62..8....3...674..4.1..8.....8....53....4..71.7.3...9...9.1.5.."
            db  ".....8....7..65.4.2.....9.66...7.....2..4.1.8..1....3.1.........48........52.1..."
            db  ".....536...6..94.8.38.....7.........39..7.1..5.4.31.......9..7.26..1..4....8....."
            db  "..4.....1..6...5...7.2...8..89.........5.487.2..9........3.6....3...5.12..17..3.6"
            db  "....56.3..7.............6.9...9......5..81....1..23..484.1....3..5....98.....572."
            db  ".....3824....4.......8.....8.41...6.369...74.1.....9..6.3....98..1...5..24..3.1.."
            db  ".2..1...4..9...5.3.......692.....6........9.116.3.2......9.6.....5.8........237.."
            db  "6451....3....37....9......88.....65.9..6..4....1.2.9..4.2.....6..........3.4.1..."
            db  ".7.39.......4...76.5.6..1...8...6.1.......8..43..5.6....9..7.4....5...2.1.3.....7"
            db  "..63...........24.....8.9...73..6.9..5.......2....3.18..4....6......8..38...5.7.4"
            db  "8...45.....7.....53..7...........4399.5..38.71...........29....56...8.....8.1...2"
            db  "..4.83...52.4......1..........1....31..5....7.728.......9...25...8...4.94...6...."
            db  "......79..1..5...8..5.946.....4......47.8356...6..9..15..8................43..2.."
            db  "..251..846......95......6..8.....4.......29...3.758.6.27........461..........7..2"
            db  ".6.....513...1.......2.83.....4.5....9..87.1..5..9..8......374..1...48...36......"
            db  "5.....9.......9635.....3.7...27..8.9.9...1..6......42....8.5.414....6...3.5......"
            db  "..5.9.....4.......3.962.7..97...83........95...6.....7.....1..4.2....6..7....328."
            db  "..29..5....3.......1.7.4.9...92............6.1.5..7....276.8..9...5..3...6..9.4.."
            db  "58.12.....7.......2.35..64.........3..43......6784...2.5...8.1.7..495..........3."
            db  "....3976.6.......935.......2.....8....4.7....5...1.3.6...5..2.....1.2...43.....8."
            db  ".86......2...3.89.4....1.....3....21...4.....8...7.36.14...5....52.46.......9...."
            db  "8..4.9....917....54.2.........865.172.......6...3....9...6...3..53...9.2......7.."
            db  "...4.9.7....81....35........2.1....7.....2.8..3..5.9...65.....9.....4.3.27...8..."
            db  "9....4.128.7.9.....2.6...977...6....3..48.....9.5714............1....5..2......4."
            db  "439.2....6......5..2..1...8........9..51....2...7..3.1.4.6.5.3.8..........39....."
            db  "7...9.8..........2.9..5..6.9.438.....8.........62.4.5.148.2......5.41......7....."
            db  "7.39....1...1..6.85....3....6.......1.836..9..4..2....9..7..........5..3.5....7.."
            db  "8.3...........3.8.4....85.929..3.....6.4..........7.4......2..3..8...47....89..26"
            db  ".6....243.......7..2.1.5......95.1...5.....2..91......9....84..4..7....8.1.....6."
            db  "2...79......4........8632.7.89...6....3.54..95.4.......6...2.5..4.5.........8..36"
            db  ".2371...5.57...6.8......1...9..46...7..........43....6.7...1.......7.......28.43."
            db  ".2.81.7...4.2.71...3..5.........6.1...2........69.3..4....8......9....5....7.5.62"
            db  "431....2.......4.1...8..3.....5..2.33.....8.6.7..89....8.1....46.....5....9..8..."
            db  ".918..7...8....95.5...3......3..5.....8....6.6...12..7.79..48..1...........5....3"
            db  "5..41..8....3..75.4....6..3.7...2...6.4.........9.56...3..7.8......89...89......."
            db  "82..5..7.........3....3.9...1.6.7...2.5.......4..........7....56..1..7.24..583..."
            db  ".8319...4..2....1...4.7.3.9...2.4.8.......1..9.5......5..7.......94...2....3...7."
            db  "....9..........814.3875....4..6......5.....3....4....2..31..258..2.7..91.....6..."
            db  ".23.9.......8.6...9.......1.7..238.4...4...1..4.9....3...142.7...6........76...8."
            db  "32....7......751..6..3.9.......5..9.57.....4.9..1.3..8...7...........83..4.98...5"
            db  ".15......4....8..7...63.8.....9..6....8.....3.....5...5...291.8.86..4.....7...2.5"
            db  "4....169.5.....7...8..........3.61..1....4.2.8.95...4..4..7...99......5....1....."
            db  "...49...57.........52...14...93....2.....4.....16.5........7..8...5..2.6.8..43.7."
            db  ".....2....3....59..768...2........6.....7.1...946.1...4...5.....5..8...69.3.2...8"
            db  ".53.4.....68...7..74..6.2...3......5....9.16....4.5.....63...........8....9..26.."
            db  ".6...........74..35...6..1..1......67....2..4.86...7.9..932...5.....5...1.2....3."
            db  "9.7..15.8.3..261..8.....3..1.........53.......8974............94.25...3.....6..5."
            db  "....82.....6...7..2....14....5.1....72...68..9..3.........9..486...3...9....68.25"
            db  ".4.8....6........97..3..1..2........8.5......9...7...3....2.6.4..6.9.......5.782."
            db  "..8....7..6.........51.8..917.5..2..2...9..8..3...64.......3.4...27...1...1......"
            db  "....8.....1....96..97..14...5.6...2..4.1....59.1.........2...3.....9.6....3.5.1.."
            db  ".7...46....6.2...3.3...5..4.9.......1.3.67..56..........751.........8....48..3.2."
            db  "2....4......7......64...2........7...9.5..46.4..267..8.......3.329...1...51.8...2"
            db  ".1..4..8.....5....4.28....1.7.....2..89...4.......7...3..79....5..1..9.2.6...4.73"
            db  ".7...5..44..827.........3......7...6.6...87.3...9..4.....1.2....2.3.69.89.....1.."
            db  ".41.....9...3...7.3.........2..6.9..4.....5.1....186...5.....6...6759.8....8....."
            db  "..46......8.52...6.3...1.2....4...688....3.......1..5.....7...15.9..4...4......39"
            db  ".9.4...2....7...3.2.3.6.9....9.2..7.8.2.5.........7..4.2..3......5.46........8..6"
            db  "4..78...9..5..9..3..1..2...6.857....9...3..2..5........4.6..........8.75.6..9..8."
            db  "...6.......5.139......981437....18...93.4.............3.6.5...11..86.4........6.."
            db  "......7..43..16...8...9....38.....2...........6.1.5.4...6.381...2......7.9..7...5"
            db  "56.....9.3..1....7.....8.3..8..5....4.....6.3...4.7.811.....4..2.4.......7..2.5.."
            db  "8......93...3..5.1.........43..9.2..59.6.4.3.6.1.....8...7............5..579.16.."
            db  "5..14....32.6....17.1.....6.4..6.3..2....4..7..7..8.2....8..93......3.....2...8.."
            db  ".1..8....9....14..8..3....15....9.1..9...67...7..3.5.943.6...7....2....8...1....4"
            db  "7.....5..6.2.1.7...912...8.43.......82..3..5......6........7..3..73..9.6....8...."
            db  ".2....4...5.3...16....69...4..836..7.......3..61.....9...6.2.8.......3....8.7..91"
            db  "...3...973....9..1.64.....34.....1....8.4..59.....72..6.9.2....5.19......2.7....."
            db  "3..84..6..2.....3....97...8....9...3......82...36.1..4...3....2..6..7...49...6.1."
            db  "..318.5.4...29....62.3............1989.........2.......16.3.78.7...45.9.........3"
            db  "9..7.82....4.63....5....93..3.1.............7.....68.......1.....6...371..842...."
            db  "6578.9.2.9...6............1..8...4.35.....7.....7..1...4..3........9.....3..25..9"
            db  ".....351.....48....5....4.88...1..3.....8.6....4.37.8.56...19...1...6..........7."
            db  "7.2..4.8........23..59.....9.....3....7.....118....64.....1......4.2..9..7....81."
            db  ".6......1.5...7......8.....9...13.6......42..14...25.9.1.....3...63....4..85..62."
            db  "4..5..7...91.2...8..8.1.9.........6.75...42........81.....73....8....1.........5."
            db  ".648.....3....1..4..8..5.7.9..........7.14.3..2.75......6..28..8.3....57...3....."
            db  ".2....6.3.7.9.4.5...5....78.6.5...3..........93..2.18.8..7.9.......4......7..3..."
            db  "...7.34...341....6..6...8.....4...2....85........795..5......1.9.8..1......6..27."
            db  "..7...4.953.1.....984.....1....5....4..9......1.6..8..35...42.......6..8....7..9."
            db  "3..8..1.91.....5..2..95....5..38..2..98.65..4................4.......6.1.3.4.7.8."
            db  "6.....1....4.38.6....7.94.......4...84....7.6..1....8....8...71.7..5....9..4.15.3"
            db  "8..9....7..2.3.....71....3..5.........9.8...1.64...97.3....75......9.........16.."
            db  "4..85....2.64.....3...1.6............725....46..9..........1..6..9.....2..527..19"
            db  "47..9......638....31...4....6.4.......7.......5...1.9.....1....8.15.2..6......7.3"
            db  "56...97..2.........897..6.......1...8...32..5........7.2..84......1..38.6.....9.2"
            db  "....8...7......2...6..1.384....3....1.2..4....89....6..75.....83......5.....79..6"
            db  "7.....3.2.54.1....2.9..8...6...3.75.......4.35....6...1..7........8..29.........8"
            db  "....3486.1.7.....4.4......53...4..8.5...1...2.1..2.4.66..8......3...6......29...8"
            db  "....63...8..2..5.394..5....5......9......7.14.6..1....7.2.......9.....61.1..2.7.."
            db  "...3..1......5....9.8.41.....1...7.8.....925....6....3..759..4....4...268.3......"
            db  "...9.....41...3...8......6.9.7.3.2......9.4.8.....8...3..4...565.2..7...1.......9"
            db  ".7....5...1.5.4.........6.1..4.7.8.....4.69..38......52....3.6....7......53.2.4.."
            db  "..4....256....3.8......5....984.....5..2.......1.7..3..7....9..91...82......543.."
            db  ".5....69...9....4.8..7...........4..12....3..7385.6...9..35....2..8..5....1..27.."
            db  "...2..8...5....1.7..6..95......1.6...713........85....1.9...72.5...2.4.8.38......"
            db  "...1.3...9...4..155.......2.4.......17.....5..2..18.64..4.3......1.2.....9....67."
            db  ".6...5..7.3...9.2....4......8....3....1..2..669.8.31....41..5...5.9.8....7......3"
            db  ".39......4..8..69......23....62.....5.....17..1..7..86......2..24.1....78.7....3."
            db  "15..3..8..3...1.674.8...........7.16.....94.....2.....2..18.9..........17........"
            db  ".......7..4.2..9.1..5..34.....6.7.1227......9.36..........3...4...9.8.2...3.4.1.7"
            db  ".6..3..75..7......2..6........3...14743.8.9........2...5...61.2.18.....9........."
            db  "...2......4..9.68..8..1....72.........1..3...8..1....5....465.32..3.5...36......7"
            db  ".7..85....5.2.........1.8..5..67..28......15.2......3..29.5..........4..8.34...6."
DataMedium  db  "....8.1.5...4...6....5....9........4....2439.13...9.7...2......7.51....88..93..5."
            db  "..23.7.95........1.......6.1794.2...5.............97.8.2..43.....1.6.9..4...9...7"
            db  ".6.....3.....8..15..3..5.98.89..4..........7...29..4.6.9..4....1....3........6.8."
            db  ".6..3..1.8...6......1..2...2459.7..3.3.4...9....6.......6...1.5.5....74....7....."
            db  ".8....6.3.5..........9.37...2..54....1.2.6..84..1...3.7......14...5.......2..8..6"
            db  "...6978.5...........7.4....26..7..........2.44..5..63.....6..91..895..4..43......"
            db  ".......6.1...4..9...2..6.7..812....4..48...5.3....58.9.3.19....2.73.4.....8......"
            db  "3..1....6...3...2..726...9..6..3..8....7.1.6...9.8..12.......7.....4....241......"
            db  "53..8..2...1..7..6.4...9.5......5.3..2...14..3.........9.52...1.57............9.."
            db  "....319....7......91..5......3..8.7969132..5......5.......43...8.....2.3...9..16."
            db  "5.2.3...173.....48....7......5..1..9.9...7........56.33..9..56..2.8.3............"
            db  "...6.....38..2...4..9......2...46..7.....5.2...4.3...9........3...48..1.6.19..5.."
            db  "2..1........7...2....3...65..7...8...59..23.4..........4...7.....5.69...92...8..3"
            db  "54......93..6.8.......3.....5.2...7.7..56.94....8................1.5.3..9.2.7.1.."
            db  "..25.........7.9..3......8........7879.8.1..4..34...2.1.5...4.62....9.....41....."
            db  "...785...7.....9.23.......41.68....9.8.......2.76.4........2......9....641.....5."
            db  "..16.49.......14....2..7..132.........5..9....9.1..26.......64...498....9.......3"
            db  "3......7..9.164...4.......663.....89.24.5.......73.......9..168...8....5.1.4....."
            db  "..6.....71..24..69.8..........9.31....16..9..2...57.4.3......15..5.6...4.2....8.."
            db  "..1...6.......18.3...3...5.9..125.6..62....9..1.........4..7.2...92.35...8...49.."
            db  "......16...196....4.....7.35946......3.......8.6..5..7....1..5...3..4....19.....8"
            db  ".7..31.82............82......9.4..3875....9...46.875....1..2.4.........5.6..7...."
            db  "..4..5....92..1.65..793......95...3........1..1.....27..5.2....2....38......6.4.."
            db  "59...4..77...3......8..1....7.6.5...84...3.......2.381........6...2..5....6...9.3"
            db  "..5.3...6...5..2.13....2...............35.1..1..6..4.227.....6..4......8.1..7.9.4"
            db  "......2..3...916.8..43.....7...1...2.52...8.....5.6..9.1.963.7.6....7............"
            db  ".91..37....76...2......9.................2.36....3621.5...71...2..8...6..3......."
            db  "7.6.4.2...5.....1..1..9...6....2..8..3.1...7......45..8....37..1936.....6....2..."
            db  "2..3....7..6....9......5..2.......38...18..5.4.5..9...7..6...23......9853.9......"
            db  "...76.5..3...2.....9.....2.......91....4......1....6327..3.......8..4.9.6...9.18."
            db  "7.........1.....898..4......7..3......3..9.6..9.86.75...6....1....71.2.......25.4"
            db  ".2..75........137.......5...96..7....1...4783........26...5..1.4.......83....6..."
            db  "2..7.6..5......6.9.5.8.....1639.....9........7.86...1.4...5....67..2......2...8.."
            db  "4.3.7..9...7.6....8.....5.....3879..2....5.7......9.....1.9..363....2.4..8......."
            db  "1.7.623.4..2.7...........8..5...847..9.73..1......9....2.....3.4.1.8......8..3..."
            db  ".....9....3.4...6..5..7...4...6.......73.4..14.2.5.7..8......25..67..3..3......9."
            db  "...8...1.1...4..63.....184.2........43.9.........2.4....5..6...84..1...2..2.7.195"
            db  ".....8.6...3....27.495..8...6..5..1....1..7.8....8....4....2...1..6.....9...7.3.2"
            db  "..35..9..6....1..8..14.7.6.......21.1...9...32.7....8.74......6.3..46........2..."
            db  "4...........596........3.2.....6.85....9.2..7........2.3..8.4....9..5..18..4..7.9"
            db  ".3.9...7..9.6.....5...8...4.2...........5..1.67...29.....5..8..3.2.....9..81.6..5"
            db  ".......65.....4..9..98.24...3..5..1.9.....6..8..2.6...6.4............1....8.179.3"
            db  "..8.....3....8.291.....4......9...54...3.5.....91..8....7....3..6..5.....84.1...7"
            db  "..9.....721....9..8..3.....3.5..7..1.8.6.13...62.3.......496......2....47.....5.."
            db  "..548.....1...9.....8.2...4...2..56.16......7..4...9...7.1......52.6....3..7...5."
            db  "..5....89.....6..713.8......7.4.5..3.821...7...6..8.......7..3......169..2.6...4."
            db  "..7...41.9..6.1...5...4....3...9..2.4.2.......1.5....8.....4....3...265....16.384"
            db  "2....86....4.3.....9..4...73..4...6.....8...1..2...7.9....94......7..51..6...3.8."
            db  ".3.....5.1.......2..9...3..2..4...9....1.6.....398.6.1...5..7..6......4.41.273..."
            db  ".....5..125...1.....678..4........5.4....2.9..73..............8.9..2.514...64...3"
            db  ".2.....5.7...1..49.5..74.....4.........9.713......2..8..5..37...1.5.....93..6...."
            db  "3.124.6....7.....4.6...3....5.....2.6.8.7..5......8..3....2..9..9....36.....9.2.."
            db  "..4937.8.....2....5..4....76...5...22......5..8.7....1..1.7......3...1...2.8.1.4."
            db  "...4.2.....9.......7.8..5.6........1.32..1.9..46.3......574...8..19....5........."
            db  "..1...........6.7596...5.....4.1.2.......4..6.5..6...9...28...3.......6.1.9....27"
            db  "..1...2...437.....6.2....49.....5........1975.6......1...4..1..........859.8..72."
            db  "5......871..7...95...52....7...9.....8...716.364.....2.....43..8..1..7...4......6"
            db  "..21......31...25.94...23...6..985...27.....9...7...6....4.37...5..2...3.......8."
            db  "9.....6......5...1...98.4.2..6.........7...3...82..5..2....68..8...7.15..75...9.."
            db  ".6.3....4.......5...4..2.1...89...4.9....85.7...1.7.3.....6.9..3....1.8...97..1.."
            db  "..762....5.8.....4....9..6.4......838..26.....1..........1........47.2.91...56..."
            db  "..2.....36...4.......95..87...1...3.864.....9.....9...4...8...1.8...37....37...2."
            db  ".53....19...9......6....753.1..98..67..26..8.4..5.............8.......2.93...7..."
            db  "..35......2..1.....5.24........6..319.......6...9.4.7.7.....3...1...67...9.3.2.5."
            db  "...427.35.............837.9.1..4....6..1..4..5.....1....86...73.4..3..8...5.....1"
            db  ".53.....4..8.926..6...........9.....7.952........16.3.....5..4.92..7.5...3....12."
            db  ".....2.18.........51...94......7..63.8...1..7...9....2.9....8...3..56...47.8....."
            db  ".62...3..4...9......3...7..3.6.........821..41..6.....68....41....7..2.9....5...."
            db  "..7...6..2..18........4...9......4..43..2...7.59........2.....538.7.4..2.7..681.."
            db  "..8.54.........5.6.......214.59.72....36..7.........9..2...3..8.9.......7.61...5."
            db  "693...5.......2..3..1.........253........4.97....6.1..7285..........6...5..7...41"
            db  "2..7..9.6..9..8.....5.....4.2....1.......9.7....6..4...4...6.8.6..4.7.2.5.792...."
            db  ".6..97......1.3.2..3..8...9.7...6..4.......5...1759.....9.482.7..7...3...8....4.."
            db  "1....36.845..........2....7.....5..23....1..9.......7.5..97.1..6.8.4......73.8..."
            db  ".542....379............7.49..8..6..12..4..8.......9.6..7.9...........3.....75.28."
            db  "...38....5........9.7.12..3..5...1...8.......6.3..7.......41..6...269.3..4....5.."
            db  ".6....2.875.24........3.......1.4..9...8...1...7.9..54975...........2.3..1.4.9..6"
            db  "...2.....3....9.....9...78.4......5......5....51.74.23.136....22.64..8.7.....86.."
            db  ".3.91...4..5.7........2.......5.7..1....4...5......36.8.4..61...9....8....218.6.."
            db  "..18..9.....9..83.3...1..6...5.........57..921............9.3.7.5...6...4..3.8.2."
            db  "........8.9.....2...261..4..2...9.3...3.647....6..........3..1.....7.9...4.2.8.7."
            db  "6..1..........75......2..86..7...84.3.48......123.........9..3.......1294....5..."
            db  "..6..7.4..5..3.7.2..9...5...9...1........8.56.1..7328...38......7...58.........2."
            db  "......23..3..6....265........93........81.4...4...5..7..4..7.1...1.287.....15..2."
            db  "5...127....76....3.385.........2....4.....1..8.2.4.63..7..9...8........56..4.8..."
            db  "3.........6....8.3.97.82....8..4.....129....6...7...........165..965.7..1.....4.."
            db  "..3..6...9.218.....8672....6.4...9.8.....71.........355.......6....5.2...97...8.."
            db  "3..7.....2...6.7..78...2....35.....9.9..1....8..63.......3..62...1...5.....24.1.7"
            db  ".5...6....74....382...78....3......28...1....5.6.....4......5973..9.......14....."
            db  "2.8......5....4...7...1829...6...41......7..6...6...3...5..17...7.9....491......."
            db  "....3.....2....8..8.1........5....6..9.2.13.....6..91.73...9.4....7.4..1....53..."
            db  ".............312.........798....23.6...7....1..2....4..1758.....596.....2..4.37.."
            db  "..3.4.2.....9.....8..2.6....8.19..........7..5...3..6....4.2175.2..7.3........9.."
            db  "38......7...9.6...67.4..5......1..5..2......9.5.76..8......7.....8....12.9..35..."
            db  "....57.....9...3..4....31.5..2.86.....8...7..5..4......3.2.5.8.7.6....9.....9...."
            db  "6..1.3..7.3.....9...8..51..1.4..6..5.................63..2.4.7...6.3..2.2...178.."
            db  "..5.6....8.....439.....8..2..6..29.39..8..5.7.4..9.......5...212.....3....8.1...."
            db  ".......1...64......57..962.4....7....1528...7..394............8......9.2.6..35..."
            db  ".8.39..1..........4.7.8......3.4...6..2.....7..9...82..3..6..4..18..........15.93"
            db  "..96....81.....7...3.4...2984......1..2.76...9.7..............4..3.28....785....2"
            db  "....2.75....3...91..21.....6......17.93..5.......43....6.8...3..3..7...481......9"
            db  ".8...964.37.....122.....5..7...34.....186.................5...46...2...1..9....7."
            db  "...6..7......31......5...9...61.8...9.7..3...32..9.....9..26..1......9.3.75....2."
            db  "3.54..2..4.......98.9..3.5.....789.6...1..............7..582......6..8.1.6.....72"
            db  ".13..7..28....5....4....9..3.64...7.4......8...293....1...6.5........6......7..4."
            db  "9...258........1...28.4.7.9..7.5...4.9...6...2...195..5.........8....6..4.6....31"
            db  ".3............5.8..563...9....167..44...2..1..7..34...2...4.6...1....2..3....1..9"
            db  "7.....3..........6.8.....5...81...7464..5..2.9..........63.71..1..8.67.9..4..16.."
            db  "........5....43...9..6.....6..72.4....5...9.6..4.....87.3..85...2....6...4..56..3"
            db  ".1.....483.........8..1.5...5.1.8.3.1..3..47.4....2..5...6.5.........8142.......9"
            db  "....7..32.582.....31....6.....6.7........21.9.89..5.2.....6.3.5.9.4.....87......1"
            db  ".54.62.......8.9...17....5.1..........9.27........34.6..3.9.514.4....8....5......"
            db  "..............6.....913.5..4...75.2..86.......7...38.....29....15......8.9.7.8.43"
            db  "3...1.84..25....6.8...........32.9......814...5........4.7......68...7...9...32.6"
            db  "....8..9..6..32.4.3.....8.7...8......8..5......5..1.7....4.6..9.7......5..29..1.."
            db  ".7......88....24.1....6.....6..23.......1.78...9..5...4..6...15.3........8.4....6"
            db  ".......41..8....56.2..3......37..81.6....4...8.91....4..7....8...5.9.4.....4.8..9"
            db  ".43....8......8..7..56.....7...2..1.......9..4...1.3...1.57...23.8...........1..6"
            db  "..6.....5.1.6.79.....24....1..5....3.97...6..2.....7...8...1.67.....8.3.4..3.5..."
            db  "........3..1..7.2..6.9.....4......918.6...2...25......3..8......8..5.3.49..7...1."
            db  ".3.8...25....3.9..297.....41...72...962...7......8....7......16..1...5......5..4."
            db  "..9.....6.4..3...7.23..7..9....2.3.........781.5..6.......49...7......5....3...4."
            db  "....25.484.3.....5.9.....1.9.6.41.8....6.7.2..8.......7.5.....6...476......8....1"
            db  "..8.6..7.7..3..4.2.5.......4..71...6...4..8..98.....1......52....168.....4......3"
            db  "9...4.5.6..8..6......91..........85..6...39.7.85...6.2.....4..8..256...3.......2."
            db  "..47.1..8................6..69..7....1..54.......1.2.7..2...9..6...8.32..8...54.."
            db  ".1..25..4.2.6.8.1........9.....1.9522..9..4.7.........3.2.....9.4..635....7....4."
            db  ".....1....4....5.89.3..2....1..94.26.8......4...1..7..4...7.........6.....5.8..19"
            db  "...3..4..3.8...7....264..5.5..7...4..3716.5..1....9.8.8...9.27......6..........3."
            db  "3...6.71.8..21......2...5..7..9....51.....37..893......2.....6...86.......7......"
            db  "3.5...729..1..3.....9.4.6..78....2......12......5.........5..7.5....1.....3...84."
            db  "83......1.......8..914....2..95...7...2..71.....3.2.4..56..87....8..4...42....89."
            db  "..6.83....1..64.3....1.......9.....523..15.....5...7.9.8...2......7..2....4..1.9."
            db  "....5.4........6..7.1.....3...6....2.37.....18....5.9..9..........93.5..5..7.2.8."
            db  "..71.......5.2.....3...4.........8..2...3.6.4..34812.......6.7.....59..896.2....."
            db  "...2.1..379........51...8.4.....65...163.7.......2....8....94....7.8.91..4......6"
            db  "....86.2.8...3.....74....5.......9....35..4.1.2.3.7......1....5....5....2.7....6."
            db  "7.6....59....7.864..1..5.7.....2..3...8.4..........6..5..1.2....4....9..2........"
            db  "..1............2....6.58.94.8.7....1...8.9.....7..3....9...43.8........9..36.7.5."
            db  "..6....4.9.2...3......39.2...8.9........6..15.....3.8441.8.......3...5...8...7..."
            db  ".1.4.........7........9...4...9....54...25..672..3......9...3.....3...4.2.7..6.1."
            db  "67.39..4..5.8.7.......2......1..6.......7......2...63..2.4..8....3..9.7........25"
            db  "...6.71..6....9..82.78...39......3.18.1.2......6.7........6....92.5....7..3.....2"
            db  "....7....5....8...8.3........2.1.9.5...6....767..491..13...5.........5.6....97.8."
            db  "..41.6..56....5.........8..5..4...2..1...3...8..9...1...5.6....2.......39873..4.."
            db  "5....3.74..8..6...9...5........3..5....2..9..4.6.....7...6.5...........132..1.7.8"
            db  "..98...2.51..........9.51...5.67.4.9..6......9.....7....34.....6.813.5.4....9.6.."
            db  "...8..2.1.98..........62.3..27..46.9..9...12....7.....8..9......32...7...1.....4."
            db  "...98..13....3.....695..7....1.9.8.59.......1.......2.4...51..7.578...6..2...7..."
            db  ".8.7.14..2975............8..25.....6.......43....9.7.5..36.5....5.3.....8...4...."
            db  "....92.1..3.76.......4.53....6.8...4.......5.2.4...73.5..1...7.37.....4..1....2.."
            db  ".....2469.........37...6........91....714...6..2...87.....1......4.....36..2...8."
            db  "......18......9....24.37...46.........3.92..4...1....3..2...87.67........4.2....5"
            db  "...4.73.2..5....4.........8.........12697...45.726....8...4.........8.6.2.97..1.."
            db  ".6..45.....72..3.......76.59.1..28.62.8....3.65.7.......21...988..9.4............"
            db  ".....5..3.3.6...9..6......8..1..2..7...4..6.9....5..4.....9....52...14..1....8..2"
            db  "........5..2.8....78..3.1..39.8..2..4..............89.9..65...1..7..4..26.19..4.."
            db  "3..1..8....6....97......12..4.........842...629..16..3.3.2.5...9........4...87..."
            db  "4....37...29.6.....6...9..............3..7.1...815.6.........82..72...93.4......."
            db  ".13.7...5...184...6.....2.....4...67..5..1..9.3.........4..3....2..5..8...76...5."
            db  ".4..7.1...8.6........9....8......437.7...2...5...8.9...3..9.7...6.....4.2.7.43..5"
            db  ".7...8.....86.........9.3...6...38.2..7...5...2.1...9.....5...4.96.1.2......8..69"
            db  "847...3.6......84.....5...1....2...4.5......878.4.....37.6......9.7.3.12..2......"
            db  "48..51........6...5..487...........11.....649..5..........3.2..7....95....25....6"
            db  "..7.46..9.....72.1.281.....5........28.....5.......8933.96....2.7.......4....97.."
            db  ".1..25......8...1.......7......5.....869..5.147...1..8...592..6.4.....9...8.7..3."
            db  ".6.2....1..8..6..33.5....7.5..8..1.77......56.....2........3..21.....4....6...7.."
            db  "9.7..1......49.2....3.....1.4....19..8.2.....6.9...3.7.....68..8..35...6....8...."
            db  ".9....3.8.7..5.......6.7..9.59..2........4.9...43.6..27.14.....68..7.2.4........."
            db  ".5...6.293.8...6............23...19..6......89.....23.....8....2.7.91.......4.3.5"
            db  "..8....7.7..8..3..32.....4.16.32.......91.83...............74.3..6..5.8.54....1.."
            db  ".79.......2.61........3.4..2.7...3..3...5.2.9..8..7....6.1........58...4.1.....8."
            db  "....95..4.14..8..7......2...21....6.....3...8.9..4.....59.7....3......9.7...8.6.."
            db  "..1..2.........17.2.7.6.89..7.4...8.348.59....9.........3....1.6...1..599...3...."
            db  "..62..3.....6.......8..75.49....5.2....8.....41......6....7..5.8.....4.9.9.5....8"
            db  "..25..73.5............7...4.....18....5..76....64..59.....19.6.1..7.....98......."
            db  ".1.58.6...29....4..4.6.....7.3...1......6.45...........38.1..6.4.............732."
            db  "91......6...2....7.....13...51..4......8...59.......6.58.96...2.3.1.76......5...."
            db  ".7........5.279..14..1.6...8...9.35.7........3..4.86.....5.....9...8..14.43...8.."
            db  ".17....429..8.7...4.......5............68...3...59.6..13...8....69.....1.4.9.5..."
            db  "1......4.....9.....5...71.6..9..5..36..34..25.....6...5.8.2.......9.......2..46.8"
            db  "..2....9..593.....7..4..2...8.....6...5....42....9..35....34...5....8.73..126...."
            db  "..5..8....6.5.1...8......47....2.9.8..3..6.1..........7.........8.174...5......83"
            db  "........5.5..2.4...4.9.7..3.3.7............1.6....4.58.8........94..12.75...93..."
            db  "7..8.....3.4..5.....5....78....6.3.2...39...7..85..........6......1896..4.....9.."
            db  "....5..6.73..8..9.6...2...4...7..9.5..8.....7.1...3.......3.2.1....4..8...62..5.."
            db  ".4....6...7.8....4......5.98....2.15.56.....21.2..7.9....73.9......41......5...8."
            db  "..786.3...6.2.....3....1...89......1....5.8.....74..2.....2...9......14...4..5..."
            db  ".....6.....7.....4.46.8..7..95.7..12...9....7...........14.79.83...9......812..6."
            db  "8..4...1.....7.....12....8..56..8.....7.....8..1.5..495.8..7..16.......4......93."
            db  "......4.9.9..25..641.....7....5....1.8....3...2.98...48...1.9..7....2.....5.4...."
            db  ".1...324....4.9..38..7.......3.5.....2..8..6..4..3...1.67....5.........4......12."
            db  ".57.8......3...6..8...7.4....5....8.2...........4..73.41.9.7.2.....26....9.8....1"
            db  ".....2.........64...38.....4...9.8.7..51...9....47.1..7.4..59..2..6..45..5..1...3"
            db  "2.5.6.........4.5...1.2...8......839.6.9......4.8....1.8...9.....6..3.....7...1.4"
            db  "....7...6.27.3....6..21.......4..1........2.38.5....6.....9.3.81.......543.6....."
            db  ".....62..5...817...96........452.......97.8.6..9.........8.....3.8.42.51....5...."
            db  ".....268.1...9327...4.1............87.9......81..4..6......7.........5.694...8..."
            db  "......8...6..9....28..51..3..64...3.........5.9.5..7.1..7.34..2..9....1..1......8"
            db  ".7.45......63..2.98...9.5................415.2...7.86..1.2.3...7..9....6.3.7....."
            db  ".........9..4.13....58....2536.8.4.1......2..4.7....65...3.6...1...7.9.......9..3"
            db  "95....4.......7...6...2......4...8.5...874.2......6.....63.9..2..31...46......91."
            db  "....4.8..8....5......68.319..75..6.....43..82.3.2..4....5......19.....3.2....6..."
            db  ".61...5.......8.3.7.....986.3.......5.73.........9.....8...2.4.....5.2...4.6...93"
            db  "....6..132.........5.8......8..397...6........3.....29.1..7...5..51..3.4.943....8"
            db  "...5183.............5...76.3...2...474.6.5.1.1...94.....9....8.......4.22..8.7..."
            db  "5.9....1....48.9.............15.7...94.....2..56...1.....6..2..4..79..5.6.7.2...."
            db  ".5...6.....1...4.73........6.............8.9...45...2....26...4.47...8.6...7..5.."
            db  ".162....8..26...3....85.....6..18.........7.6.71..6..3.......548.......2.....91.."
            db  "..8..62...7......3.6....758....2....1...5..9..9.....41..68.....72..65...3..1.7..."
            db  "1.5.4....89...71.4...........4....2.6....3...9....1678....3..5....6.9....1.8....7"
            db  "..83.7..13..6.12.4.5........3..85....4.........7..4.......7.6..1..2.6..8.......39"
            db  "9....6..43.2..987......82..1.......2..84..59.......7...9..21....3........5..87.2."
            db  "..2...1..3.....6.75...98...7..81...6....3.5......29..1..1.....8...3.......8.6..4."
            db  "8........9..17.4.......382..1.6..5..7......3.23.4....8.7...1.5....9.........5...."
            db  "..2....54....6..8..6...7.2..7.3.8..912.6.....3...2....4.1........3...7.......5..6"
            db  ".............3.6.......5.2.......258..6.1...7.9...8..383.96....9...47.8.1.28....."
            db  "..65..3.9......5.187.......4372.........8.1.2.......4...3..7.5..6.........2...4.6"
            db  ".3....41.9......7.7.8......6....39........18.2....8.......4...9.4.3195...7...6..."
            db  ".5...139.7..6......2.8.....1.....2.6......7......2...5..9.73....4..1..5.....5.8.."
            db  "28....4..5..9...3.4..1.........37..8.......918..........436.....9.7..3.6.6...1..."
            db  ".5.3...942.....1.......82....15.......6..4.7......64.2.....3..5.7.14.63...5......"
            db  "..3.26..4.25.......8.97...32....4....5.....6...7...2......4.5...6.2..78.7.96....."
            db  "8....39..7.1....8..241....5...2.7...3....5......8..37..4.....5.1..3......7.....21"
            db  "4.........2..5..97...1...6..4.........69..7..9..6.32..........8..9.2......1..863."
            db  "........85..2..1..3485.....29..3......7....8....4....6..98..........1.....59.642."
            db  "2....6...1....274...8.7.2..4.6.38....13.97....8.................5.1...326.....415"
            db  "5.9.4.786.76......1.............7.....4...8..21..6.53.6.........8.3...2......2451"
            db  "....5......9.32......8.6..4.2........7...85...3..9...11........8..2...1....4.73.6"
            db  "..1...2....97.3.....7.82.64.....56......1.7..5..347...9..........4..932.2......1."
            db  "....68.....9.1....4.6...1..7.....526.3...78.....2......9.3...5.....9......845...1"
            db  ".....385..2......6.9.68...3....14...1..9....2......9.78........4....7....3...6.75"
            db  "...3.89.....26..5..4.....7.....24.....8.1...6.129..3.8...5..6........7.9.29......"
            db  "9....7....53..8....241.......1..6....8.9...7......192....5....63..6....4...2...9."
            db  "..2....8.68....514..1.....9..3..6.9...912...62.....4...5.4.......8.7....3.....6.."
            db  ".....5..8.89.16.7..5..7.1......275..8...9...2.......1....2.1..92.....7..9...4...1"
            db  "5.8.4...2..4...7......1....6........29..54.......2..38.....78.5.......27..268.3.."
            db  "1.8.429....31.9.47.9..............64..4..5...98.......3.6.8.....1..5......5...6.2"
            db  "4..87..26.......7.....41.98..36...17.....3..9.69....83....86...6....5.4..2......."
            db  "2.1...36......5.2....8....78.....1...42....5...94.8.7.....6.9..4..3........2....3"
            db  "35..............47.81.9....6..8..7....53..4.6..............6.9...41..6....9..71.5"
            db  "...98132..58..69.....2......1........8......7.76.3.5..3.487.......5....3....2...."
            db  ".2.5.81......436.........9.918...5...7..52.84.............1...7..53.....6....4..1"
            db  ".7...63.2..4....9....8...6...3..1.............5.9...142..6..5..8..4...71.6..98..."
            db  ".956.3..........51...8....4.7........1......54..2.7...9.....6......8.5427.......8"
            db  "..2.3..7.1.67...9.3..41..5..1..9..86...5.32......4........8...4...3.58....1.7...."
            db  "....9.....68.7.91..2....46...9..1.2....3..1.528........7...2......84.....15.67.4."
            db  "43...57....7.....9......1..8..6.74.......921....3.8..5...7......4......2659...8.."
            db  ".2..........4...29..9.7.1...8.2...6.....94........68.27....8.14.36.......4.6..53."
            db  "...2.5...8.6........9...38..64.........79...31..5.8.9..8.....24.....17...1..7...8"
            db  "..6....2...5.2.4...39.75.6...7.1....4..3......9...8.7.8...........5.9..6........4"
            db  "5........8..45..2....3.74.97.5..9...2.....31...3...2...47...5......1.8.....7.3.4."
            db  "..1..9.6...9..638.........2..2..4......91.5...4....7..7..5...4....6.8...6....3..5"
            db  "........31.6.3......3598......61.3.2.9.4..1......2.7...6.2.........456...54...2.."
            db  "2.......959...3.....8...361.29......8..64......6.9.5.......91.3.3.........57..8.."
            db  "....32...2.4....9..1....24...3.9.......6.7..9..7.1..68.5....4...4...9...8.2..6..5"
            db  "74..3.8.5...5.....3.1...46..3....1.2...1.....9..47.3...2.756............5...89..."
            db  ".1...3.6.5..6...........7...7..3...48..5...7...98...2......4..32.8..1..6.6....9.."
            db  "..7.....1.3.2..5..1....7.964...6.........4...2....3..9.4.3....23..9...84.8..5...7"
            db  "........33....4..119.3............2.5...6.....74...6......1...8..823..9.2...574.."
            db  "..8...6.9.9...2..72.3.4.......7.6.1.921.................93..8...87....5.54....7.."
            db  "......1..5.3.........87....3..5....6.....4..19456..3..691...58...........5..2...4"
            db  "..9...5......5...3.4...2.81...........2.37.5868.5..9...7........9...8.3.5..71...."
            db  "8......5..6.9.....4....6..2....35....5........7...412...8...71.2..6.1....9..8...6"
            db  ".....8.........97.5.3..2..4......1.92..8....7....93..6..14.95...3.......75.....42"
            db  "..........97..8..6.4...59.2........37..56.....35.9..2..........2.47...3.5...198.4"
            db  "7....1..3..49...6...15.........29...6.5...2.....46..8196..83........4.98.......1."
            db  "............1....4.....47587.38..92.2...1......4.....5.35....9..2..78....1.....6."
            db  "9.....68....213....72......69........51..83.....7...4............69........6371.."
            db  "6.31....8....4......12...37..7...........45.....5.2...1..79....3...8.9..9.63...7."
            db  ".6...12...9.57.8........5.14.......7..5.4.....29.17..48......2....68.3.......2..."
            db  "..1.4..9........1..4..5...2..478.....5.3.....6.7..51....6..78........97..3...96.1"
            db  "74...183...5....7....7.32..9...5.4..........617........9.6.8....3...4.8...1.2...."
            db  "..2.6.......9....75.3....96....3..5...51....9..64...8.....1.4..2.9..6.38.7..2...."
            db  ".......3.....26785..7...9.6......37...9.........4..8.2.6..742..81.3.......5.6...."
            db  ".....9..315..6..8.9..4..1.....3...2...1.9..4.6985......371.........5.........2.5."
            db  "......675.65...1....9.3....4....9...............4875.69.25...8..8...17........2.1"
            db  ".2947....4.1.......7.....3...61.938..8....49....2...6.6........9....2.7...4..8..."
            db  "..62.5..9.1..8........6.38.....49.7..4......59..5.....7.1.5..4.3.2.........8.3.6."
            db  "..85....9....8.57....4.......691.....3...7.6..8....12...91.68.........355........"
            db  ".....9.8..5.3..1.7..67.1....7.....2.9.3.4.......1..5..........4.3..9....2.14...6."
            db  "...1..294.8...7.5..9.........32.1......5...7.4.1.8.......9....2.4.8.....7...5...6"
            db  ".6......8....78.1.1.....9....5.4.....8391...5..15.63..73.....6.....9.7........523"
            db  "6....3.8.458....9..9..5.......7.4..2..1...8..87........6.5...1.2..36.....8....7.."
            db  "...9.3.5......2....7.5..62...8.2....34..1....5....4391..91...3........6...1.....7"
            db  "..1.7......34.....6...2.3.9..2...15..1..97..4.....2....4.965....2......5.8....4.6"
            db  ".36........5.......2.3.6...5.2...1......1..97.6.9.8..2....3..51.5.14.76.3........"
            db  "...4.53..3......25..4.3.9.1......7...1...8.....8749.....9......4.7.5....8..2.3.7."
            db  "64..5...8........4.3....2.6.....93..781..........2....5..8.7.93......7....96.1.4."
            db  ".6.8......3.197..4791...38.1....2.3....93.2.........4.8...........5....2.2.4...9."
            db  "..5....3....9..42..9.8.3.6.3.81......6.24...3.......17..1.69...8.4...1...3.5....."
            db  "..6......4...2.9.......7.65.....9.......3.8.19..18.5..3....54....7..1..6.6.2...8."
            db  "..2.1.........6..1..68.7...5......2..1..32795....9...6.5.9..6......7.34.2....4..9"
            db  ".......6..6.5.8...439.7....5.....9..9.2.6...4......8....4...2.7.7...2.43.....5..."
            db  "..3..1..24...2.....6.........67.......24.387..4.9.5..3.2.5...91.....9..7.51......"
            db  ".....8.7..4..2.1....1.9.4.6...4.........7...889...6..5..2...7.19..8.....3......6."
            db  ".3........78....32..9.7...1....2.9..85...9..3...8...4.5....8.....641..9...2.5.71."
            db  ".7...59...162..........31.....1............4.35..78.9.......5.4.69..7.8....3....."
            db  "46...2...398.........91.8...5.2...7..46...3....2..7.1.....5.78..8.....46..4...1.5"
            db  "....96..5.8..........53...9..9.....72.3....5..4.2..8.3......21.4..3.....7..9....."
            db  "..........8.....5.6.7...3.89..8..4...43..2..6....56..27....869..5...4.......37..."
            db  "...9....31....4.9.2.9.3.....1..6.24..8......6..72.........9.........763..36...8.1"
            db  "..6..9.8.5...8.7..41..7........5..3...17...6....1...971.7...6.5.5.9.....2........"
            db  "8....6.414......9..6...27..............457........19.8.8...9.6..1..68..3.532....."
            db  ".3......15...8...7.1....8.98..167..5.214...9.....9.7..68....5.4.5...4.........1.."
            db  "...4....8..5...61..4.2.6.9.....6.1...8...752..5......68.......2.2..4...3...8.54.."
            db  "........76.492.1...8.....259...83........95...75.6...2...7.6...3.6.9....4..8....."
            db  "....96..8..7.8..542................9.7.8..........5.42.4....5..81.76....6..2..8.."
            db  "....7.86....3.5..91....2...2.5..3..7.7.6..9.1.9........5.......83......6...4.9.5."
            db  "..2.7..4.9.......81.7.86.......1..3..4.9..........7....2....9...1.....56.35...41."
            db  "...14........3.9...9.......3...6..1..85.973..6......2.7....3..2.4......79.34....8"
            db  ".....3.4..9.........6..8.9375....98.6.3.7...44....2.....79..1..............13..26"
            db  "46..5....2...18....3..47....7....59.8......2.3.......1..2.84..3...36..89......6.."
            db  "........8.7...14.3.3...2.......4.8...58...3..9..3..6..4.......25.361.......4.7..."
            db  ".7.69.123....3...5.......7..6.....5..9.214.........3......2.....3.1....9..74...6."
            db  "......2451.4........86.......1.2...7..93............68.....3....5.78...2.....14.6"
            db  "....765..59..81......5....3..8.9..166.7..3......4.....4..6...87..28......89..7..."
            db  "4.....3.......8.7..2......6.....5...85.3.2.4........97.8.9.37..51.76....9..8....2"
            db  "..5.67...8.....7.29...2...41......95....74..3...3..8....6.9.....5..3.....4.....1."
            db  "3..9...6..6...1....8.7...5..2854..7.......2..1.....8.......7...........6..1.62..3"
            db  "5........43.....8......74....6....4..1..85..9......62....9....13..7...6.7..1.29.."
            db  "..59...4..6..3...1....17..8......625...4.6...9...7......7...2.68.....1...1...5..3"
            db  "...742......3...7..8...54..3...2...4915.......4..1.9..6....3..........85.....81.7"
            db  "...7....1....95..726.4......9....8....597...6..8...72.....3..1..1.....3.68..4...."
            db  "..21...4......2.9363.....5..7..64.....5.2.76...8......34...6....8....5.9....81.7."
            db  "..3....8.....8.5..6.5........19...5..2.41...3.3....8.....67..3.86..4...1..2......"
            db  "18.........5..2.13....1..6....8563...42...7............1..4....8..73...15.....8.."
            db  ".....9..517...6..34..3..91....1..84..8.......512.........6.72...57.........2.4..1"
            db  "43..2.....5.....16..6.7.39...2..7...3....21.7.75..4.6.....6..5.5....1.4.....3...."
            db  ".1..4...3..8...95...2.1....2..3..8....1...3.4...2...7...49........43.6.9.9..26..."
            db  "61.37...5..5.6...7..8......5.67.1...........94..6.21..............1.837...1.5...."
            db  ".1.....8.5.....2..4.6.....9.....9.....271....6.1.2..3..2...5..71......98...4....6"
            db  ".2...94.5.79.........712........5.3..14.98.....8..31...9...7...........75...6.8.."
            db  "5....8..4..2.7.6......5......3.158....56...27.....3.4.14..6.5..2..8...7..9......."
            db  "2.8....6....6...43....417...5....9...9..1..2......2..4.1..25.....347....4.5.6...."
            db  "..26.4..........96..3.27...4.6.....9.5......2.7..3......9.58..4.24.1..35.....2..."
            db  "..475.....8.63.9.7.6..2..3...1.4....375.........5...26......81..5.2..7.....3....."
            db  "..3..4.76...1..9..9..3...8..2.51....1......4.3..6.7...2.8....65.1..587..........."
            db  "..9..7........4...87.52...3...1...97....9.5..1...6..4.24....358.1...........8..2."
            db  ".83.5..4..1...2...72.8.....6.....43.....73.8.......952.5.43..2...9..65.......1..."
            db  ".......597....4...4.5..1.3...386..4...14.5..3........8........5.67.3.9..9.....86."
            db  "...5....8...17...........45.29..6...4.8...16..5.2....46..4.39..2....5....3.9...8."
            db  "9..67........3..62.2...5..........96..685.......7.9.4....1....4713.8.....8......."
            db  "6.........98.....575.6..198...5.7..93......27..........8.9..4......4.....2..168.."
            db  "..7..3...5.6..9.1...32...4..2.54...........5.6.......8.5.3....6...8......8...23.4"
            db  "54......89.7....6....15.9........58.....3.....1...5.7447.6.1........9....38.....6"
            db  "5..7..........24.3.......87.....973..6..7.....4.....68.......5.8.71..9.42.45....."
            db  "..2.6.3....6..5..7..72........47..5..9.1..........6.8.4.86.2....7...1.......385.."
            db  ".4.6......9...3..5.72.4..8..5....1....4.5..6.1..3...477..8..6....6.....1.....9.3."
            db  ".713..4.289...2....52.14.....8.9...7..5...8.992...5......9...3.....3.6......5..7."
            db  ".1...2.......37......8..2.5..7.49.81.4..8..5.2..3..6..3...9............6.2..1.8.."
            db  ".41.........8.7...2...153.95.6.3.....2..8.5...9..6.........145.......2.7.67......"
            db  ".....3.291..4.75.......5..8.6..4....84..7...52.....3.7..31....27..........9.....4"
            db  "6...5...81..4..27...4.3.......9.43..79.2....1..6.......1...7.5...5...9..2....1..."
            db  "..7..3.....6.....88..64........8..4.7....59..9.5......2.3...46...8..75.36.....1.."
            db  "6.........9...4.278...7.6...2........1....59394..6...........4.....51..6...4.2..9"
            db  "....6...8...5.961..8..31..5........4..72.....16...5..39.4....5.7.5...3...2.3...9."
            db  ".4....529....7.......258.1.....67.....53..68.....9..5.93......268.....4....1....."
            db  "......8...1.69...4..67.......5.83....2.....19...........9.4.6.35...7..2..8425...."
            db  "......1.9.2...4.....8.65.2......8.4....57.3...6......7..48.9.3.6.1.......8.2..9.1"
            db  "...3....4..1.4..72.....719.83....9...972.6..........6..7...2.8625.....3....9....."
            db  ".....2...1..3....47..1....262......95.9.8.........47...5...7.2..8.5........4..81."
            db  "5......7...92...61..16....4.....9......5..83.3...7...2...86.....1..23...4.8.....7"
            db  ".....7.1.2.1.9................53...84...6.....7342...58.5.....77...4.6..62....9.."
            db  "..4.19..6.......5.......3..1..843.9292...............7.3.7.......61..5..59..6..83"
            db  ".2..3.........26...1.8.7.3..5.6.....9...2...3...18..7.....6.2...81....457...4...."
            db  "..5.1...94.......28.....56....6...4....82..57.9.1..8.....2.....938.....42....6..."
            db  "...9....3...26.9...7......4...6...1.8......37...35......27.1..94.........1.8...7."
            db  "81..4.....6...1..9.....2.1..8.3....1..4.9.7..976...8.....7....6...26..5........3."
            db  "14........9..1.3.......6.219.....4.7..........7...526.....2.74..6..3..1.7...9.8.3"
            db  "....4.2.7.......384.813...6...41.....2......58.39.....6....4....59...........87.3"
            db  ".6....1.3.8...4.9........57.4..253.....9.....721.4......6.......3.5....82.....74."
            db  "...3.......89...637.5..49....1....7..6.2.95.8...........7.....5...8...9...9.61..2"
            db  "....65974..73...5.2................99.6..2.........3.5.5...6....2..9.1......84..6"
            db  ".1.....9..6.9....8..8.7........4..52..45....6..5..3......8.2..97....96..3..15...."
            db  "..5..261...31......7.8..5..........9.....3.8..6.4...21..7.4...3.....8...582....9."
            db  ".5....3.....1.7...9.8.4...6...8.......1..32....6.5..7.867....9..........29.7.1.4."
            db  "37.8....9.....9..1....76........2.4.26......8..73.......4..3...8...9..24.3.54.7.."
            db  "..2.6...8.4......6.....597....4........9.7.3..8.51..945.6.3....8......2.97.6....."
            db  "..86..2.1....7..5....3..8.7.......42.6...1...2.7..5...1....3....7542..1.3......96"
            db  "...5...32.8.4.....2.5.3....35....6.....31.5..8.27...9....9.78...74...........4..6"
            db  ".78....2.1...4.......1..9..9.....4.3.......8....4.3.....3.5...8..1.2.3.52.4.7...1"
            db  ".........9.14.7.5..2..5.9.........2...8...7.9.64.8....872..6....1...9.....52.31.."
            db  "..3..61.......1.94.4.5.9.2.2..4...1.4.8...5....1..2....2.9...7.............1.76.."
            db  "....6..514...58.....3..7......5...8..1....36...7........6...7....98...4...12.4..."
            db  "..5.4..6.8.....5.7.3..8.....13..5..8...4....2......13612.7......4.3.......8....1."
            db  "86.7....9..3...7...9..6.3....85..2...7.1............7..1...2..3.....346...4..58.."
            db  "...1..97...7......5.9.8...4.85.46.......1..67....3......492....1......26.....4.3."
            db  "3.1.8..76......4.3...5.......932...1......9...4.....8...39......56....2....16...7"
            db  "..5..3.91...7...4.7..1...........5......6491...9..136.6.........28..6.7.5.38..1.."
            db  "....8.....3.57.9...1......44...........1...4.58.....3664.9....8...3..2..8...2...."
            db  "...2..5.1.4..3..2..9...5..6.8.35.......1......1..2.79.9..4..1....4....5.6.7.....8"
            db  ".19......648..1..7............23..5.5.....4...2.1..9....3.6...4...5..8..45...8.1."
            db  "...4...9.7...52..8..3.......5..96....4.1..67....5..2...29..8..7...9...5.1.6......"
            db  ".1.7.....3.79....4....6..1.4.82..15......8..79..65............5..3.8.9....4..7..6"
            db  "....8..4..2.9.6..769........4...1...1.6..7.....2.9..56..973........5..3.7.......4"
            db  "...96..2.1687.........8....9....7.85..6...9...31.5......9.2...8...1983....34....2"
            db  "........7.89....3.3.567.9.....3...145....83.......1...6......7....9..4.6..8..3..."
            db  "..91.4.3.1.7......23.5......95.8............7.2..7..4........1..7.9..4.34..3.2..5"
            db  "..6........8.76.4...7154....3....485.....8....14....7.......2.....7..3.97.93...1."
            db  "5.6.9..8..8...352.........11...2....3...5...9.6...8....2....3.4..5..4..6...8....."
            db  "5...6..8..6......44....89.....2.....857.43......6.9.5..1.8.2...2.6...3...3....4.."
            db  "3.....8...2.6.....8..23.14.....9..2.2...64.....5...9.857...12.4...7......1.....3."
            db  ".1...5.....6.9......7.4..137.1.2...8........5.42...6..3............1.9.2.6.7....."
            db  "......2....1.....3..25..687...3..8..7...9.1..3.9..8.75.2......1.....67......37.9."
            db  "92.6..1.55....97..4...5..8...3......14..6........836.....4...3......2...2.1......"
            db  "..7.26.......35.....2....15.......47..9..15...754.9.81..1.....9.86..7.2.7..9....."
            db  "......5...792...36.32.....7....5....3....91..6.578........182.5.....6.........384"
            db  ".....97.2.59...1...7.....368..4........3.5.7.......3..3.2.....5.8.1...4.49..6...."
            db  ".2.......5.9...16...8..397..7.....8...4.6.......85.3.7..1...5.44.5..2.1..9......."
            db  "6..........47.6.3....9.2..4.3.......7.2...15..8.2.......1....98.25..14.....68..2."
            db  "82.9.4.....51..6.....3...8......1.6...2....376.1..7..9279..5....8.24...1........8"
            db  "....2.7..958.....1.3.6.94..39.2...4.....9..3..1..........4...8.8745..........7..."
            db  "28.9..3...3..6........1.2..86...7.9.7.3....2........5......5..7...8..1..3.94.6..."
            db  "..6....9..1.73.86.4.....7...8.4.53..6..2.......18....2......438.4.1..2..........9"
            db  ".7.3.894...............4683........6.9...54..6.5...2.1.278.....4.9..6.1...3..9..."
            db  ".5...2...94..8.....2.4....53...........7..5.8.9.5..46....37..2.....5...1...1..6.7"
            db  "8.3.....6.59...1.....9.7..82.....4...6..12.....8759......193...32....69.........."
            db  "..1..5..46.....2.1.7.4..........69..4372.....9......5..4..8...5....7.46...6....27"
            db  "...31...93.2..9....8......6..3.9....4.1....2....47..3....86..4....73..........5.7"
            db  "...3..7..79.6..........192.6.8......9..........2..5.4.87.4....6.....68....17..5.."
            db  "..5...4....8.7.9..3..2...1.48...9.5......6..8...3......6.42.8...5.8....1.4......."
            db  "37.8..5.2..2.1......8..64......4..2.....57.83.1.6.....9............7...1..39....8"
            db  "..2.9....8.57.6.......2.7.5...4...7.......3.....98.2.44....2...7...3..5..3......9"
            db  "28..9....6..85....9.16.7..5...7.2.1.........9..6.............2..7...9..34.91...8."
            db  "3......6..586.4......7.8..9827...9..4.....5.8...9..7...6.......78..92......17...5"
            db  ".82..5.1..3..91..2.4..7....86....42.........7.....65.....94....7.....26.......1.5"
            db  ".93.8.2..7.8..5...5.....6.4...6.........2..3..6....4.7.3.54.......7....1..2....9."
            db  "7..5...........2......23.8..7.65.42..9.3.....5.4..2.6..8..3.5.7..1...........1..9"
            db  "....3....7.251.4...1...8..5......75....4.61.9..8......25........8.........97.3.4."
            db  "6..5....82.1.9..6....8...2...5..89......2...4..........6.7...9..9....78.47...1..."
            db  "7.........5..3......2491..5..8...79.54...8....7...2..3.8......13..2...4..195...3."
            db  "2..8...14.5...72..1.......9....23......5....383...94...8.7..9..9..65..4.56......."
            db  ".8.....297....5.....9..1..4..1.4....59..68.............7.8..14...4.29..8....5.3.."
            db  "..4.......2563...7.....8.5.13.5....6...3.4..5.........7...86..44..7..281....2...."
            db  "6.8.....2.47......2....16...2..9..13...8.4.9.5........9..4...6...1..97.4....583.."
            db  ".4......626.5.......7.483...1.......4...9316...2..7..9.......9..8.4..75.3...1..4."
            db  "39..2.1.........2.2.5.3................56...117.3...59..2.....78......4.4..8.7..3"
            db  "....86..4.4....6.2.....9..3.9.7.4.....5.2..1.....6....863.4....7...35...5......8."
            db  "........1.853.4..2.4...9.5...7...2.....1.......4..5.......7....7.....63.9.62..4.5"
            db  "3.....4.6..6.2...8......925.8.592....1...............2..17...5...7.36.........1.3"
            db  "39.....5......6...861.....9..3.1.76...........7.435..1...52...3.5.....7.1.4...9.."
            db  ".4....512..32.....9.........3.4...9....7..6...1....824.68..3...27..9..3........61"
            db  "..15........7.18..4.....9..178.4.....2..7..4.5..........981..3........5..8.3....."
            db  "..4.3.1........3..37.4......4.39.8.791..8......5.7...9...8.........2.9..5.27....3"
            db  ".9.2.4...........88.....256....2...74.....53..6...1.8.5.4917....18.5............."
            db  "......2...8...9.....4....6...17.......7.63..89.2.4...1.....6193..9.2.4...7....8.."
            db  ".3......2.......4.6...1.....7.85....1.57..2....6..3.......82.37....7.5..58.9..6.1"
            db  "..36..7.....37541............1....5.6.85.4.9..29.1.....9.4.........96...4..73...8"
            db  ".4.3....1.....58....6.1.5.2.79....366.59.......3.......1..9..65....2.7.4...4....."
            db  ".32..4......3..8....1.7.6...1.....8..5..41..9..4...3.2...9..4.....2.5.7...6......"
            db  "..35.......8..1642.....9..55..........94..2....7...184....6...7....9.43..1..84..."
            db  "...8.5...27..6......6....4.....27.1.....8.93.1.......5.6..3....78..4.1.29....1..."
            db  "9.7.2.......31.....5.....196...8...4...23..8..8.....71..8.............4...4..5963"
            db  "2....19....4.3...2..9..4.......8.14..5...9...9..4.28.6..6..5....4.8...2.7......1."
            db  "...17....4....8.....83...5.2...39.6..1........9....7.29.4.1.....6.5...8.....2..3."
            db  ".........7.8...5......5.8.3.4...6..93..82.....61..5......6...1..8..9.3...1..3.7.5"
            db  "7..8.6.9...4.....6.9.........7...5.242.....68..3.7....2..4..1.....59..7.5.....9.."
            db  "..7..6..3...5....2943..8..5...6.....2...1..5..1....98..5...7...7....4.3983....7.."
            db  "..2..4.....38....6..956.......1..9..4....3.1......9642..5..1.3.91..8.7..........."
            db  "..1.5...6.....247...27...9........2.48.2.6...7...13...1...9.6...5..4.7....4.....5"
            db  "8.9.23.5.15.....9...............7..4.1...27.93..6...1.....59..147........254..37."
            db  "......23....3.4.7.8.6...........2..7.8.4.....34...1.29..85......9.2.81...2..1.74."
            db  "1..3.....7..4.2..6..8......82.....95..3..........9...4.......8.47.8...192..6..7.."
            db  ".......85....32....7.68.....13.....75....86..8..41.5.2......2.69...4......5...3.."
            db  "3.6..9.......7..4....2..16...79.32.4.4......61......3......6...8..75...9.9......."
            db  "98.......3...........53.42.8..6.32....7...8....4...6.9...25..16.9..4.....6......4"
            db  "......1.......49..9.1.2...8.32.....7..8.9.51.7....6..357..3.....8.5........9...6."
            db  "..5.8..24..7.....9..2..58.6...5.2.......7..3..749..5.....6.7..2......6..9.8......"
            db  "..4.8.7...3......81....79.......65.....2....7.....164.....931.26.5..4...........6"
            db  "...2...7..9....5......34.9...5...6.9.1.....5...4...2.3...62...72.195..3.8...7...."
            db  "........1....8.43......7....4.2...1.2.96.5.7...3...5..7.5...29.6....3.....8.296.."
            db  ".....8.....5..43...62....4....6..87...1.4..5....1.7.3.53.....82..4..1...2...9...."
            db  ".681.9....1.8.7..2..4.........2...672..5...48...98.5...5.........6451..........3."
            db  ".6....15.58.7...3...2..6......4..582.......7..9...5.....52..7.96...8..4.1...3...."
            db  ".5.46....12..79....6..3.74......74.......56.2.9.1....8..9......2..61.5..........6"
            db  ".........9.63...144.36....88741.3.....548....12.......5..9...2....8.41...3......6"
            db  "2...3..6....8.47.....5.9....3......76....8.4..57....2.4...8......36....196.74.8.."
            db  ".8.........54..2..7....6..9.23.4....81....3.4..4.1..9....6.74.16..9......5......."
            db  "4......15.8...4...7..1............2.9.24.......5..83.6...83724.2..5...87.....1.5."
            db  "........1.43.....6.5.6.9.8..8.1...355...9.4.........69.....4.1...9.813...7.3....."
            db  "8..1..7....1..6.4.4..8........6.4......7.98.1.89.1..2..9...72....4...6....8....5."
            db  ".6.854.2...........3.1.9..4.4..8513.9...41...3...9........7.4...97..6..........16"
            db  "...82.....8.....1..1...4.9.3.......1...31.9.62...89...6.......9.7....4..4.9...628"
            db  "...9....4.5.......4....1.7...1..6..8.65.7.......5....163..98...7...5..3..2.3...6."
            db  "9.......66...4.3..85.........18....4..7.64.3.5..7..8.....4.21......8.5.....6.1..."
            db  "...2.67.91....4.6.7.......34........8.6..7.4....9..8...3..8.......3.5..1.7.6....."
            db  "....5943.6.7..89......2.8..7......1....51..2..9..4......1..........6.....6.3.4..7"
            db  ".8..2.9......71....5....72...19..5.68....4.......6...7.........3....6.9894..8..3."
            db  ".7....9.8.8...6.3......74..3..4.2.....5.9..7...8..5..26..8.4....4....2..9.....1.."
            db  "......8.....6...196.387.....35..9...1..........871.....1..52...2..........6..45.1"
            db  "....721.....6.....5...4..6.6..7.....1......48...3...12.2..9..8..872..9...1.8....."
            db  "7..1....81..9.4..642.....5.....1..83.6..........2.91..8.9....1...3...2......5...."
            db  "..1......5..473..99..5......1....35..4.....7..7.6.1........56.8...268...3.....1.."
            db  ".7............19276...4..389...83.41......5.......4.8...7...2....157.....2......."
            db  "..4.295..1.....9.....8.........86...76......2..5..1.97.1.........9....16.56.42..."
            db  "....4..........5295......7....4..83...6.93...2....8.5..9.57......36..7..4...2...."
            db  ".7.96...3..38..4..2...3..693..6......1....6....7.....5..1..23........1...4.1..27."
            db  ".......859.2.35...6......2.3...92.5.24......1.5....7.....17.5............9...8.37"
            db  ".....5.89..8.46.5..........1.....84....5.9..6.3..28..1.47.9..........7..89.37.5.."
DataHard    db  "8.......6.7943.1..3....25...1.........4....7...36.9.1...6.....5...2..49....81...."
            db  "398....6.....68.9...7...5..57.4..1....3..9........7.....47..6...6.....5.2..3....1"
            db  "..73..4...3.....5...2..7....8.....3.....61..2.2....58.3.8.16........3.....1.4...6"
            db  ".9......3.3.5.1..97......1.2....5.9..7..6....58.2..47...6.......5..89....1...6..8"
            db  "..5...6......29...31....4...39.47....423...........2.....6.5.....3.8...7658....9."
            db  "...39.5..43...61......879...7.......6.5......32.9...6.9.....4.........51.612..7.."
            db  "..7...6......7..4.13..9...27.....9..3...52...4.8..6...6.9..4.2....2..1...2......8"
            db  "..86..53.....81.2.1.....7.9..5...6......43..234....9.......7..85.2....7..7.1....."
            db  "19.2.......7.1.83...4..8.1....964.........3.7....5.9......8....7.3.....258......6"
            db  "..1.......524.8.96.6..2.8.36.42..........1....8..9...5...3....1.2..56........4.7."
            db  "....3.7.......2..4..9...5...8..9......2.84.3.6....54...2.1....78..5..3...5.92..1."
            db  ".....1.3...2.....7..9.8...5...45.1.26......4......658...73..4...4.2...7.315.....6"
            db  "35...2....98.1....6..3.7...7..92..8.......64.......1..9.4.7.8.......5.1..6..4...."
            db  "49......7....3.4..1....5.....6..2......1...75.8..53.4.32.....9..49...2..6....1..."
            db  "........1...8..5....3.79..85....6...47...3.......57..6...2.1....68.3...9.29....7."
            db  "82....4...3..1.9.8....96.3.25..8......1.62...........9.64........713.6..3......8."
            db  "......5......3..794.1..8...8..5.....94..6..38......7.5.6..7...4.......2.3.814...."
            db  ".......14...38....4.6..7.5.....7.8.1.1.......65........3..2......7..8.9...25.1..."
            db  "....2.1.....3.47.9.....7...36....2.7..2..9.....17....593.......24..6.5..1...4...3"
            db  "...7......37....61...54..2......5....1...69.2..8.7.6..9...1..3.........7.6.3.91.."
            db  "..17.6......18..2..274...........49.........52..6.73.....8...3..3.....1..46...27."
            db  ".1.2.4...8....716.6......5.1..4...3......18.......27.1.7.3..5.9.3.........2..8..."
            db  "..2.......4..2.6.1.316...........8.38..3.4.7..1..89....24...9.89.......6....4...5"
            db  "24.5..6...7..6...4.......9.....4...9.6....4......78.....9.13.2.62.4..817..72....."
            db  ".8..2...479..5..3...4.18......4....1.35...4.9......7.......3...31...2.5.....8...7"
            db  ".6.7.2.5..........1.2.9.......6..1...7.8..53.6.5..39..7....6.23....5..1..9......."
            db  "3...7.691...92.7.....3............7...1.9.2.....5.48..19......8..71..3...35....2."
            db  "6.5..........9.....1.63...8.46...2...7..5...6....7.4.1.....7.....48.2...7.1...52."
            db  "68..1..............14...7.3..8..7..6.7.5.81...9..4....9..6.3..8....529..........1"
            db  ".5.64.3.....7..5.......2..96..2.5..31..9....2..3....84.78...4............3..2...6"
            db  ".3.81.....18.....2.....6...8..93..4.......7......68.....21...965....2..7....931.4"
            db  "....2..5....8..413..8...67..57..4...3....6...46..7.1......6...9.2..4....8..7.2..."
            db  "....8..5.6.4....3.7.......64.......3.2..58......43..8.......2...5.7.6...9..34..7."
            db  "2.1.......9...34....6...9....5..8......75...3......6.45...4.....4...6.8.7..3.2..."
            db  ".47..6.......8.5..5.91.................92.7..21.7...54.....1.3..6.4....81.....6.7"
            db  "...8.3.2.5...6..1.4..1....6..1....7.92......4...9.8..3.4..7...........4.893..2..."
            db  ".3......18.5..7..69...6..3..47..3.5....5......23..9..7.5..8..4....1..7....9....8."
            db  "48.7..13......9.7..9.....85......9..1...7..4....4.25....8.26...9..1....6.64......"
            db  ".5..63.........1..9.61..4..4.578..9..879..........6...2......4..3...591..4......3"
            db  "3......84..45..6...7...42..7...8...99....1..6....72....21.6....5.............87.."
            db  "8....9....968...1..7.51..2.....3..89..1..........94.5...2...8..359.............67"
            db  "546.....9...8............7.....192..21......57...3.......2.1...6.....42...938.5.."
            db  "5....1..22...5..84.8.....6.76.1.....3....5..1....3765...8..9.4..7..2......3..6..."
            db  "1...9.5....84.........7.93.34.6..2...5....7........14...6..84.1..5..2..72.......9"
            db  "...46.25.....5..71.74..9......3.......1...6...95....8....6.........4.8.5...7.8.3."
            db  "7..3.9........6..1..47...8.....7...3.....5......1...468....3.72.9....4..5..62.3.."
            db  ".6...4.....2.1....7.......8.......6.1.5.7.9.....9..1.2......38....1.7.46.4.26...7"
            db  ".7........6.38...1.......356..57..4.1.......2......8..23......8..9..1..7.4..35..."
            db  ".....4..67.861.....3..5........9...2.52..8......7....49...6...1..3..9648...5....."
            db  "..9..6.5..15.........42.....9...4.....2..97..43.7...25.....738......3.46....8...."
            db  "..49.......9.5...663......8.6......9.5.2..7...8.....1.2...46..3.......7....87.2.1"
            db  "6...4..71....5794..27.......78..5..45..1.......1...........28598...9.4....2.....6"
            db  ".....8..51..2..94.......17...8.....3....67....3.9..5........364....2.71.6.4......"
            db  "...4.......9.2.35..5...8.2....7.498.2....9...1.4.......43.9.....8.....6....2....5"
            db  "...4.2.5.2.4..9...6...7.1..57......31.6...9.8..87.........5...2.....7..5....6..3."
            db  "..6.4.1..........3.45..39......6..8..2.51....47.9......1.7..34.8.....6......2...."
            db  "6.4....7....5.6..3....7..2..5.4....7.42..........93.......6.8...23..8.4.8....5.9."
            db  "........6.6..2..1.9..5...2.6.......28.......4...8.17..4....3..8..81......7..6..9."
            db  ".3..79..........4..172....5..5.............3..724.8.9....85...1...74.....4..63..."
            db  "..81....3.4...7...3....8..7.65...........3.......16.4.8..9...61..9...5.2.26.5...."
            db  "..4..19.7..1...35..659.....84...6..2.....8.......5....7..8...2....32...8.....4..."
            db  "..6.9.5.83....1......5.......594.....4..5..62...7.....1.....629.29...4......7...3"
            db  "...6..59..7...23..13...9....2....4.17.....6..39.......2635.........9...6....4...."
            db  "...9..4......3..65..8.2.....2....8..6.7.1.........8..7..52..73.8..5...19.69......"
            db  "4.1..6....7...2.9.......8.578...9.6.....8....6.2.3.9..3...6..1.51....7......2...."
            db  "..8.........52.96..3..6........9.327...7..6...2..1....5.34.8........1.........54."
            db  "27....5......5.41.8.....3.......817.7.9.......4...3.9...5.4.........1....37...8.6"
            db  "..67.....4...5.61.....9..5..93.....7...18...4...2..3...4......8.15....9.7.....2.."
            db  "....2....2..59.3.83........8..2....697.8..4....4.7............9.8.3.517.7...6...3"
            db  "...6..91...8.3.2...7......3...8.......2..6..4..15...3.1..389.......4.6..9..2.5..."
            db  "...5.2....7.....8.3...1....9....3..1....64....8......42...3.7.9.4..7.3....6.....2"
            db  "8...1........4.....615.3..4...1....39..48.6........8.751...67.........2..83...9.."
            db  "..89...3.4.7.6.........8..49..7....6.6....7....2.1.9.861..5...........2..3....4.5"
            db  "4..3......1.2..8.6.8.5....43.2......8....4..........135......2........6....867..1"
            db  "8..1...2..675.8.....9...........2567..........9..5.4..7.4.2.6.8.....1..4.....47.."
            db  "..3..25....8.......5...1..73..7..2.....6..13...6..58....9.4....1.79...5.43...8..."
            db  ".6.9.2...8...4...9.1.35..........645.8...6..1..5..9.3..4.....1....87.....97......"
            db  "...73.....4.....8...8.9.3..68....1....5....34..4..29..1..8......7........36.4..97"
            db  "9.....5.8....1..93.4...7....24....6.3..9....2......8..........6.8..3.....5...64.."
            db  "43.52.1........5..5.8....3.1...8..4...4.....6..5.173.....16.9.....3..46.........8"
            db  "59........6......8.....542....58.17.....6....27...4.6.71.35.....5..48...........1"
            db  "5.6..7...3.....982.........4..8...2....64...3....2.....6....57..9..5.1.8..8.3...."
            db  ".59.14.6.2............6..7...5.........2.58.4.1.....3..3..2..9.....417..8..3....."
            db  "....6..2.92.8..5.6..1.97....5....71.183........73.........7.69..7.....82...9....."
            db  "...92...4..9.5.........46.2....8..6.23.....1.9.7..6.2..1.3...5......53..6.......8"
            db  "8....3.......1.9...5...76.3..5.96.18.....5......1....25.17......9..2....34...1..6"
            db  ".....57245..4...1..28........5.1.2..........5.3....19.1.......6.9..7......6..24.."
            db  ".........8.....64...571..8..4..32...96........5..9.1........396...3.875...7.6...2"
            db  ".15.28........5....4...386..7.68....5..........3..1..9........4...5...924....957."
            db  "5.1...86......7...3..5..97...4.5.63....8.6...8..14.5...6.3..4...........98...5..."
            db  "3......5.....129...2...7...7.1...3.9.3.....644.......886...32.7.....9.1.....6...."
            db  "7.1...5.44......27.52...16.9.......6..6..9.1...526........8...3....27...3.4......"
            db  "6....4....857..2..1......8............4.635..5....8..7...6..3..46..3.......297.5."
            db  "........4.....21.8.7..1.........12....845...3.....3.49..4.8.7.265.........25....."
            db  "5..........2..8..5...1.4.6..........2..63...7.3..7..19.....71....3....8..785....6"
            db  ".....9.83......2..1..76....4..92.6......1...5.1...6...6.....53..3...4.....51..7.."
            db  "8.........32.7.1.96...39.....3....1.....2..8.....517...8.1.3.4......7.6.3.......5"
            db  ".28.....67...5...4...3...7.3..1.4......7..3.9.....8......8.51..8.3......1.9.7.2.8"
            db  "....86.5.76.1.5..........8...9.4...237......4......17.4...3...85........637.29..."
            db  ".....1...69..23..4...6..1.84..5.9.8...........2......9.7...8..6...1.679....7....3"
            db  ".9..2.......6...4.173..........93.58...85.........74..84......2..5..97...1..3.6.."
            db  "......2854...17.............6.32...9..54.8.........6.49.........2...5..8....3.72."
            db  ".8......7.6......9....7.261..2......4.....31...692......3.1......57.4......29.7.5"
            db  "..23..6...1..72..8.38....51.....9.8..9....7.2.......43...64.1.7.....1...4...8...."
            db  ".6..8......4..29....3......2..1.....9....72.......4.1.728...........1.6...635..2."
            db  "4..1..6....192.8....6...3.......1.7.57..3.4......5...82.4....9..1......3......54."
            db  ".....2.16.5.3..4....9...7..1.742.....26...8.......3.....59.........5..7...18..6.."
            db  "....762....82...1.4.......5.51...........1.39...624...6..7..3...3.........7.15..2"
            db  "....762....82...1.4.......5.51...........1.39...624...6..7..3...3.........7.15..2"
            db  "...68...1..8.........2.4.5.79....3..84..12..6...39......6.......8....24...7.4..9."
            db  ".....3187.21..........4.....18..2..5......94.....5...15...9.3..64..3..7.....27..."
            db  ".4..7..29..58.....7....3..4...5..14....2.86..4.....2..13....4.....6....158.....6."
            db  "....4...86..3...9.78...6..........4....2..7..8.9.....6.24.3.8......17..5.7..9...."
            db  "....7.1.9..1....5..5.3..4.73...4...114.7.......9..2..6...5.3...2.3...........92.8"
            db  ".69......1....8..6..31..4..6..7.....9.......8....42.93.....62.....32.5....4.5...."
            db  ".....75...8.65.....67.1..8..5.......29.8.......6...2....19....24..1.56........7.."
            db  "...1.5..7..89.6...7.6............12...1..9...9.4.5.....2...3..64.....5..67...29.1"
            db  ".......2....6871..1......642.5..98..4.......2.91.....5.....2......8..6..3674....."
            db  "....92..753..1..8.......6............6...45..28.6...1...4...975....481..9...7...."
            db  "...9...3.....4...761........6.....8..72..5..93.........25..176.....3921.4...2..9."
            db  "......2..8.3..1..6.6...7.8.58..4......7.52..3...9....4....1..3........281.4....65"
            db  ".896....7.6.......3..2......3....8.9..7.8.26.........4...4657...7...1..69..7..53."
            db  "32.8.715.59.....2...............5..8.7.6....1.8.3.2..6............21..7591....3.."
            db  "9..458.2...2...7..........3...6..89..8...15.......2..6..3.....71.6........429...."
            db  "3..8.........468..1.....4........3..2.6..71.49...23......2..6.8..1..4....7.3..25."
            db  "....2.1.4...8.9.5..2..........6..4...51....8.7..1...6...328.5....9....3..8..6.2.."
            db  ".4.8...7...5..7....13.....21..54....4....65.7...3..6.93..1....8.......9.2.7.6...."
            db  ".....4...2..6..41.9.1.....83.......48.....73..9.7.2.....43...5...85.7...1..8....3"
            db  "..781....9.5...........32.......8.9.....4...68...7...13..2.76.4.8.4..3.7...6...5."
            db  "...94..6..5......7....3.8......63...3..72.1..62..1.4...79.....2......6.4...2...7."
            db  "....9..4.......1..6....4..58.6.5..94..13....6......8...5.6.87..43..........2....1"
            db  "5..7.....7......3.....54..94...29....2....8.....6.7....3...5...9...136.427..9.5.."
            db  "97..3.............1......28.1.3...5......48.97.6..5.4..4.5.6..3....1.5..6...2...1"
            db  ".472.....29....4.......8.5...9...7..3....9.......5.12....7....37..63.5.......4..."
            db  "3..9....1......6...9.2.678..2.8...15......8..46...9.3...93.5........2....7.1....."
            db  ".8....5....4...9..71.....43.2.....6.8...3....9.18.2....3..1..2......3195..56..3.."
            db  "..7....32..831..7..4.....5....2..6....5.8...7.8147........59......8..3...9....2.."
            db  "1.4...5....3..7...7.....8.2...5..4.......89...41.....59..6.2....76.......2.8.97.."
            db  "....46.....39.7.162.......9..9....43..7....2.....5......5.3217..6..79..4.....5..."
            db  ".......69..893..21.....27..4....9..5.1.6..9.3....1.....4......73..1......9.72.35."
            db  ".....8.3..965.......3.9.521..9..52...7..8...9.....1....573.6...9..1....7..1......"
            db  "..2.3....9.4..6...57..........7.9...8..3...1.......2.5....6..2.18.47.6..4....81.."
            db  "..7496...........5.9..8.1..16..3..4.9..264.....5............8.7..6..39..4....1.3."
            db  ".7..3...65...7.8..94...832.....5..49....12.8................6....5..3..289.64...5"
            db  "...8..2...41.2........75..6...1.9...2...6..8359....4.........4..2..8..19.35......"
            db  ".4......3.6..548..7.3.2..1...4...........9....9..87....3.8...7.2..9....1..6...35."
            db  "...7....3.6..15.....7...2...2....5...1..39...69.........98.74.5........7...5...21"
            db  ".7...2..9.....1.6.2......8...6...3...9..43..7.2..15...8.1......9.......5....5.4.2"
            db  "..........7...1..492..6..5.1........5.......7.8.5..149....2...5.9..768..8......3."
            db  ".......3.8.6...7.1.23..94..4..8.....5.9.1.......6....8.5.7..1.....4....6..1..5..."
            db  "..3..7..........625...3..47..8......234....98...2..15.4..8...2...94.5..........1."
            db  ".3.672....1............5.7.2.9...6..1..2...878..3.......7.3...1.......6.5.6.8.92."
            db  ".71..2..........4.8.6....53....9...536...4......7....4...6........5.7..9..7.8.2.."
            db  ".1..643..8...2...65..3.....36.4.......46831..9.........9.....47...7..8.1..8.1.9.."
            db  ".......9.....82..4....1.2.6.....6..8.1..4....2.5.9..7...4.571..3..8..5...2.....8."
            db  ".....51..6........9.2.864...3..9......4.3.9........2....31...7..762.3.1.18..4...2"
            db  "..42.....75.9.....9..35..4......71.4.1....8....9......8...49.3.....2..1...6..84.7"
            db  "..7.8....9...3......2..157.68..7.3.....5......5.....6.5..24...8......9....13..4.."
            db  "........72.5............34....4..5...4...918.597..1.6...41.....7..52.61.....7...."
            db  "3.985.7.2....47............2......9..8.76..2.4...9...31..98......32.......6.....4"
            db  ".......9.7.....3.1..6.....4...4......9..18....2....63...4.5..8.3.96.....2...497.6"
            db  "...5.8...96.......4.1.....2..8.79.4.71....65.......2......14......9628...92..5..."
            db  "........7.8.2...3.2..64.5..93.48.....26..9.....1.......1..2.9..7..3....84.....6.."
            db  "5..9.....4.9...2.8816......3..48.5......63.8......96..1......5..7......2.4.3.7..."
            db  ".4....7.......8...73.5....851.2...6.3.2.......6...943....7.3..5..6...2......1...."
            db  ".......3.4.5...2....862...13......6578.9.........8..7...68.9......3....8....1..42"
            db  "..5....7..1.8...32.3....1..1....5.....2...4.7..82..9..5....6.......34..83.9.1...."
            db  "..4.9....7...6.4....84..2.98..7......2...91..9....85..6....1.3...3...6.41...3...7"
            db  ".2.8.9..583..6................61.....9.....4.46..5...7.4.2...38...4.8....5.....74"
            db  "25.....13..12..8.......3.......5.1..7.4...59...5..8..28....57.....3...26....61..."
            db  "98.......4.....3.6..54..........17.......5.2339......8..194.6.2..92.7......3....."
            db  "6.28...95.....9..6..42.....9...46...38.....1........7....1...2.2.......7..3...4.9"
            db  "..1..2....4...19.5..25...6.3.....64......87......15.3...3...8...2...4...7.6......"
            db  "9...7..5.8....619..4...3....8....41.6...87...792.3........98..63......4........2."
            db  "6..7..4.9...3.6..7..2.8....36..9...1....2.5...9...4.........7.27..1......4.....8."
            db  "....9..8.7.....3.......5.4..3.1..9.5.8...2.7.1..4..6..3.....8.......7..1..86...5."
            db  "...9......7..4.1..9..6....41.....7...85........6....31.2...5..8....92..5..3....47"
            db  "..1....45....7..........863.3.9.....9..8..4.2.65....8..2...5...4....7...5....3..."
            db  "4......35.......2..21.7......6......31......7...43.89.5....8....7..1.25....9.7..."
            db  "...34.6..1....8....6.............823..2.....9...7.5..49...1.5.83....24..6...7...."
            db  "8.........7...6......12..35...5...16..93..4...5.......6..4.1.7......3.485..6..9.."
            db  "..7.3.21.9..2.5.7....61.....8.......4...9..8.6...83.2...5...3....3.62..1.....9..."
            db  "...5.......147..2.3...61..9.7..3.8...8....51.6..8..29.....9..5..4..2.1....2....3."
            db  "3...5...8....89....5............24..9.4.7.6..7..3...9....6.8.4.83.7....26.......7"
            db  "8..364.2...3...8...96.81....2.1...6.4.....5.....59..72..4.37....3...9.......5...."
            db  "8...7.931...2......6...3...........57..45...6..176.2...7........19..2.8.24.89...."
            db  "..317849.5.......6.9.....1......4.3.6.......2.....9..8...5..7..4.8......9.7.3..6."
            db  "...7..6..5...9..1..92...34..5.97..6.7.6.8.9.....6...35.3.1.....92....4.......7..."
            db  "..4.9.2..5..2.1.......8...4..............56872.......5...8..59..7.......129..37.."
            db  "..8......1.4..7..6.7...2514.5.9.8...4....5...3..............6.7....9.2.52.6.5.9.."
            db  "....5...6..2.7.89.........56..4.1........83..5.1.3..4.4........18.2...73....87..4"
            db  "1.8.......6...5..8....93......9.4.57.....2...5......91..2..6.3.4..53...96........"
            db  "..19........46.51.....7..9...65..4..73.1..2..........8..935.6.7.68..4......6....."
            db  "47.....2.......5..6...8...3.....685...6..........47....6.9..3.21...35..832....17."
            db  "...14...2..6.29.........4.5...5..1....2.....467....2.33...7..96..8.......9...1..."
            db  "5..1...94.4..7.6..........7..186..7.26......1..4.....9.83.....6.9..4.3..4..3....."
            db  "....5..36..7.2.41..59.........93.7.............2..715..7.....8....8.....3.451...."
            db  "9.25......7.3...96......24..83.514.2....6......7...5....142........1...7.......8."
            db  "68....254...6....1.9..7.........29....5.9...3...7.8.4....9...8.513.......4.....1."
            db  ".....1...2...5.....63....79...9..7...5...346...4...5.8...4..8....2.7..4...6.....3"
            db  ".5..9....1....6.....68....1.3561.........4.....9.7.4.8.47.6.21......3...3.....7.."
            db  "...85.....9.7...8...79125..1.4.2..7.....8.....3...6..9..6.9...54.1......9......28"
            db  ".6...5...1..2...9......71.598.7.......6.......1..243......3..46....5.72.2.3......"
            db  "....3......465...79...2..1..1..6.3....64.8.........4..2..91.8........2466.5......"
            db  ".......5.62...1..379..2.....3....6..8..5....2...4...3..483..9..5....8..6.1...9..."
            db  "2...7......8.5.9.......1...6..4.72...........9.1...7.8.7.19..6......4.3.53..8.4.."
            db  ".79...2...3........18.4.73..6.....7...28.39.........51.9...85..6...2...9...3....."
            db  "871..5...2..7......9.....18...5.2.9...3...5...2....8.4.8...7..16.42...5.........."
            db  "3...2..4.........6..7....5...16....8.2....6..75.....1...37.........84.2......6.71"
            db  "..41...5..8..5..9...........2......1.5698.42.1....3......5...4397....6..8..2.6..."
            db  "......1...759.3.2..6..4..5........8.8..6.9........2.1693...54.........9214......7"
            db  "...74...9..1...2..3..15..6.....94..5..4..........67..21..9...277.........5.6....."
            db  "...8....2.53..9.7.1..4.7......5..1.7.4.1.3.95...9...3...7....56......7...68.....4"
            db  "....5...6..4......3....7.1...1.75.6....61..748...2.....4....7..2.5.81.....9...8.2"
            db  "....982..2..4..1..69.........2....5...8.5.37..7...2........3798.1.........6..4..."
            db  "6..34.17........3..7....6.45....3.26.6.8..4..3.....59.....7.9.1...........9.52..."
            db  "...178....59.....7.6........2.....5..1.8..46.3...9..2.....571..........6...92...."
            db  ".9.8..7....5..7.126.....9.....9..1...4...1.3...9.......5...8.4.1..7.32..7.24....."
            db  "..8..2....19.....5....34..6.....892...1.....4.4.3.....9......52.7.2......85.1.4.."
            db  ".8.2...5...7.3.2....1..9.......6..1.8.3..7....76......3..9..58......3..61.4......"
            db  ".2...1........3..73.4.9...5.....81..8..3..45..1.2...6..87...2.....95...3........."
            db  "...6......897.........382........67.2.3...1.....9....8.6...4......5....1.528....7"
            db  ".7........3.1..........2.6....8.15...435...16.193........6..8.4.......3.6..29...1"
            db  "4..2....78....3...3....4.2...5.3.98.7.25.....9...6.2.....6........3.51....1..7..9"
            db  "7.8......5...162.......319...9...35.8.7..9.2425.........5.7....6.........8.9...6."
            db  "4.2.3...6.......1.76..8.....7..56.313.....9.524.............8..5..7.3.4......2..."
            db  ".7..264...9..1..8...3.....71.4...6......5..48.5....23.....8.........13.6....62.5."
            db  "..5.3764..3.........68153....4.......8.5..4.77...6......8.9....6..1.8....49...5.2"
            db  "6......3......5...9.3...58....891..7.....26..1...7.8...4...6.71.1.3.......25....."
            db  "9.......6..2...9...45......1.....25.....3..7...974....75...2....3.6...4.....1.6.."
            db  "9.......6..2...9...45......1.....25.....3..7...974....75...2....3.6...4.....1.6.."
            db  "6...47.....8..6..35...1.8....5.8..3.4...........4.12........41..2.......94.725..8"
            db  "8..5.6.7......79......9.....7..8...32.64.....3.....42...5..9.619..63.8.......1..."
            db  ".6...9.1.5....7...9..2.3......6..8...56..8.2..32....9...37.64.....4829.....3..1.."
            db  "......93.4.21.......85....7.......91.2..5.8..6.9..4..5.7.......254.9......64.85.."
            db  ".......6...1..9...2...35..9.8....6......4..32.4....9....37...8.16..84.....9.1...."
            db  "..3.1679...6.....39...3...86.1..4.3..59..2....4......55.29...6.....7.........3..."
            db  "7..32...6........2.9...51.......4.....9.5....276..1..3..5...4..9......1.3.1.8..2."
            db  "..826.....2......4.61..7....7...59.3..3....72.........3....96..9...7..38..45....."
            db  "...6..78...9..86....2...519.....7.6....5........4..19..7..6....8.5....4.9.41..3.."
            db  ".....83.5..9.1.8...2.3.....1...4..3.8.......22......86.1..65.........79......4..."
            db  ".....9.....2.3....49.....8....256..3...8....1.861....45..7...48....25.7.7.....6.."
            db  ".2..........89..5..641.........4...2.....26.993...1.8..5....71....7....3....8...."
            db  "2.63..78......6.9......8.....5.2......79.562...4.....5......9...1.7...6..89.....1"
            db  ".6...83.15..7..9....4...7....73.4...98...................65.81......3....79.8..6."
            db  ".8...59..........297....3.55....1....31....6....86.....1...683...9.4........2..4."
            db  "......45..1.......4.937...63..68.....21.3..7...8.......9.7...18....9....8..5..63."
            db  "....2.547...5....2..91.4..3.1.......4.8....9.5..8...6....3......37..54.9.6.....5."
            db  "3....8..98...3..1......93.4.18.2.............5.....7.3..574......6.82.4.7........"
            db  "5..9.....8..3.56....7..1..5...46...9...........3...178.1..893....8....9...4....26"
            db  "3.........867.....4.......1....58..3.4..1..9....6...2787...52.....92...5.3......."
            db  "2.....7..7.35..1...9...2..3..48.....3....1.2...1.5..6.......416.....9......7..95."
            db  "619...4...2...9.......2..5.........12.35.1...97..4...5..7.85..9...6.........9.34."
            db  "6....78...42.3.......4...2.....5.......8.6.......9...1.2......3..65.....53.12.49."
            db  "....27..5.....9....475.1..9..5.3.24.8..........19........4..1.79.8......6....29.."
            db  "...........7.84..25.9.....7.......2..62..37.8.4.8..5.....31.....8.6.71....3.4.6.."
            db  "..49....1..1..2...6...5.....57....13..........4..38..9.7.4....2.....7....8.2..9.4"
            db  ".8...5..3..1...76..........5..4...9.2...31..8.18.2............5.256.9..19........"
            db  "713.....8...8.......49.6..1.......4..7..1..2....4.29....63...........5..325.9..1."
            db  "..6.2.7..1....7.2..32...9..3.......6..8..92.....7.81..............68.4.9.....4865"
            db  "...24.5..5....8..1..7..1.....8..7....43..59......1...2...1.....67.9.3..4894.....6"
            db  "761........4..89...2........9.....4.4..1..68..3...2.1.6.38....5.....5..3....1..6."
            db  "4.1..2..5.2..6.4.1..8.7.....6.4.....8......5..1..87..43...9.2.....7....3.7.2....."
            db  "2...6....378.........7.8...5...7.2...2.8.3.1...6..1..9..523.48.............5.9..1"
            db  ".4..96.5.......39.8....7..19..4..6...6.5......1.8...231.7...4......3...26.....9.."
            db  "..5......1..2.....9...8..57...4....8.7.8.16........73.6....71......482..73.9..5.."
            db  "....5..1..593..7.........49..12.....9...8..32.8....1...18..4..67..9...8...5...2.."
            db  "..5.....296...3......85..4..3.5..6......26..8..2.17..94.....25.....3.....7......."
            db  "...74........6..18..48.3....7...8.3...2....7.6.9.....5.....6.......3.1..4....125."
            db  ".3....69....1...7....72....2..8...1.....75.........93..72.....3.8.5.....14....5.8"
            db  ".5..3........9..7....1.7.....43....2...8.6.547....2.1...96....15...2......8..1..3"
            db  "5...8...7..8....64.3..2..1.1......2.....1.7.8...263...6..5...3.41.........5..9..."
            db  "..2...8..........557...2....4...95..3.......4.6...7.1.8..24.1...9...64.7...9...8."
            db  "6..3.2.8..4....3...2..6....25...8....1.....9...9.7........4........174.9..6.952.."
            db  "7.1..6.......9..3...3..48..98..5....4....35..........2.......2615..4.......2....7"
            db  ".9...521...5.429..4.1.9...3..9........3..6..574.....8........9.....5..32174......"
            db  ".6.9.1.87..........1...6.......1......9.57...63.8....2..71....4.93.4..18....2..5."
            db  "..8.......4.......2..4..8.65..1...4..9.....373..7....9..9...5..4.1.8...2.7.6.5..."
            db  "....5.63.....1.......8.9.74.4.........29..3...3527..4.........781.......9.6..328."
            db  "...4...36.1..2....8......2.37......1....9..8...6...4..9..3.16..5....8..9..1.49..."
            db  "4..9152...........2.......1.1..67.9.....2..5..5......8.76...3..1..4.9..6.8...2..."
            db  "..6.8..2.4...39..19..5.6...27.....6..1..9....8......97...........5.....4...2.83.."
            db  ".4...........17...2....39.8....9.2.3.......5..3.4...9..1....6..47.9..81...8.3...2"
            db  "...17....7.4.2.......3.67..2.3.....5..7.5...4..5...69.8...3..1.3.26..8........9.6"
            db  ".8.52...4.6...4..9......2...25..1...6..4.29.57...5..8.43.6.....1..3.........4...."
            db  ".8..3...6.3...72.5.....9.1...137.....2..64...5...2......5...1..3......97..9...48."
            db  "92...6.....6.....3......84...15....2.5.1.....38.........2....8...37.2.6.7..6..9.."
            db  "....49.5........9.1...2......931...5..........3..5.7..3..1......2..9..83.4...82.7"
            db  ".6....8.93.9........18.3..4..4.7...25......1.1..24...8............38..7..73.59..."
            db  "......51......3..6.2...57.47...3...1....5....58..64.3.2.8........4......1.39...8."
            db  "...57.....984.......58.34..4.1.8...9....2...33....1...94......5...14..2.....69.3."
            db  "........6...26......793.5..3.......4.61.2..5...5...8.9.7...5..89.3.74..........3."
            db  "...4.6.2....85...3.6.1..4.5.....92.19.......4.43...7.8..5......63..7.1....1..83.."
            db  ".......1.7.......5....1629.......8.7.1.....6.6..498.....5..4...2..86.....9.5.2.8."
            db  "...3.7..4..9....5...64..9.......2473...8.....5.....6..4......398...3......19..52."
            db  "78...........14....3.....21.4..367....3.......7.18....9.........5.6..4....82.9.6."
            db  "..91..47.1........27....68...4.....931.7........3...6.9...54...6.8.3.......8...2."
            db  "..8...41.1..52..3.5..4.........7...12.3..9.4..5..6.9...6.....8..82..........863.4"
            db  "6..1.5.....4..6.2..1..8...3.3...7..1....9....4.7...2.8.........8..3.2.7..6.7..3.2"
            db  "......512...........9285..6......9..987.56...4.2...3....6..3...8.5.1.24....7....3"
            db  ".61......3...1..7......38......849.5..9......72....6.........1..85.....36.3.92.5."
            db  ".64...8...........5..63.9.49.....63......8.7.....41..2...85.7.9.2.......6..1....."
            db  "...5.....5.1.68.9.3.......59.71.......6...4.......5.8....6.9.73.......6...2.739.."
            db  "..2...4.......7..1...2.....2.86.9..4..4...6...7..3.....13.8..9...63......9.4..81."
            db  "..42...386.....9...7......2.38.1.....6.9.4............1..7..2.49....27.....3....1"
            db  ".....16.5............6.873...7.5.8.1..6.1.4..3..87.2....34....25........7...8...9"
            db  ".....75..6......1....1538....9.....1.76.1..23...8........2.8.6...1..4..7.......9."
            db  ".3..6.75.8...5.......8......2.6.8.4...4....7.1.3.2....5..37.49...9..4..7......1.."
            db  "..9......4873......2..4...6..5.6.87.........9...17...57.....9...4.8.73....3.2.56."
            db  ".617.........42......8...64....3...9.3.....5....5..7.8.8....5....3..54...92.1...."
            db  "..9.....3...2....4.1.8.4........1745...6.......834..915.....3.......386.6.......7"
            db  "...27....7......62.5..3..1...6....58.29.....183...1...1....4..39......8........27"
            db  ".9.1....5.86.......5.3.78..57..8..1...9..6.4..3.9.....7.8..4.3..2....1..........."
            db  "6.....4....542.....1...76....2.9.873...68..5......1.....9....3..4.3..7...2...8..."
            db  "........4.4..263..78....12...3.547.....6....3..1.7.4....94......3.5...8..5...92.."
            db  "8.....4...7..1....3.9.......5..8.73.2......6......2..1...853.9.6....1.2...5.4..1."
            db  "..248.......3.18....3....9..1.....4....8..6...9...4..52...6..8.......95.6.8.9.7.2"
            db  "89......3.263..5....3.1...69...7.....6..2.7.4.........14.....2......3.7...59....."
            db  "6......18..4...32..8..2...4..........721......63.4..8...8...9.6...4.6.7....5.38.."
            db  "..6.....8....79...1.2..3..94..2.69....3.4.....97.8....2.8...63..4..2............1"
            db  "1..4..8......36.....7....16.5....4.1......95...3..5.7..2.38..9.........8...9.2..7"
            db  "......1..2.5.....36......8..71..98.......7........163..9...3.......5.7...8..2..54"
            db  ".....83......97.511....3.7................917.78..64...9..5...678......9.25...7.."
            db  ".36.8.............78...9.....1.....29.3.4..178...7..9......3.6.1..86...9...4..8.."
            db  ".8..32.6...2..7.......9.8.473...9.....9....53.1.............43.3..8..6..6..7..9.2"
            db  "...47..18.5.....92..43......49.....5....1...352...6..........5..7.....6.9..1..8.."
            db  "...........7..1...2...4.653...1..9.53..5...4......6...........1534....9..794.8..."
            db  "......9....3.28...5..6..8..2.6.94....1.3......4......56..7.21....41...32....6...."
            db  "..3...9.27.8...1.42....7.5..8...2...16..........7..61...5.1..9......3..1.7...98.."
            db  "3..9..4.5.96....2..5......96............62.83.8.1.4...8..2.1...1..8...9.4...3.5.."
            db  "...1.3....7..9.3.1.6....4.7.5..2.98..163......2......45.......973...4......7....."
            db  ".4.....2..537...9.....436.8.....8.5..2.......36.91............55..8.72....9.6...."
            db  "..75.49..2....37..6.........6...........1.4....5....6.5.3....1...91....74...8.3.."
            db  ".673.....4....5.761........6...5....7954.8..........2...8.....7....13.8.3..7.46.."
            db  "......69.7......342..5.......6.7.1...4.8.......2.....99.14.38..4.3.1...5.....7..."
            db  ".2...57..6...4...3.8...1..94..6..83..95.1..4.............7..3...7..921.......6..."
            db  "........4...2..5....176......9..3.....41...78.7.8.29.1.1..8..9......76.52......8."
            db  "47.....1.1..........3..4..22...4..9.....5.8....6.71..4...38..4.9..........2765.3."
            db  "....59.......3..59...8....7..21..4.....3......6..9...8...7......54..18..1...84.3."
            db  "..1...9.59.........2.3..61...7.16....52.............58..4.2.......9...848....17.."
            db  "..7....69..6.4.8..3.....24.......1.7.9...5.......62..31.42.................95..8."
            db  "5..3.....46...87..7.14.........97.6...........17.6.38....5...318.4.....2......4.."
            db  "4..95...2..8...5.3....47.....5..16.....6.......7......1.4..9.38....2...7.3......4"
            db  ".1.2...6...3..69.8...........9.....25....8.....4.5.....9..8.7...46...3..1..97...5"
            db  "....81.7.2........759....8..3.24.7...4..7.......6....5.16.2.5........1..4.....3.7"
            db  ".7.3.....8...7..1.1..8..7.2....6...7..5...4..4....26.35.8..9...3......959..1..2.."
            db  ".........738..5.9.25..3.1..1....6......9..31.4...2...739..5.8.......825......4..."
            db  "..48.2.7.83....46.......13.21....6...7..85........9.5....75..4.4....1.....1......"
            db  "..86.....5.3.....7.....3......52...1.8.3..49...9..6..........8.192....56....5...3"
            db  "...9.2..1....648..6........18...7.4...45..3....7...1..81..9..2............3.4896."
            db  ".....2..1.3..4..5..9.......3......8..164.3...42.8.....65..174..14....639.......7."
            db  "....29...8....3..5...7....4479....28......36..2..8...7...3.....5.3...4...6.4...7."
            db  "952....8.34.....1...8......7....13.....2....6.3..7..42...1.25......8....8.59.4..."
            db  ".8.3.46...1...5.7.......21.3.....18.....5...4...9.2.3....7...4..52..18...6......."
            db  "..734..9...2.....73.........94...5.6.......2....6..1....5.3.7.....8143...8...6..4"
            db  ".95.38......4.6....32..9..6.5......8.....14..1.9...7.22..6...73....8......4......"
            db  "3.8..5..1........6....3.....6..9.12.52.7...3..3...1..7.4...6.....5......9..27.45."
            db  "..7.......5.3..1...2.8.67..19....6...6.182..3.........47....5.......9..6..5.4...1"
            db  "............5.9..6.8..4....5....6..9..4.13.653.12.............8.2....94.9...7.32."
            db  "...8.6...7...1....69...7....3.......84.1.3..9...684.5..5....3..1...7..483...9.7.5"
            db  ".5..39.....27.18...6.....9.7...8.6.3....2....49...7......4....2.85....6........1."
            db  ".27....8......96..15..84....3..2.1...4...6..2..5.4.3.............4.65.....1...76."
            db  ".......2...2.7...4..9..35..3.56..1....4..735.......79...........9.8..43..16.9..8."
            db  "9.12..6.......5..7...6..5...3...1..2...4.2.....59...8..7...31.....8....9........6"
            db  "6...3..9...5...4..3....251...8.....9.9...4..7...7..63..2..859.....2.........4..7."
            db  "...95....7.....4...8.16.....5.713..93..5..8.1..............1.7..26.....8.3.4..5.6"
            db  ".2.......4......6.53..2.48..1...7.5...348....85........9.7........3....5....467.2"
            db  ".....6......1.8....9....6.8..4....6.78.........1..7..5.....2..3..6.9.21...537..4."
            db  "...9...35....3.4..1...8...79....1...2.............6.744...5..21.9...75....6......"
            db  ".6..289..1.4.3...........6............7.1.58..9..4..37........1..53.4.983..96...."
            db  "..1....5.8.7..9.2..5..726......9.1.21.3...56.........84..2.....5...6.4...9...7..."
            db  "3...5.....7...35.2.2....9.3..5.46....6.....4.2..7...9.........78.....3....9.3..8."
            db  ".5...7.....9....24...3.......84.6.9..3.91.5.....8..2..39.1.......1..5.....7.6...."
            db  "......49.9..3.6......5..1.73......4...9...61...1725......2.....1.7.34....86......"
            db  ".76....3.....7...4..4...7.6...8.4..15....7.6...2...5...3...6...91..........9.3..2"
            db  "5..16.........795..41...........12..........6.8.35...4.384...2......2..315.67...."
            db  ".246..9..63.....2..5...1.......7....9.....8.......274......5.3.5...94..7.1...6..2"
            db  "....5.7......3.15..3.71.8..3.9.....4..24...1..17..9...1......6.....2...86...9.2.."
            db  "35..12.7.6.1......7...5.6....6..3.5....1.5..4.1..87.9.....7...2.8.....3....4.9..."
            db  "9..4...1..85.69.....7.....4....87...24....7...56..........3.9..........86739..15."
            db  ".8..5...7.....6...53.......2..6...48...8..61....5.2...34.1...6.82.3....91...9...."
            db  "2...5...........71..4.195.3..67.....7..13...8..549....6...4..9..27....4.3........"
            db  "65...........5..27....2...9.9.41.7....37...527..2....842..3.......9.........4.83."
            db  "......3.2..1.32.5....8..9..1.7.54....8..6.....3.......3......985....6..4.6..18..5"
            db  "6..94....5....8.....23......7..6.9...948....32...3..1.4..2..........5..8..5.7.1.."
            db  "...538.4........9.5.8....3..29.5.......86....4....2..1......5......4....7.5..19.6"
            db  ".7.3..8.539....2...4.7............87.....9...5.6..1.2.1..5.8.4...8..2....5.9....."
            db  "...89..4...3......416...5......4.....2.5.9.....9..31...37....1.8..7.2.5.2.....37."
            db  ".75.6..14..34.7.8....2..6.........6.54.....9......4...72...3..68.6.2........1.9.."
            db  "9...846..3.....2......7..8..4.9.2.....3...51...8..1...4..71...983........2.4....3"
            db  "..4..8.67...9...4.1.6...9....23.7....5.....1.61....4....1......9...5........24..8"
            db  ".14...2...7..1....5........72.....4.....8..3.4....3.2....9.83.7..57...6.9.......5"
            db  ".7398....4.6....1....4..........2...........1..8....3982.5..4...5..7....1..2.4.6."
            db  "..5.7.......1.....7.36.8.....1.6..59..8..5....62.....7.2...6......9..8.3.9...7..5"
            db  "....2.869..8...13....37..2.........4.2..4......5..6.81.5.4..7.8.7.....5...19....."
            db  "..879......7.2..14...3...9..761..5....2.....9..............8....1.645...6.......2"
            db  ".84...91....4..5.......3...7....6.2...8...6..9...1..5....6.9...24..........7..8.4"
            db  ".......2.9.6....8..843129.....8......95........1.7....6.3.495.......31.......7..."
            db  "3.......2.....4.....537.....8..45.6.1..9...4........18.2...6.8.....9.3..84.7....5"
            db  "..1....9...36....5.7...4...4..29...3......84.....5....1....3..25...7.3...8.5..4.1"
            db  ".16....3...8.7...65..3...........1.....7...5.984.15..3.....39.17..4..8....18....."
            db  ".....79...5..4......39.1.876.182..9.5...9........1....942..6.1.......6....8......"
            db  "1..6...3...3...6.9......7.4......89...6........8.43.7.5.9.8......7.3....6...291.."
            db  "...3.6....8..546.......25.7.....7286.4......1..8..3.4..36...1..1......92...2....."
            db  "........9.4.51...6.3624..............9.3...82.5..78...9.....4.5....2..3.2....6..7"
            db  "95.1..7..68.9.........8......1.....7.6.....3.5....4.6..3...16...9.6.7.5....8..1.4"
            db  "....6....24.......73.24.....527............61....5.73.32.....1.6......98..9.....6"
            db  "5.......6.3..9.5...6..4....7.........9.5.2.87....1...2...9.....4..8.6..1..8...27."
            db  ".4....58..7....9.4....36.7.........9..91...2.65..........3......3.7.2..816..5.7.."
            db  "54..72.1.1....8.....3....2.3........86.1.5.4......4.7.6..5...........9.....92..37"
            db  "741....8.8.....6..3.......7....9....95.81..3.4.6.7.59....2..........685....7..3.."
            db  "..3...6........72.45...6.8..9.3...4....9.7....17...2....6.1.5...3.8.4.9.........."
            db  "...2.7.....9.8...7..169....6..7..8....3...5.1....25...9..43.2.82.......34......6."
            db  ".....14..7.....5..46..2........9......3.1..9.8......24..8..63.......3.86..65.9.1."
            db  "1...4.82......3.1.4..7........2.9..3.6.5.........7.562.81..56........9..5..1...4."
            db  "..18.......7...4......45.198.9.....77..9......2..6..8.6.34......4....2.1.18.9...."
            db  "...1..7....9.84.3......3...4...2.69.2..5.8.............18.....2..73...5..5....413"
            db  "9..1....7.3...2....4.....8...4.75.9.2....68....1.4..........6....26.4.......83.52"
            db  "62..9......5.......7....486....3..6...8..61...6...1.38..36.5.1....4.3......18...5"
            db  "....5.8....76.4...3.61.....4....75..........37...9.....3.7.82.5........82.....3.4"
            db  "..5...1...73.....89.....3.......86.....1.7..9.8...3...7...6...551....92....27...."
            db  "...1.........97.....5....17...9.5.8.7..4...3.38..6..45..2.7.6.4...6.9.......8.15."
            db  "...8465....7.......8...9.6.....2.3.9.26......5..97...6..4.9...2....6...7..83....."
            db  ".6.4....7.....31.5.8..2.....5..9.3......4.8..74.5.......1....2.2..7....3......4.."
            db  "5.7....3.1...5.......1...72...9...23.1.6......38..1.5...9....6.8.53......2...8..."
            db  ".8.7.....36.....8......2..4...1.6...1.....9..2...43.......693.5..3.5.72......8.9."
            db  ".6.8..1....82......9....4.6........2....72...54.19......9......75....9......37..8"
            db  "...7..2...1.3....7.458......51....9.8.......1......3....9.15.38.......7..8.23.1.."
            db  "6....1..5...8...6..824.3........7.2.3.5...9.6..4..6..8...2...1...1..46...4...9..."
            db  ".1....53...3.....2...8.9..1...5..26............74....3....5.3...2...7..46.4..2.9."
            db  "..1.......8..2.....96.17.32.29.3..7.7..5.8...4.5.......7......8...6..3......591.."
            db  ".9.....1...2.6..4573..8...........5..6.7.5......64...2.7132...........6...3..84.."
            db  "...7....28.4.........6354..2.9.1.....7...95.1..5...7...4..5.....1.4...3...32..6.."
            db  "...9.8....8.1.......5..72..3.7....249.8...15....4...6..2......9.....6...13......7"
            db  "....69.4..5...79....7.41..5.............9.4.6..4..2.53.368.......1.2.........3..2"
            db  "3...9...7.16....82....2.......8..5..1..9......2.3...7.86..3...9..9.1.3........65."
            db  "......1.....2.7..84...6.2.3.8....925.......1.6...7.....3.8...5...413...78.1......"
            db  "4...3.......5...1....2..9.....4....16.8.7......1.6..32.8.....5..39....67..7....4."
            db  "....9........1..8..3...724.5..73..6.6.........725.......8146.7...4..83...2......."
            db  "5..1..6.39...6..2....5...4..346....7....1.....9.4..58.2.8.4...............9..735."
            db  "93...4..6.72..5..8........53.........569.......867......17...5..8....74........3."
            db  ".2.1..8...7...34.....7.....4...2.1..682..9..........5..478....2.6...4......9..53."
            db  ".8.6....1.....4.9.2...1.48....9.8.74..6............9..15.3.....7..5......43..96.."
            db  "..71..8...1......46....8...9.5...6....6.9..47.......95..4...23..8..1....3....2.6."
            db  ".5..........8....7..3.429.....4.........89...7..52...85...3..7..1...78.526.1...3."
            db  ".4.5.32....6.871...2......33.....6.4..1..695.........17.......64....9.3.......5.8"
            db  "....895........83..6......7....74..8..831.....76.......4....25....9....6.925..3.."
            db  "4.......2....97....62......9.7..54..53..2.......7.........1...8.5.....3..1.639..5"
            db  ".6.....7835...9.....8..2..3.3....5.6....2...4.46.1..3.......4......7......75.8.1."
            db  "4.8...16.31.....8..9....3...8..65...13...7.48.64..............7....5123....7.4..."
            db  "......6.....3.4.....7.19.2..2.....78...8....9...9...3.1.3..2.5...954.7..7...9...4"
            db  "....1.56...2....1..8...4..9.13.6.82..4..5....7......5.2.9.....7...3.1......7....."
            db  ".4..3..6......8.....157...4.8...9..39.5.....2..6..38......9..7..6.2...........18."
            db  "....3....6..81...5..8....613.14.9.86.2..5.....8...74..2.........3.5...4........1."
            db  "..3....47..4..7..5.8.3...925.7..9..8.62..5....3...........71......9....381.6....."
            db  ".....67.....7...9.13.5...2...1..5..9.8...73.5....1..8.........48.91...5.2......3."
            db  "..9..6.....61..87.....8...491...8..2.8..53..1..5......1689.7...3.....4...7......."
            db  ".......1...9...27..4...59.33.78...2.2.8..6........25..7....1......46.....1...96.."
            db  "3.4...6.....94.8...8........6....238...5....7.1..8..4......17.........532.536...."
            db  "...9.6.......1.8.38..7....1..3.69....91.....5......2....7....5.2.6..7..8...3....9"
            db  "6..9.8....8..1...7....2.........1.4..47..6125...4...8....56......3..7..8..1.3.4.6"
            db  ".......82.72......1..2.39...8....1....49......3...85.....132.54.6..9........4..3."
            db  "4....1.......4.7.93.....81..2...5.7.6..9...2...8..3..5.1...2.....618....8.7..4.6."
            db  "...7..4..53.6......96.......68....1.........23..1..9.5..2..6..8.....354......47.."
            db  "..6.52.7...4.......1..8......13..8..3.2.7...14....57........35...7..9...29.....4."
            db  "13.............6..8.....975..67....84...6..3.7....8..19..8......7....49......3..2"
            db  "1...52.....249......46..85.68.........97..12..7.....4.....41....2..6..9....9....5"
            db  "5..173.......4......8................2...9.463.18.7..5.8.2.......6.34.8..9....5.1"
            db  ".1...3..48..2.......7...12....4.8..2..3.7..1...4...6..5...3.......6.9..596....3.7"
            db  "...2....43......279.6..3..1..25..61.19......2........3..........6.3.....5738.6..."
            db  "...6..1..86.2...........53...734.........6.9....9.175..4.......3.....8.1.96..2..."
            db  "...9..2...3..2...6...5..879..5..4........2..17.139..4..594.....8...1......7...93."
            db  "..7...96121...........9..7..2......54.....8....5261......6.47..6..8.5..3.......2."
            db  "...7.9..1....8.6....1....3...34..71.5.....2..6...3.4..8.21.3.....7.6..5........4."
            db  "........5.8......7....41396...7...6.14..8.....2....1.3..4..5....6..3....9.5..7.2."
            db  "....2.4..4..63..1..7..5.....2...6.3.81........3.7.2...7....3....6...829.......85."
            db  ".2.1...58..589..2.6.3.2...1.3.689...2..............7.69....2.7.5.......9....4.5.."
            db  "..9....3.6145...7.....4...1.....6....7.2..8...5.81.......1........9.7.15..8.6...."
            db  "..2.5.3...5.7..8..6....1.....768.4...24..............3..6..7...3.8..6.9.9..4....."
            db  ".5.3..629....1....9.75..1..8...4......5.36..83.6...4....2...9.....9...7..7...8..."
            db  "...........19.7...8.416........4...2......5..97...53....6....385..8.....1.26...4."
            db  ".2...9...4.18....9......4.32.4.1.3.......6.5.7.........9.4.....5..3.......3.51..6"
            db  "...1.....389...4.....84...5.7..5.23....29.7..........6..13.4...5.7..2....96...3.."
            db  "..978....64......5....2.3..38..12..6....9.73...........1..6..5...4....185.....6.."
            db  "....6.3....72....6....1...8...4...3.6...5..9414.7...5...1.2...938...5.7..6......."
            db  "..........2.1....4649.5......8.2.9.1...54...74...19.5..8.6......52.9...3......8.."
            db  "86.........9.7.62......9.8..4....7....57....9.2...15..51..9...7..3.........182..."
            db  "9....2..64......5.52..4..9.7........2...3..6..8.79......456398....4..5.....87...."
            db  "5..7.8.....3.....9....325....5..1...1.2....3.3...4..7.........4.4..2.9.88....4.17"
            db  "..4......7.89.........85..22...5.9..41..9.63..39.1..5...1.....95...3....3..2..7.."
            db  "7.9..2..4........5..17..6.91....75......13....64.....7.3...5..6.8.....4....84...."
            db  "..296..7.....7..46.....2..8.1........69.3.15..7............8.....4.1..3....2....5"
            db  "1.7..6.9.....7..3...528.....6....91..5.....72.....9.....38..6........1..4..3.5.8."
            db  "58....16...4.83...7......2....4..8..6...7......1.6..7......9.1....6..9...92.18..."
            db  "..42..7.......5.....9.3....43...........54.181.......2.965..37.....79.........2.1"
            db  "..32...9....5..3......7.4..6.9.38...3..4.....8..91....972....6..4.....1.........7"
            db  "...2....696...58....8...14.7...2....3...9...76.....4......1..98.....8....475...3."
            db  "3..6......6.29.5...9.....6...9.......5.4.8....4895.1.2....8........42..7.8...6..3"
            db  "8......451...6.8...3..........1..3.9.1..7.....4...5..2.......53..7.28..1....3.9.."
            db  "7.2..16...98..6..........8.....52..9..3...5.69......43....2...8.4.9.7...6..4....1"
szGame      db  7 dup (0)               ; In case I ever load all 20,000 Games
hReport     db  0
hMessage    db  0
szLevel     db  10 dup (0)
system_time SYSTEMTIME  <>              ; Used to seed the random number generator

.data?
;---------------------------------------
hInstance   dd  ?
hIcon       dd  ?
hMenu       dd  ?
hHorizontal dd  ?
hWnd01      dd  ?
hWnd02      dd  ?
hWnd03      dd  ?
hWnd04      dd  ?
hWnd05      dd  ?
hWnd06      dd  ?
hFont1      dd  ?
hFont2      dd  ?
hFont3      dd  ?
hFont4      dd  ?
hFont5      dd  ?
hGame       dd  ?
pszString   dd  ?
hLocale     dd  ?
NoChange    dd  ?
CommandLine dd  ?
HintFlag    dd  ?
hover       BOOL    ?
orgStatic   dd      ?
hFinger     dd      ?
buff        db      256 dup (?)
rseed       dd      ?
hTable      db  328 dup (?)
ShowString  db  256 dup (?)

processinfo PROCESS_INFORMATION <?>
startinfo   STARTUPINFO         <?>

.code
start:
    invoke  GetModuleHandle, NULL       ; Get handle for this application
    mov     hInstance, eax              ; Save it for later usage
;   -----------------------------------------------------------
;   The following code is very necessary because if you the    ;
;   program from an icon on the Desktop, the Desktop directory ;
;   becomes the default which is not what we want. The INI     ;
;   file needs to be in the same directory as Sudoku.exe       ;
;   -----------------------------------------------------------
    invoke  GetModuleFileName, hInstance, addr GameDir, 255
    push    eax                         ; Save pointer to filename, with path
    mov     ebx, offset GameDir         ; Complete path AND filename
    add     ebx, eax                    ; Move to the end of the string
    sub     ebx, 3                      ; Minus the extension
    mov     byte ptr [ebx], 0           ; ASCIIZ
    invoke  lstrcpy, addr CurrentDir, addr GameDir  ; Currently without the extension
    invoke  lstrcat, addr GameDir, chr$("ini")      ; Now the correct path to the INI file
;   -----------------------------------------------------------
;   The same situation exists for the HTML file, it could be   ;
;   okay to have it on the Desktop, but it really needs to be  ;
;   in the same directory as Sudoku.exe for easier access.     ;
;   -----------------------------------------------------------
    invoke  lstrcpy, addr WorkSheet, addr GameDir   ; Used to Read/Write to the INI file
    pop     eax                         ; Restore pointer to filename, with path
    mov     ebx, offset WorkSheet       ; Complete path AND filename
    add     ebx, eax                    ; Move to the end of the string
    sub     ebx, 3                      ; Minus the extension
    mov     byte ptr [ebx], 0           ; ASCIIZ
    invoke  lstrcat, addr WorkSheet, chr$("html")   ; Now the correct path to the HTML file
;   -----------------------------------------------------------
;   GameDir and WorkSheet have, now, become dedicated strings  ;
;   that are used in many places throughout this program. From ;
;   this point on, the contents of these two strings shouldn't ;
;   be modified or you will have lots of problems 'nuff said.  ;
;   -----------------------------------------------------------
    invoke  GetCommandLine
    mov     CommandLine, eax
    invoke  WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    invoke  ExitProcess, eax

WinMain proc    hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
;---------------------------------------
    LOCAL   wc:WNDCLASSEX
    LOCAL   msg:MSG
    LOCAL   hwnd:HWND

    mov     wc.cbSize, SIZEOF WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra, NULL
    mov     wc.cbWndExtra, NULL
    push    hInst
    pop     wc.hInstance
    mov     wc.hbrBackground, COLOR_BTNFACE+1   ; COLOR_WINDOW+1
    mov     wc.lpszMenuName, offset MenuName
    mov     wc.lpszClassName, OFFSET ClassName
    invoke  LoadIcon, hInst, IDI_ICON1
    mov     hIcon, eax
    mov     wc.hIcon, eax
    mov     wc.hIconSm, eax
    invoke  LoadCursor, NULL, IDC_ARROW
    mov     wc.hCursor, eax
    invoke  RegisterClassEx, addr wc
;   Set the Window location, there are three options determined by the Docking value
    invoke  GetPrivateProfileString, addr szSection3, addr szKey6, chr$("1"), \
            addr szResult, 2, addr GameDir  ; Get Dock value, default on error, is 1
    invoke  AsciiBase, addr szResult, 10    ; Convert the ASCII value to a decimal integer
    mov     hDocking, al                    ; and save it
    invoke  GetSystemMetrics, SM_CXSCREEN   ; Get the Screen width
    sub     eax, 597                    ; Subtract the width of the main window
    shr     eax, 1                      ; Center the Game to the Desktop (Horizontal)
    mov     hHorizontal, eax            ; Save the value (for Docking calls)
    push    eax                         ; Save the left position of the main window
    invoke  GetSystemMetrics, SM_CYSCREEN   ; Get the Screen height
    .if hDocking == 0                   ; Put the Game as low on the Desktop as possible
;     36 pixels is the height of the Tray
      sub     eax, 420+36               ; 36 Pixels is the default height of the Tray
    .elseif hDocking == 1               ; Center the Game to the Desktop (Vertical)
@@:   sub     eax, 420                  ; Subtract the height of the main window
      shr     eax, 1                    ; Center the Game to the Desktop (Vertical)
    .elseif hDocking == 2               ; Dock the Game to the top of the screen
      mov     eax, 0                    ; Top of the Screen
    .else
      jmp     @b                        ; Error Trap result is to center
    .endif
    pop     ebx
    invoke  CreateWindowEx, NULL, addr ClassName, addr AppName, WS_OVERLAPPED or \
            WS_MINIMIZEBOX or WS_SYSMENU, ebx, eax, 597, 420, NULL, NULL, hInst, NULL
    mov     hwnd, eax
    invoke  ShowWindow, hwnd, SW_SHOWNORMAL
    invoke  UpdateWindow, hwnd
    invoke  GetMenu, hwnd
    mov     hMenu, eax
    .if hDocking == 0
      invoke  CheckMenuItem, hMenu, IDM_TOP, MF_UNCHECKED
      invoke  CheckMenuItem, hMenu, IDM_MIDDLE, MF_UNCHECKED
      invoke  CheckMenuItem, hMenu, IDM_BOTTOM, MF_CHECKED
    .elseif hDocking == 1
      invoke  CheckMenuItem, hMenu, IDM_TOP, MF_UNCHECKED
      invoke  CheckMenuItem, hMenu, IDM_MIDDLE, MF_CHECKED
      invoke  CheckMenuItem, hMenu, IDM_BOTTOM, MF_UNCHECKED
    .elseif hDocking == 2
      invoke  CheckMenuItem, hMenu, IDM_TOP, MF_CHECKED
      invoke  CheckMenuItem, hMenu, IDM_MIDDLE, MF_UNCHECKED
      invoke  CheckMenuItem, hMenu, IDM_BOTTOM, MF_UNCHECKED
    .endif
    invoke  GetPrivateProfileString, addr szSection1, addr szKey7, chr$("1"), \
            addr szResult, 2, addr GameDir
    mov     al, szResult[0]
    .if al == 30h
      invoke  CheckMenuItem, hMenu, IDM_HELPER, MF_UNCHECKED
      invoke  SendMessage, hWnd06, WM_SETTEXT, 0, NULL
    .else
      invoke  CheckMenuItem, hMenu, IDM_HELPER, MF_CHECKED
    .endif
    invoke  GetPrivateProfileString, addr szSection1, addr szKey8, chr$("0"), \
            addr szResult, 2, addr GameDir
    mov     al, szResult[0]
    .if al == 30h
      invoke  CheckMenuItem, hMenu, IDM_SOLVE, MF_UNCHECKED
    .else
      invoke  CheckMenuItem, hMenu, IDM_SOLVE, MF_CHECKED
    .endif
StartLoop:
    invoke  GetMessage, addr msg, NULL, 0, 0
    cmp     eax, 0
    je      ExitLoop
;   Process keystrokes directly in the message loop
;   --------------------------------
    .if msg.message == WM_KEYDOWN
      cmp     msg.wParam, 9h            ; TAB Key
      je      right
      cmp     msg.wParam, 8h            ; BackSpace Key
      je      bkspace
      cmp     msg.wParam, 27h           ; Right Arrow Key
      jne     left
right:invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1    ; Remove the Highlight
try1: mov     ebx, offset hTable        ; Handle Table
      mov     ecx, hLocale              ; Current location
      add     ecx, 1                    ; Move right one Button
      cmp     ecx, 81                   ; 80 is the bottom right Button
      jb      @f                        ; If not at the bottom, right
      xor     ecx, ecx                  ; 0 is the top, left Button
@@:   mov     hLocale, ecx              ; Save the new location
      shl     ecx, 2                    ; 4 bytes per handle
      add     ebx, ecx                  ; Index into the Table
      mov     eax, [ebx]                ; Get the Handle for the New Button focus
      mov     hWnd01, eax               ; Make it common
      push    ecx
      invoke  GetWindowLong, hWnd01, GWL_STYLE
      test    eax, WS_DISABLED          ; Is this Button User accessable?
      jnz     skip1                     ; Jump if no
      pop     ecx
      invoke  ShowWindow, hWnd01, SW_HIDE
      invoke  ShowWindow, hWnd01, SW_SHOW
      invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1 ; Highlight the Button
      jmp     done
skip1:pop     ecx
      jmp     try1                      ; Contine moving right (with wrap) until successful
left: cmp     msg.wParam, 25h           ; Left Arrow Key
      jne     up
bkspace:
      invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1    ; Remove the Highlight
try2: mov     ebx, offset hTable        ; Handle Table
      mov     ecx, hLocale              ; Current location
      cmp     ecx, 0                    ; 0 is the top, left Button
      jne     @f                        ; If not at the top, left Button
      mov     ecx, 81                   ; Wrap around to the bottom, right
@@:   sub     ecx, 1                    ; Move left one Button
      mov     hLocale, ecx              ; Save the new location
      shl     ecx, 2                    ; 4 bytes per handle
      add     ebx, ecx                  ; Index into the Table
      mov     eax, [ebx]                ; Get the Handle for the New Button focus
      mov     hWnd01, eax               ; Make it common
      push    ecx
      invoke  GetWindowLong, hWnd01, GWL_STYLE
      test    eax, WS_DISABLED          ; Is this Button User accessable?
      jnz     skip2                     ; Jump if no
      pop     ecx
      invoke  ShowWindow, hWnd01, SW_HIDE
      invoke  ShowWindow, hWnd01, SW_SHOW
      invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1 ; Highlight the Button
      jmp     done
skip2:pop     ecx
      jmp     try2                      ; Contine moving left (with wrap) until successful
up:   cmp     msg.wParam, 26h           ; Up Arrow Key
      jne     down
      invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1    ; Remove the Highlight
try3: mov     ebx, offset hTable        ; Handle Table
      mov     ecx, hLocale              ; Current location
      cmp     ecx, 8                    ; At the top?
      ja      @f                        ; Jump if no
      add     ecx, 81                   ; Wrap to just past the bottom of the same column
@@:   sub     ecx, 9                    ; Move up one row
      mov     hLocale, ecx              ; Save the new location
      shl     ecx, 2                    ; 4 bytes per handle
      add     ebx, ecx                  ; Index into the Table
      mov     eax, [ebx]                ; Get the Handle for the New Button focus
      mov     hWnd01, eax               ; Make it common
      push    ecx
      invoke  GetWindowLong, hWnd01, GWL_STYLE
      test    eax, WS_DISABLED          ; Is this Button User accessable?
      jnz     skip3                     ; Jump if no
      pop     ecx
      invoke  ShowWindow, hWnd01, SW_HIDE
      invoke  ShowWindow, hWnd01, SW_SHOW
      invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1 ; Highlight the Button
      jmp     done
skip3:pop     ecx
      jmp     try3                      ; Contine moving up (with wrap in the same column)
down: cmp     msg.wParam, 28h           ; Down Arrow Key
      jne     done
      invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1    ; Remove the Highlight
try4: mov     ebx, offset hTable        ; Handle Table
      mov     ecx, hLocale              ; Current location
      add     ecx, 9                    ; Move down one row
      cmp     ecx, 81                   ; A valid destination?
      jb      @f                        ; Jump if still in the matrix
      sub     ecx, 81                   ; Otherwise, wrap to the top of the same column
@@:   mov     hLocale, ecx              ; Save the new location
      shl     ecx, 2                    ; 4 bytes per handle
      add     ebx, ecx                  ; Index into the Table
      mov     eax, [ebx]                ; Get the Handle for the New Button focus
      mov     hWnd01, eax               ; Make it common
      push    ecx
      invoke  GetWindowLong, hWnd01, GWL_STYLE
      test    eax, WS_DISABLED          ; Is this Button User accessable?
      jnz     skip4                     ; Jump if no
      pop     ecx
      invoke  ShowWindow, hWnd01, SW_HIDE
      invoke  ShowWindow, hWnd01, SW_SHOW
      invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1 ; Highlight the Button
      jmp     done
skip4:pop     ecx
      jmp     try4                      ; Contine moving down (with wrap in the same column)
done: invoke  PossibilityCheck, hwnd, hLocale
      .if msg.wParam==VK_F1             ; Helpful Information?
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_HELP, 0
        jmp     StartLoop
      .elseif msg.wParam==VK_F2             ; Show Possibilities?
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_HELPER, 0
        jmp     StartLoop
      .elseif msg.wParam==VK_F3             ; Show Solution?
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_SOLVE, 0
        jmp     StartLoop
      .endif
    .endif
    .if msg.message == WM_KEYUP
      invoke  GetAsyncKeyState, VK_CONTROL
      rol     eax, 16
      cmp     ax, 1111111111111111b
      jne     ProcessMessage
      .if msg.wParam == 31h             ; Ctrl + 1
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_BLANK, 0
        jmp     StartLoop
      .elseif msg.wParam == 32h         ; Ctrl + 2
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_BEGIN, 0
        jmp     StartLoop
      .elseif msg.wParam == 33h         ; Ctrl + 3
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_CURRENT, 0
        jmp     StartLoop
      .elseif msg.wParam == 57h         ; Ctrl + W
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_PRINT, 0
        jmp     StartLoop
      .elseif msg.wParam == 4Eh         ; Ctrl + N
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_NEW, 0
        jmp     StartLoop
      .elseif msg.wParam == 52h         ; Ctrl + R
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_RESTART, 0
        jmp     StartLoop
      .elseif msg.wParam == 50h         ; Ctrl + P
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_GET, 0
        jmp     StartLoop
      .elseif msg.wParam == 55h         ; Ctrl + U
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_UNDO, 0
        jmp     StartLoop
      .elseif msg.wParam == 56h         ; Ctrl + V
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_VEASY, 0
        jmp     StartLoop
      .elseif msg.wParam == 45h         ; Ctrl + E
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_EASY, 0
        jmp     StartLoop
      .elseif msg.wParam == 4Dh         ; Ctrl + M
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_MEDIUM, 0
        jmp     StartLoop
      .elseif msg.wParam == 48h         ; Ctrl + H
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_HARD, 0
        jmp     StartLoop
      .elseif msg.wParam == 51h         ; Ctrl + Q
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_EXIT, 0
        jmp     StartLoop
      .elseif msg.wParam == 4Ch         ; Ctrl + L
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_LOAD, 0
        jmp     StartLoop
      .elseif msg.wParam == 58h         ; Ctrl + X
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_CLEAR, 0
        jmp     StartLoop
      .elseif msg.wParam == 46h         ; Ctrl + F
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_ERRCHECK, 0
        jmp     StartLoop
      .elseif msg.wParam == 49h         ; Ctrl + I
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_HINT, 0
        jmp     StartLoop
      .elseif msg.wParam == 47h         ; Ctrl + G
        invoke  SendMessage, hwnd, WM_COMMAND, IDM_CHECK, 0
        jmp     StartLoop
      .endif
    .endif
ProcessMessage:
    invoke  TranslateMessage, addr msg
    invoke  DispatchMessage,  addr msg
    jmp     StartLoop
ExitLoop:
    mov     eax, msg.wParam
    ret
;---------------------------------------
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    .if uMsg == WM_CREATE
      invoke  CreateFont, 24, 5, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, chr$("MS Sans Serif")
      mov     hFont1, eax
      invoke  CreateFont, 36, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, chr$("Arial")
      mov     hFont2, eax
      invoke  CreateFont, 16, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, chr$("Courier New")
      mov     hFont3, eax
      invoke  CreateFont, 18, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, chr$("MS Sans Serif")
      mov     hFont4, eax
      invoke  CreateFont, 18, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_SCRIPT, chr$("Arial")
      mov     hFont5, eax
      invoke  MakeBox, chr$("GeneSys Sudoku"), hWnd, 8, 3, 572, 36, 300
      mov     hWnd02, eax                               ; Game Label (Heading)
      invoke  SendMessage, hWnd02, WM_SETFONT, hFont2, 1
      invoke  MakeEditBox, NULL, hWnd, 336, 90, 230, 208, 301
      mov     hWnd03, eax                               ; Report Window Textbox (ReadOnly)
      invoke  MakeBox, chr$("Report Window"), hWnd, 326, 47, 250, 34, 302
      mov     hWnd04, eax                               ; Report Window Label (Heading)
      invoke  MakeBox, chr$("Possibilities"), hWnd, 326, 300, 250, 24, 303
      mov     hWnd05, eax                               ; Possibilitiy Window Label (Heading)
      invoke  MakeBox, NULL, hWnd, 398,326,105,18, 304
      mov     hWnd06, eax
      invoke  SendMessage, hWnd03, WM_SETFONT, hFont3, 1
      invoke  SendMessage, hWnd04, WM_SETFONT, hFont5, 1
      invoke  SendMessage, hWnd06, WM_SETFONT, hFont3, 1
      invoke  MakeBar, NULL, hWnd, 8,42,570,6, 2001     ; Top Border
      invoke  MakeBar, NULL, hWnd, 112,44,6,314, 2002   ; Vertical Grid Separator #1
      invoke  MakeBar, NULL, hWnd, 8,146,314,6, 2003    ; Horizontal Grid Separator #1
      invoke  MakeBar, NULL, hWnd, 8,42,6,318, 2004     ; Left GameBoard Border
      invoke  MakeBar, NULL, hWnd, 8,250,314,6, 2005    ; Horizontal Grid Separator #2
      invoke  MakeBar, NULL, hWnd, 216,44,6,314, 2006   ; Vertical Grid Separator #2
      invoke  MakeBar, NULL, hWnd, 320,42,6,318, 2007   ; Right GameBoard Border
      invoke  MakeBar, NULL, hWnd, 8,354,570,6, 2008    ; Bottom Border
      invoke  MakeBar, NULL, hWnd, 576,42,6,318, 2009   ; Report Window (Right Border)
      invoke  MakeBar, NULL, hWnd, 320,79,258,2, 2010   ; Report Window Divider
;     The next 4 lines frame the Possibility box - I like it better than WS_BORDER
      invoke  MakeBar, NULL, hWnd, 396,322,110,2, 2011  ; Top
      invoke  MakeBar, NULL, hWnd, 396,344,110,2, 2012  ; Bottom
      invoke  MakeBar, NULL, hWnd, 396,322,2,24, 2013   ; Left
      invoke  MakeBar, NULL, hWnd, 505,322,2,24, 2014   ; Right
;     This routine will create 81 PushButtons
;    -----------------------------------
      mov     eax, 9                    ; 9 Rows
      mov     edi, 1001                 ; First ID
      mov     edx, 46                   ; Makes sure the first pass is EDX = 46
more2:mov     esi, 12                   ; First Button location (Horizontally)
      mov     ebx, 3                    ; 3 Blocks
more1:mov     ecx, 3                    ; containing 3 Buttons
@@:   pushad                            ; Very necessary
      invoke  MakeButton, NULL, hWnd, esi, edx, 34, 34, edi
      popad                             ; Restore all Registers
      add     esi, 34                   ; Next Button
      inc     edi                       ; Next ID
      loop    @b                        ; Make a 3 Button set
      add     esi, 2                    ; Add a spacer (so the Grid is evident vertically)
      sub     ebx, 1                    ; Count the set
      jne     more1                     ; Do it 3 times (9 Buttons)
      .if eax == 4 || eax == 7          ; 3 Button set boundary?
        add     edx, 2                  ; add a spacer (so the Grid is evident horizontally)
      .endif                            ; Need 2 spacers
      add     edx, 34                   ; First Button in the next Row
      sub     eax, 1                    ; Count the Row
      jne     more2                     ; Do it 9 times
;     ----------------------------------
      invoke  GetLocalTime, addr system_time    ; Ensures the first Game appears to be random
      xor     eax, eax                  ; Need a byte value so clear the rest
      mov     ax, system_time.wMilliseconds     ; Get the currnt time (millseconds)
      mov     rseed, eax                ; Store it as the initial seed
      invoke  SetTimer, hWnd, 200, 50, offset TimerProc ; Randomizes the rest of the Games
      invoke  GetFileAttributes, addr GameDir           ; Get file attrubutes
      .if eax!=(-1)                                     ; If Sudoku.ini exists
        invoke  GetPrivateProfileString, addr szSection1, addr szKey1, chr$("1"), \
                addr szResult, 2, addr GameDir          ; Get Game Level, default = Very Easy
        xor     eax, eax                ; Makes sure only AL will have a value
        mov     ebx, offset szResult    ; Value is in this string
        mov     al, [ebx]               ; Get the value
        sub     al, 30h                 ; Convert it to a number (1-4)
        .if eax==1
          jmp     VEasy
        .elseif eax==2
          jmp     Easy
        .elseif eax==3
          jmp     Medi
        .elseif eax==4
          jmp     Hard
        .else
          jmp     errLevel              ; Can only happen as a result of manual editting
        .endif     
      .else
errLevel:
        invoke  lstrcpy, addr szLevel, chr$(", Level 1")
        invoke  ShowBoard, hWnd, addr DataVEasy
        invoke  ShowSolution
        invoke  SaveSettings            ; Store Game# and Level# in the INI file
      .endif
    .elseif uMsg==WM_COMMAND
      .if wParam == IDM_EXIT            ; Close Button?
        invoke  SendMessage, hWnd, WM_SYSCOMMAND, SC_CLOSE, NULL
      .elseif wParam == IDM_NEW
        invoke  EnableMenuItem, hMenu, IDM_RESTART, MF_BYCOMMAND or MF_ENABLED
        invoke  EnableMenuItem, hMenu, IDM_SAVE, MF_BYCOMMAND or MF_ENABLED
        invoke  EnableMenuItem, hMenu, IDM_CHECK, MF_BYCOMMAND or MF_ENABLED
        invoke  EnableMenuItem, hMenu, IDM_ERRCHECK, MF_BYCOMMAND or MF_ENABLED
        invoke  EnableMenuItem, hMenu, IDM_HINT, MF_BYCOMMAND or MF_ENABLED
        invoke  GetMenuState, hMenu, IDM_VEASY, MF_BYCOMMAND
        .if eax == MF_CHECKED
          jmp     VEasy
        .endif
        invoke  GetMenuState, hMenu, IDM_EASY, MF_BYCOMMAND
        .if eax == MF_CHECKED
          jmp     Easy
        .endif
        invoke  GetMenuState, hMenu, IDM_MEDIUM, MF_BYCOMMAND
        .if eax == MF_CHECKED
          jmp     Medi
        .endif
        invoke  GetMenuState, hMenu, IDM_HARD, MF_BYCOMMAND
        .if eax == MF_CHECKED
          jmp     Hard
        .endif
      .elseif wParam == IDM_VEASY
VEasy:  invoke  RtlZeroMemory, addr szUndoBuffer, sizeof szUndoBuffer
        invoke  CheckMenuItem, hMenu, IDM_VEASY, MF_CHECKED
        invoke  CheckMenuItem, hMenu, IDM_EASY, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_MEDIUM, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_HARD, MF_UNCHECKED
        invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0 ; Erase the Report Window
        invoke  lstrcpy, addr szLevel, chr$(", Level 1")
        invoke  ShowBoard, hWnd, addr DataVEasy
        invoke  ShowSolution
        invoke  SaveSettings
      .elseif wParam == IDM_EASY
Easy:   invoke  RtlZeroMemory, addr szUndoBuffer, sizeof szUndoBuffer
        invoke  CheckMenuItem, hMenu, IDM_VEASY, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_EASY, MF_CHECKED
        invoke  CheckMenuItem, hMenu, IDM_MEDIUM, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_HARD, MF_UNCHECKED
        invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0 ; Erase the Report Window
        invoke  lstrcpy, addr szLevel, chr$(", Level 2")
        invoke  ShowBoard, hWnd, addr DataEasy
        invoke  ShowSolution
        invoke  SaveSettings
      .elseif wParam == IDM_MEDIUM
Medi:   invoke  RtlZeroMemory, addr szUndoBuffer, sizeof szUndoBuffer
        invoke  CheckMenuItem, hMenu, IDM_VEASY, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_EASY, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_MEDIUM, MF_CHECKED
        invoke  CheckMenuItem, hMenu, IDM_HARD, MF_UNCHECKED
        invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0 ; Erase the Report Window
        invoke  lstrcpy, addr szLevel, chr$(", Level 3")
        invoke  ShowBoard, hWnd, addr DataMedium
        invoke  ShowSolution
        invoke  SaveSettings
      .elseif wParam == IDM_HARD
Hard:   invoke  RtlZeroMemory, addr szUndoBuffer, sizeof szUndoBuffer
        invoke  CheckMenuItem, hMenu, IDM_VEASY, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_EASY, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_MEDIUM, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_HARD, MF_CHECKED
        invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0 ; Erase the Report Window
        invoke  lstrcpy, addr szLevel, chr$(", Level 4")
        invoke  ShowBoard, hWnd, addr DataHard
        invoke  ShowSolution
        invoke  SaveSettings
      .elseif wParam == IDM_TOP      ; Dock the Application to the top of the Screen?
        invoke  CheckMenuItem, hMenu, IDM_TOP, MF_CHECKED
        invoke  CheckMenuItem, hMenu, IDM_MIDDLE, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_BOTTOM, MF_UNCHECKED
        mov     szResult[0], '2'
        invoke  WritePrivateProfileString, addr szSection3, addr szKey6, addr szResult, addr GameDir
        invoke  MoveWindow, hWnd, hHorizontal, 0, 597, 420, 1
      .elseif wParam == IDM_MIDDLE      ; Dock the Application to the center of the Screen?
        invoke  CheckMenuItem, hMenu, IDM_TOP, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_MIDDLE, MF_CHECKED
        invoke  CheckMenuItem, hMenu, IDM_BOTTOM, MF_UNCHECKED
        mov     szResult[0], '1'
        invoke  WritePrivateProfileString, addr szSection3, addr szKey6, addr szResult, addr GameDir
        invoke  GetSystemMetrics, SM_CYSCREEN   ; Get Screen height
        sub     eax, 420                ; ...minus the Application height
        shr     eax, 1                  ; ...divided by 2 (now we have the 'top' value
        invoke  MoveWindow, hWnd, hHorizontal, eax, 597, 420, 1
      .elseif wParam == IDM_BOTTOM      ; Dock the Application to the bottom of the Screen?
        invoke  CheckMenuItem, hMenu, IDM_TOP, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_MIDDLE, MF_UNCHECKED
        invoke  CheckMenuItem, hMenu, IDM_BOTTOM, MF_CHECKED
        mov     szResult[0], '0'
        invoke  WritePrivateProfileString, addr szSection3, addr szKey6, addr szResult, addr GameDir
        invoke  GetSystemMetrics, SM_CYSCREEN   ; Get Screen height
        sub     eax, 420+36             ; 36 Pixels is the default height of the Tray
        invoke  MoveWindow, hWnd, hHorizontal, eax, 597, 420, 1
      .elseif wParam == IDM_RESTART     ; Start over, same Puzzle?
        invoke  RtlZeroMemory, addr szUndoBuffer, sizeof szUndoBuffer
        invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1  ; Remove the Highlight
        mov     ebx, offset hTable      ; Handle Table
        mov     ecx, 81                 ; 81 buttons
@@:     mov     eax, [ebx]              ; Get Handle
        mov     hWnd01, eax             ; Make it common
        push    ecx                     ; Because it will get trashed
        invoke  GetWindowLong, hWnd01, GWL_STYLE
        test    eax, WS_DISABLED        ; Is it User selectable?
        jnz     skip                    ; Jump if no
        invoke  ShowWindow, hWnd01, SW_HIDE
        invoke  ShowWindow, hWnd01, SW_SHOW
        invoke  SendMessage, hWnd01, WM_SETTEXT, 0, 0 ; Erase any current character
skip:   pop     ecx                     ; Restore the counter
        add     ebx, 4                  ; Point to the next Handle location
        loop    @b                      ; Do this 81 times
        invoke  ShowHighLight, hWnd     ; Pick a random Button and highlight it
        invoke  ShowSolution
      .elseif wParam == IDM_SAVE        ; Write the current Puzzle in the INI file
        mov     ebx, offset szLevel     ; Get the current level
        add     ebx, 8                  ; from the display string
        invoke  WritePrivateProfileString, addr szSection2, addr szKey3, ebx, addr GameDir
        invoke  WritePrivateProfileString, addr szSection2, addr szKey4, addr szGame, addr GameDir
        mov     ebx, offset szBoard     ; Buffer for Puzzle data to be saved
        mov     ecx, 1001               ; Control identifier of the first button
again:  xor     eax, eax                ; I am a fanatic about this, oh well
        push    ecx                     ; Because it will get trashed
        invoke  GetDlgItemInt, hWnd, ecx, 0, 0  ; Get button label
        pop     ecx                     ; Restore the Contrrol Identifier
        add     al, 30h                 ; Convert it to hex
        mov     [ebx], al               ; Store it in the buffer
        add     ebx, 1                  ; Update the buffer pointer
        inc     ecx                     ; Next Control Identifier
        cmp     ecx, 1082               ; Control identifier of the last button is 1081
        jb      again
        invoke  WritePrivateProfileString, addr szSection2, addr szKey5, addr szBoard, addr GameDir
      .elseif wParam == IDM_GET         ; Restore a Puzzle saved in the INI file?
        invoke  RtlZeroMemory, addr szUndoBuffer, sizeof szUndoBuffer
        mov     byte ptr Flag, 1                ; Suppress the Puzzle Selector
        invoke  GetFileAttributes, addr GameDir ; Get file attrubutes
        .if eax!=(-1)                           ; If Sudoku.ini exists
          invoke  GetPrivateProfileString, addr szSection2, addr szKey4, chr$("999"), \
                  addr szResult, 4, addr GameDir    ; 999 is the error out value
          invoke  AsciiBase, addr szResult, 10  ; Contert the string to a number
          cmp     eax, 999                      ; Error out value (if the read failed)
          jne     works
failed:   mov     byte ptr hMessage, 1  ; Message to report there is no saved Puzzle
          invoke  Report                ; Show the error
          mov     byte ptr hMessage, 0  ; Clear the Message pointer (it has multiple usage)
          mov     byte ptr Flag, 0      ; Clear the Random Number Generator Suppress flag
          jmp     scan                  ; Back to the Message Loop
works:    mov     hGame, eax            ; Save the Puzzle number
          invoke  GetPrivateProfileString, addr szSection2, addr szKey3, chr$("1"), \
                  addr szResult, 2, addr GameDir    ; Get the Level
          xor     eax, eax
          mov     ebx, offset szResult  ; Result is in this string
          mov     al, [ebx]             ; Get the hex value
          sub     al, 30h               ; Covert the string to a numer (1-4)
          .if eax==1
            invoke  CheckMenuItem, hMenu, IDM_VEASY, MF_CHECKED
            invoke  CheckMenuItem, hMenu, IDM_EASY, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_MEDIUM, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_HARD, MF_UNCHECKED
            invoke  lstrcpy, addr szLevel, chr$(", Level 1")
            invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0   ; Erase the Report Window
            invoke  ShowBoard, hWnd, addr DataVEasy     ; Display the Puzzle
            jmp     FillBoard                           ; Display the user entries
          .elseif eax==2
            invoke  CheckMenuItem, hMenu, IDM_VEASY, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_EASY, MF_CHECKED
            invoke  CheckMenuItem, hMenu, IDM_MEDIUM, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_HARD, MF_UNCHECKED
            invoke  lstrcpy, addr szLevel, chr$(", Level 2")
            invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0   ; Erase the Report Window
            invoke  ShowBoard, hWnd, addr DataEasy      ; Display the Puzzle
            jmp     FillBoard                           ; Display the user entries
          .elseif eax==3
            invoke  CheckMenuItem, hMenu, IDM_VEASY, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_EASY, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_MEDIUM, MF_CHECKED
            invoke  CheckMenuItem, hMenu, IDM_HARD, MF_UNCHECKED
            invoke  lstrcpy, addr szLevel, chr$(", Level 3")
            invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0   ; Erase the Report Window
            invoke  ShowBoard, hWnd, addr DataMedium    ; Display the Puzzle
            jmp     FillBoard                           ; Display the user entries
          .elseif eax==4
            invoke  CheckMenuItem, hMenu, IDM_VEASY, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_EASY, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_MEDIUM, MF_UNCHECKED
            invoke  CheckMenuItem, hMenu, IDM_HARD, MF_CHECKED
            invoke  lstrcpy, addr szLevel, chr$(", Level 4")
            invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0   ; Erase the Report Window
            invoke  ShowBoard, hWnd, addr DataHard      ; Display the Puzzle
            jmp     FillBoard                           ; Display the user entries
          .else
            jmp     errLevel            ; Display a random Game, Level #1
          .endif
FillBoard:
          invoke  GetPrivateProfileString, addr szSection2, addr szKey5, chr$("A"), \
                  addr szBoard, 82, addr GameDir    ; 'A' is the error out value
;         If the Game number test was okay, then this should be, also, unless
;         the file was modified by using an editor. This traps for that,
;         if all is well, the GameBoard is updated
          mov     ebx, offset szBoard   ; Offset into the Game data
          cmp     byte ptr [ebx], 'A'   ; Was there an entry in the INI file?
          je      failed                ; Report the error and return to the Message Loop
          mov     ecx, 1001             ; 1001 is the control identifier of the first button
again1:   xor     eax, eax              ; Probably not necessary, but I am fussy
          mov     al, [ebx]             ; Get a possible character
          cmp     al, 30h               ; Nothing to display?
          je      skip1
          mov     szResult[0], al       ; Store it in the String Buffer
          push    ecx
          invoke  SetDlgItemText, hWnd, ecx, addr szResult  ; Display it on the button
          pop     ecx
skip1:    add     ebx, 1                ; Next button identifier
          inc     ecx
          cmp     ecx, 1082             ; 1081 is the control identifier of the last button
          jb      again1
;         Erase the Level number, Game number and Board content entries
          invoke  WritePrivateProfileString, addr szSection2, addr szKey3, NULL, addr GameDir
          invoke  WritePrivateProfileString, addr szSection2, addr szKey4, NULL, addr GameDir
          invoke  WritePrivateProfileString, addr szSection2, addr szKey5, NULL, addr GameDir
        .endif
        invoke  ShowSolution
      .elseif wParam == IDM_CHECK       ; Check for duplication errors?
        invoke  StatusCheck, hWnd
      .elseif wParam == IDM_ERRCHECK    ; Check for data-entry errors?
        invoke  ErrorCheck, hWnd
      .elseif wParam == IDM_HINT        ; Randomly select and show a Hint
        invoke  ShowHint, hWnd
      .elseif wParam == IDM_CLEAR       ; Clear the Report Window?
        invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0 ; Erase the Report Window
scan: .elseif wParam == IDM_LOAD        ; Load a specific Puzzle?
        invoke  RtlZeroMemory, addr szUndoBuffer, sizeof szUndoBuffer
        invoke  DialogBoxParam, hInstance, IDD_GAME, hWnd, OFFSET GameDlgProc, NULL
        cmp     NoChange, 1             ; Cancel?
        jne     @f
        ret
@@:     invoke  EnableMenuItem, hMenu, IDM_RESTART, MF_BYCOMMAND or MF_ENABLED
        invoke  EnableMenuItem, hMenu, IDM_SAVE, MF_BYCOMMAND or MF_ENABLED
        invoke  EnableMenuItem, hMenu, IDM_CHECK, MF_BYCOMMAND or MF_ENABLED
        invoke  EnableMenuItem, hMenu, IDM_ERRCHECK, MF_BYCOMMAND or MF_ENABLED
        invoke  EnableMenuItem, hMenu, IDM_HINT, MF_BYCOMMAND or MF_ENABLED
        invoke  GetMenuState, hMenu, IDM_VEASY, MF_BYCOMMAND
        .if eax == MF_CHECKED
          jmp     VEasy
        .endif
        invoke  GetMenuState, hMenu, IDM_EASY, MF_BYCOMMAND
        .if eax == MF_CHECKED
          jmp     Easy
        .endif
        invoke  GetMenuState, hMenu, IDM_MEDIUM, MF_BYCOMMAND
        .if eax == MF_CHECKED
          jmp     Medi
        .endif
        invoke  GetMenuState, hMenu, IDM_HARD, MF_BYCOMMAND
        .if eax == MF_CHECKED
          jmp     Hard
        .endif
      .elseif wParam == IDM_ABOUT       ; Kudo?
        invoke  CreateDialogParam, hInstance, addr AboutName,
                hWnd, OFFSET AboutDlgProc, NULL
      .elseif wParam == IDM_HELP        ; Information?
        invoke  DialogBoxParam, hInstance, IDD_HELP, hWnd, offset AbtDlgProc, NULL
      .elseif wParam == IDM_HELPER      ; Turn on/off the Possibilities Checker
        invoke  GetMenuState, hMenu, IDM_HELPER, MF_BYCOMMAND
        .if eax == MF_CHECKED
          invoke  CheckMenuItem, hMenu, IDM_HELPER, MF_UNCHECKED
          invoke  SendMessage, hWnd06, WM_SETTEXT, 0, NULL  ; Clear the Possibility Window
          mov     szString[0], 30h      ; Need to write a '0' in the INI file
        .else
          invoke  CheckMenuItem, hMenu, IDM_HELPER, MF_CHECKED
          mov     szString[0], 31h      ; Need to write a '1' in the INI file
          invoke  PossibilityCheck, hWnd, hLocale   ; Show the possibilities
        .endif
        invoke  WritePrivateProfileString, addr szSection1, addr szKey7, addr szString, addr GameDir
      .elseif wParam == IDM_SOLVE      ; Turn on/off the 'Show solution' option
        invoke  SendMessage, hWnd03, WM_SETTEXT, 0, 0   ; Clear the Report Window
        invoke  GetMenuState, hMenu, IDM_SOLVE, MF_BYCOMMAND
        .if eax == MF_CHECKED
          invoke  CheckMenuItem, hMenu, IDM_SOLVE, MF_UNCHECKED
          mov     szString[0], 30h      ; Need to write a '0' in the INI file
        .else
          invoke  CheckMenuItem, hMenu, IDM_SOLVE, MF_CHECKED
          mov     szString[0], 31h      ; Need to write a '1' in the INI file
        .endif
        invoke  WritePrivateProfileString, addr szSection1, addr szKey8, addr szString, addr GameDir
        invoke  ShowSolution            ; Show the solution to the current Puzzle
      .elseif wParam == IDM_PRINT       ; Display the WorkSheet for Printing
        invoke  exist, addr WorkSheet
        .if eax == 1
          invoke  lstrcpy, addr ShowString, chr$("iexplore.exe")
          invoke  ShellExecute, hWnd, NULL, addr ShowString, addr WorkSheet, addr CurrentDir, SW_SHOWNORMAL
        .else
          invoke  lstrcpy, addr ShowString, addr WorkSheet
          invoke  lstrcat, addr ShowString, chr$(" does not exist.")
          invoke  lstrcat, addr ShowString, addr szCRLF
          invoke  lstrcat, addr ShowString, chr$("You need to create a ")
          invoke  lstrcat, addr ShowString, chr$("WorkSheet before you can display it.")
          invoke  lstrcat, addr ShowString, addr szCRLF
          invoke  lstrcat, addr ShowString, chr$("From the Menu, select Option, ")
          invoke  lstrcat, addr ShowString, chr$("and then Create a WorkSheet.")
          invoke  lstrcat, addr ShowString, addr szCRLF
          invoke  lstrcat, addr ShowString, chr$("Next, select the type of WorkSheet you ")
          invoke  lstrcat, addr ShowString, chr$("wish to create.")
          invoke  MessageBox, NULL, addr ShowString, chr$("Search has failed..."), MB_OK \
                  or MB_ICONEXCLAMATION
        .endif
      .elseif wParam == IDM_BLANK       ; Display Blank WorkSheet?
        invoke  MakeWorkSheet, hWnd, 1
      .elseif wParam == IDM_BEGIN       ; ...with starting values?
        invoke  MakeWorkSheet, hWnd, 2
      .elseif wParam == IDM_CURRENT     ; ...with ALL values?
        invoke  MakeWorkSheet, hWnd, 3
      .elseif wParam == IDM_UNDO        ; Undo the last move
        mov     szString[0], 20h        ; Space character is used as an eraser
        invoke  SendMessage, hWnd01, WM_SETFONT, hFont1, 1  ; Set the font for the button
        invoke  SendMessage, hWnd01, WM_SETTEXT, 0, addr szString   ; Erase the button
        invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1  ; Remove the Highlight
        lea     esi, szUndoBuffer       ; Locations storage buffer
        mov     edi, esi                ; Save the pointer to the starting location
        cmp     dword ptr [esi], 0      ; Is the Undo Buffer empty?
        je      zero
@@:     mov     eax, [esi]              ; Looking for the last entry in the buffer
        add     esi, 4                  ; Update the buffer pointer
        cmp     eax, 0                  ; EOF
        jne     @b
        sub     esi, 8                  ; Point to the last entry
        cmp     esi, edi                ; Is there only one entry in the buffer?
        je      @f
        xor     eax, eax                ; For clearing the entry
        mov     [esi], eax              ; Clear the last entry
        cmp     esi, edi                ; First location?
        je      @f
        sub     esi, 4                  ; Point to the new last entry
        mov     eax, [esi]              ; Get the location value
        mov     hLocale, eax            ; hLocale is the offset into the Handle Table
@@:     mov     eax, [esi]              ; Get the offset
        mov     ebx, offset hTable      ; Handle Table
        shl     eax, 2                  ; Multiply the offset by 4 (Handles are 4 bytes wide)
        add     ebx, eax                ; Point to the desired Handle location
        mov     eax, [ebx]              ; Get the Handle
        mov     hWnd01, eax             ; Store it in the common variable
zero:   invoke  ShowWindow, hWnd01, SW_HIDE
        invoke  ShowWindow, hWnd01, SW_SHOW ; Force a repaint of the button (only)
        invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1   ; Highlight the Button
      .elseif wParam > 1000 && wParam < 1082    ; If a button is clicked ...
;       Remove the highlight from the previous location
        invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1
        mov     eax, wParam
        mov     ebx, offset hTable      ; Table contains all button handles
        sub     eax, 1001               ; Control identifier of the first button
        mov     hLocale, eax            ; Store it as a number in the range of 0-80
        je      first
@@:     add     ebx, 4                  ; Keep searching for the Handle
        sub     eax, 1                  ; until it is found
        jne     @b
first:  mov     eax, [ebx]              ; Get the Handle to the button just clicked
        mov     hWnd01, eax             ; Store it in the common usage variable
        invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1
        invoke  ShowWindow, hWnd01, SW_HIDE     ; A work-around to reliably force a repaint
        invoke  ShowWindow, hWnd01, SW_SHOW     ; of the button without using Paint code
;       I use the above method instead of sending WM_CTLCOLORBTN so I don't have to get the
;       Device Context and Brush constantly, for this use it works marvelously but it would
;       be a lousy idea to do an entire window in this manner (flicker).
        invoke  PossibilityCheck, hWnd, hLocale
      .endif
    .elseif uMsg==WM_DESTROY
      invoke  DestroyIcon, hIcon
      invoke  DeleteObject, hFont1
      invoke  DeleteObject, hFont2
      invoke  DeleteObject, hFont3
      invoke  DeleteObject, hFont4
      invoke  DeleteObject, hFont5
      invoke  PostQuitMessage, NULL
    .elseif uMsg==WM_CHAR
      mov     eax, wParam
      cmp     al, 20h                   ; SpaceBar
      je      space
@@:   cmp     al, 60h                   ; NumberPad Value, lower limit
      jb      @f
      cmp     al, 69h                   ; NumberPad Value, upper limit
      ja      done
      sub     al, 30h                   ; Convert the value to 0-9 and continue
@@:   cmp     al, 30h                   ; Lowest possible number
      jb      done
      ja      @f
      mov     al, 20h                   ; Convert '0' to a Space
@@:   cmp     al, 39h                   ; Highest possible number
      ja      done
space:mov     szString[0], al           ; Store the character in the display string
      lea     esi, szUndoBuffer         ; Undo Buffer
      lea     edi, szTopOfBuffer        ; Is it full?
      cmp     word ptr [esi], 0         ; Is it empty?
      je      empty                     ; Continue 'as is' if no
@@:   mov     eax, [esi]                ; Get the saved offset into the Handle table
      add     esi, 4                    ; Looking for the next available location
      cmp     eax, 0                    ; Position #1?
      jne     @b                        ; Jump if no
      sub     esi, 4                    ; Now pointing to one past the last entry
      cmp     esi, edi                  ; Is the Undo buffer full? 
      jb      empty                     ; If it still is not full
;     If we are here, the Undo buffer is full so we will
;     resize it by shifting all the stored locations down
;     10 positions. This will mean that the first 10 moves
;     will be lost. The chances of this needing to be done
;     are remote; but, it IS possible so it must be dealt
;     with. The following code will accomplish this.
      lea     edi, szUndoBuffer         ; Undo Buffer
      add     esi, 40                   ; 10 dwords     
@@:   mov     eax, [esi]                ; Get saved location value
      mov     [edi], eax                ; Store it 10 positions down in the buffer
      add     esi, 4                    ; Update the source pointer
      add     edi, 4                    ; Update the destination pointer
      cmp     eax, 0                    ; Are we done shifting?
      jne     @b                        ; Continue shifting until the top is found
;     Now we will do housekeeping
      push    edi                       ; The new top of the Undo buffer
      lea     esi, szTopOfBuffer        ; Get the safety valve position
@@:   mov     edi, 0                    ; Clear this location
      add     edi, 4                    ; Point to next location
      cmp     edi, esi                  ; All unused locations cleared?
      jne     @b                        ; repeat until they are all cleared
      pop     esi                       ; Top of buffer needs to be in ESI
empty:mov     eax, hLocale              ; Get the offset into the Handle Table
      cmp     eax, [esi-4]              ; Traps for repeated entries in the same cell
      je      @f                        ; by looking at the last entry
      mov     [esi], eax                ; Update the Undo Buffer
@@:   invoke  SendMessage, hWnd01, WM_SETFONT, hFont1, 1        ; Set the font for the cell
      invoke  SendMessage, hWnd01, WM_SETTEXT, 0, addr szString ; and display the character
      invoke  GameCheck, hWnd           ; Test for a Win
      cmp     eax, 1                    ; 1 = Win, 0 = Not yet
      jne     done
      mov     byte ptr hMessage, 2      ; Win message
      invoke  Report                    ; Display it
      mov     byte ptr hMessage, 0      ; Clear the Message pointer
done:
    .else
      invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
      ret
    .endif
    xor    eax, eax
    ret
;---------------------------------------
WndProc endp

MakeButton proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    szText  ButtonClass, "BUTTON"
    invoke  CreateWindowEx, 0, addr ButtonClass, lpText, WS_CHILD or WS_VISIBLE or \
            WS_TABSTOP or BS_FLAT or BS_PUSHBUTTON, a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeButton endp

MakeBox proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    szText  ContClass, "STATIC"
    invoke  CreateWindowEx, 0, addr ContClass, lpText, WS_CHILD or WS_VISIBLE or \
            SS_CENTER or SS_CENTERIMAGE, a, b, wd, ht, hParent, ID, hInstance, NULL

    ret
;---------------------------------------
MakeBox endp

MakeBar proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    szText  BarClass, "STATIC"
    invoke  CreateWindowEx, 0, addr BarClass, lpText, WS_CHILD or WS_VISIBLE or \
            SS_BLACKRECT, a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeBar endp

MakeEditBox proc  lpText:DWORD, hParent:DWORD, a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, ID:DWORD
;---------------------------------------
    szText  EditClass, "EDIT"
    invoke  CreateWindowEx, 0, addr EditClass, lpText, WS_CHILD or WS_VISIBLE or \
            WS_BORDER or WS_VSCROLL or ES_WANTRETURN or ES_READONLY or ES_AUTOVSCROLL or \
            ES_MULTILINE, a, b, wd, ht, hParent, ID, hInstance, NULL
    ret
;---------------------------------------
MakeEditBox endp

HyperLinkWndProc proc uses ebx HWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------
    Local   tmpFont:LOGFONT
    Local   rect:RECT
    Local   pt:POINT
;
    mov     eax, uMsg
    .if eax==WM_NCHITTEST               ; If the mouse clicked?
      mov     eax, 1                    ; Save the condition
      ret
    .elseif eax == WM_CTLCOLORSTATIC    ; Paint request?
      push    ebx
      push    edx
      invoke  SendMessage, HWnd, WM_GETFONT, 0, 0   ; Get the current font for the label
      mov     edx, eax                              ; Save it
      invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont  ; Get the DC of the font
      mov     tmpFont.lfUnderline, TRUE             ; Need to underline the text
      invoke  CreateFontIndirect, addr tmpFont      ; Create the modified font
      mov     ebx, eax                              ; Save the font
      invoke  SelectObject, wParam, ebx             ; Select its DC
      .if hover == FALSE                            ; Is the mouse over the label?
        invoke  SetTextColor, wParam, Blue          ; Color the text Blue, if no
      .else
        invoke  SetTextColor, wParam, Red           ; Else, color it Red
      .endif
;     0ECE9D8h is the default background color of dialog boxes
      mov     eax, 0D8E9ECh;            ; Needs to be reversed, of course
      invoke  SetBkColor, wParam, eax   ; Set the background color to be the same
      invoke  DeleteObject, ebx         ; Delete the Device Context
      invoke  GetStockObject, HOLLOW_BRUSH  ; Get a Brush (Paint the Label)
      pop     edx
      pop     ebx
      ret
    .elseif eax==WM_MOUSEMOVE           ; Did the mouse move?
      invoke  GetParent, HWnd           ; Get handle of window that created this window
      push    ebx                       
      mov     ebx, eax                  ; Save it for comparison
      invoke  GetActiveWindow           ; Get the handle to the active window
      .if eax == ebx                    ; Is it this window?
        invoke  GetCursorPos, addr pt   ; Get Cursor position
        invoke  GetWindowRect, HWnd, addr rect  ; Get area to watch
        invoke  PtInRect, addr rect, pt.x, pt.y ; Is the mouse over the window
        .if eax
          invoke  GetCapture            ; Get handle of this window (if the mouse is over it)
          .if !eax                      ; If the mouse is not captured...
            invoke  SetCapture, HWnd    ; Capture the mouse
            mov     hover, TRUE         ; Watching for a hover event
            invoke  InvalidateRect, HWnd, FALSE, FALSE
            invoke  SetCursor, hFinger  ; Change the Curser
          .endif
        .else
          invoke  GetCapture            ; Get handle of this window (if the mouse is over it)
          .if eax                       ; If the mouse is captured...
            invoke  ReleaseCapture      ; Release it
            mov     hover, FALSE        ; No longer watching for mouse movement
            invoke  InvalidateRect, HWnd, FALSE, FALSE
          .endif
        .endif
      .endif
      pop     ebx
      xor     eax, eax
      ret
    .elseif eax==WM_LBUTTONDOWN
      invoke  GetWindowText, HWnd, offset buff, sizeof buff ; Change this for using a preset url
      invoke  ShellExecute, NULL, offset szOpen, offset buff, NULL, NULL, SW_MAXIMIZE   ; Change this to represent your preset url
      mov     hover, FALSE
      invoke  InvalidateRect, HWnd, FALSE, FALSE
      invoke  SendMessage, HWnd, WM_GETFONT, 0, 0           ; Get the default system font
      mov     edx, eax                                      ; Store result
      invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont  ; Get our font into a logfont structure
      mov     tmpFont.lfUnderline, TRUE                     ; Under line the link
      invoke  CreateFontIndirect, addr tmpFont              ; Create the new font
      mov     ebx, eax                                      ; We need the return to free the memory later
      invoke  SelectObject, wParam, ebx                     ; Select our control
      invoke  SetTextColor, wParam, Blue                    ; Change this to change the color of the link
      xor     eax, eax                                      ; No errors
      ret                                                   ; Return
    .endif
    invoke  CallWindowProc, orgStatic, HWnd, uMsg, wParam, lParam   ;Passes message information to the next stop
    ret                                                 ; Return
;---------------------------------------
HyperLinkWndProc endp

AboutDlgProc proc hwnd:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    mov     eax, iMsg
    .if eax==WM_INITDIALOG
      invoke  GetDlgItem, hwnd, IDC_URL ; Need to subclass this label
      invoke  SetWindowLong, eax, GWL_WNDPROC, addr HyperLinkWndProc
      mov     orgStatic, eax            ; Save the handle to the subclass procedure
      mov     hFinger, eax
      xor     eax, eax                  ; Should return 0
      ret
    .elseif eax == WM_CTLCOLORSTATIC    ; Paint request?
      invoke  SendMessage, lParam, iMsg, wParam, lParam
      ret
    .elseif eax==WM_CLOSE
      invoke  EndDialog, hwnd, NULL
    .elseif eax==WM_COMMAND
      push    edx
      mov     eax, wParam               ; Get message
      mov     edx, eax
      shr     edx, 16
      .if eax==IDC_EXIT                 ; Close request?
        invoke  SendMessage, hwnd, WM_CLOSE, NULL, NULL
        invoke  EndDialog, hwnd, NULL
      .endif
      pop     edx
    .else
      mov     eax, FALSE
      ret
    .endif
    mov      eax, TRUE
    ret
;---------------------------------------
AboutDlgProc endp

ShowBoard proc uses ebx edx esi edi ecx HWnd, pString
;---------------------------------------
    m2m     pszString, pString          ; Makes the string public for later use
    invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1    ; Remove the Highlight
    mov     ebx, hGame                  ; Just in case a Game was selected using IDM_LOAD
    cmp     byte ptr Flag, 0            ; If 1, a Game has been chosen
    jne     chosen
    invoke  Random, 499                 ; Randomly (sort of) select a Puzzle
    .if eax == 0
      mov     eax, 1
    .endif
    mov     ebx, eax
    mov     hGame, ebx                  ; Save the Puzzle Number
chosen:
    mov     byte ptr Flag, 0            ; Clear the flag
    mov     esi, pString                ; Points to Puzzle #1 of the requested level
    cmp     ebx, 0                      ; Puzzle #1?
    je      done
@@: add     esi, 81                     ; Add 81 bytes per Puzzle, keep updating the
    sub     ebx, 1                      ; buffer pointer until Puzzle is found
    je      done
    jmp     @b
done:
    mov     ebx, 1001                   ; Control identifier of the first button
    lea     edi, szString               ; String used to display button values
@@: invoke  GetDlgItem, HWnd, ebx       ; Get Handle
    mov     ecx, ebx                    ; Make a copy of the identifier
    sub     ecx, 1001                   ; Convert it for indexing
    shl     ecx, 2                      ; Each step (or Handle) is four bytes
    mov     edx, offset hTable          ; Button Handle Table
    add     edx, ecx                    ; Offset to correct location for current button
    mov     [edx], eax                  ; Save the Handle
    mov     hWnd01, eax                 ; Make it current
    mov     dl, [esi]                   ; Get Button data
    mov     [edi], dl                   ; Prepare it for display (need ASCIIZ to do the job)
    cmp     dl, 2Eh                     ; Show a blank button?
    jne     okay
    invoke  SendMessage, hWnd01, WM_SETTEXT, 0, 0 ; Erase any current character
    xor     eax, eax
    mov     hLocale, ebx                ; Save the pointer into the Handle Table
    sub     hLocale, 1001               ; as an index
    or      eax, WS_CHILD or WS_VISIBLE or WS_TABSTOP or BS_FLAT or BS_PUSHBUTTON
    invoke  SetWindowLong, hWnd01, GWL_STYLE, eax   ; Don't want a highlight
    invoke  SendMessage, hWnd01, WM_SETFONT, hFont1, 1  ; Set the font for the button
    jmp     next
okay:
    invoke  SendMessage, hWnd01, WM_SETFONT, hFont1, 1  ; Set the font for the button
    invoke  SendMessage, hWnd01, WM_SETTEXT, 0, addr szString   ; Display the character
    invoke  GetWindowLong, hWnd01, GWL_STYLE
    or      eax, WS_DISABLED            ; Disable the button
    invoke  SetWindowLong, hWnd01, GWL_STYLE, eax   ; No highlight and not selectable
next:
    add     esi, 1                      ; Next character
    add     ebx, 1                      ; Next Button identifier
    cmp     ebx, 1082                   ; 81 Buttons to deal with
    jb      @b
    invoke  ShowHighLight, HWnd         ; Pick a playable button at random and highlight it
    invoke  dwtoa, hGame, addr szGame   ; Convert the puzzle number to a string
    invoke  lstrcpy, addr szTitle, addr AppName ; 'Suduko, '
    invoke  lstrcat, addr szTitle, addr szLevel ; 'Level ' plus number (1-4)
    invoke  lstrcat, addr szTitle, chr$(" - #") ; ' - #'
    invoke  lstrcat, addr szTitle, addr szGame  ; Puzzle number
    invoke  SetWindowText, HWnd, addr szTitle   ; Display above string in the TitleBar
    invoke  lstrcpy, addr szReport, chr$("Looking for a Solution.")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    invoke  Solver, HWnd
    invoke  PossibilityCheck, HWnd, hLocale
    ret
;---------------------------------------
ShowBoard endp

Random  proc    range:DWORD
;--------------------------------------
    mov     eax, rseed                  ; rseed varies according to the timer
    mov     ecx, 23                     ; Multiplier used to inflate that value
    mul     ecx                         ; The rest of this stuff just mucks with the result
    add     eax, 7                      ; in such a way that the ssed is
    and     eax, 0FFFFFFFFh             ; returned with a different value
    ror     eax, 1                      ; to prevent sequential Puzzles
    xor     eax, rseed                  ; being chosen by this process
    mov     rseed, eax                  ; because TimerProc just bumps the seed by one
    mov     ecx, range                  ; Largest value allowed
    xor     edx, edx                    ; Prepare for the result of the division
    div     ecx                         ; Get the Integer portion of the result
    mov     eax, edx                    ; Result is returned in EAX
    ret
;--------------------------------------
Random  endp

TimerProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;--------------------------------------
    inc     rseed                       ; Pretty basic, I know, but it is good enough
    ret
;--------------------------------------
TimerProc endp

GameDlgProc PROC hWndw:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    LOCAL   hCtl:HWND

    .if iMsg==WM_INITDIALOG
      invoke  GetDlgItem, hWndw, IDC_EDT1
      invoke  SendMessage, eax, WM_SETFONT, hFont3, 1
      mov     NoChange, 0
      invoke  GetDlgItem, hWndw, IDC_GAME
      mov     hCtl, eax
      invoke  SetDlgItemInt, hWndw, IDC_GAME, 0, FALSE
      invoke  SetFocus, hCtl
      invoke  SendMessage, hCtl, EM_LIMITTEXT, 3, 0
    .elseif iMsg==WM_CLOSE
      mov     NoChange, 1
      invoke  EndDialog, hWndw, NULL
    .elseif iMsg==WM_COMMAND
      mov     eax, wParam
      mov     edx, eax
      shr     edx, 16
      .if dx==BN_CLICKED                ; Was a button clicked?
        .if eax==IDC_CANCEL             ; Was it the cancel button?
          mov     NoChange, 1
          invoke  EndDialog, hWndw, NULL
        .elseif eax==IDC_PREVIEW
          invoke  GetDlgItemInt, hWndw, IDC_GAME, 0, FALSE    ; Get Game number
          cmp     eax, 499              ; Largest value allowed - Puzzle #500
          ja      fail
          mov     ebx, eax              ; Make a copy for processing
          mov     esi, pszString        ; Points to Game #1 of the current level
          cmp     eax, 0                ; Puzzle #1?
          je      done
@@:       add     esi, 81               ; 81 bytes per game
          sub     ebx, 1                ; Keep searching for the right Puzzle
          je      done
          jmp     @b
done:     mov     ecx, 81               ; 81 characters in each Puzzle
          lea     edi, ShowString       ; String used for previewing
          rep     movsb                 ; Get the Puzzle
          mov     byte ptr [edi], 0     ; ASCIIZ Terminator
          invoke  SetDlgItemText, hWndw, IDC_EDT1, addr ShowString  ; Display the Puzzle
        .elseif eax==IDC_OK             ; If it was the okay button
          invoke  GetDlgItemInt, hWndw, IDC_GAME, 0, FALSE    ; Get Game number
          cmp     eax, 500              ; Test for valid entry
          jb      @f
fail:     invoke  SetDlgItemInt, hWndw, IDC_GAME, 0, FALSE  ; Clear the entry window
          invoke  SetFocus, hCtl        ; Set focus to the entry window
          jmp     again                 ; And try again
@@:       mov     hGame, eax            ; Save the Puzzle number
          mov     byte ptr Flag, 1      ; Set the 'Chosen' flag
          invoke  EndDialog, hWndw, NULL
again:  .endif
      .endif
    .else
      mov     eax, FALSE
      ret
    .endif
    mov     eax, TRUE
    ret
;---------------------------------------
GameDlgProc endp

GameCheck proc hWndw:HWND
;---------------------------------------
    xor     ebx, ebx
    mov     ecx, 1001                   ; Control identifier of the first button
pb: xor     eax, eax
    push    ecx
    invoke  GetDlgItemInt, hWndw, ecx, 0, 0 ; Get Button data
    pop     ecx
    cmp     eax, 0                      ; If the Button has no data
    jne     @f                          ; then the Puzzle is not solved
peb:mov     eax, 0                      ; Set for 'Not Solved'
    ret
@@: add     ebx, eax                    ; Add the value
    inc     ecx                         ; Point to next identifier
    cmp     ecx, 1082                   ; 1081 is the last identifier
    jb      pb                          ; Continue until all have been tested
    cmp     ebx, 405                    ; If number is differnet, something is amiss
    jne     peb                         ; so it is not a win, for sure
;   At this point, all the buttons have a label and there are 9 sets of 9,
;   now we must check the matrix (both down and across to see if it is a win
    mov     ecx, 1001                   ; Control identifier of the first button
bep:xor     ebx, ebx
    mov     edx, ecx                    ; Get start of row
    add     edx, 9                      ; Need to point to the start of the next row
    push    ecx
@@: push    ecx
    push    edx
    invoke  GetDlgItemInt, hWndw, ecx, 0, 0 ; Get Button data
    pop     edx
    pop     ecx
    add     ebx, eax                    ; Add the value
    inc     ecx                         ; Point to next identifier 
    cmp     ecx, edx                    ; Entire row counted?
    jb      @b
    cmp     ebx, 45                     ; Correct?
    jne     peb
    pop     ecx
    add     ecx, 9                      ; Point to the next row
    cmp     ecx, 1082                   ; Done?
    jb      bep
;   Matrix going across is correct, now we must check the matrix going down
    mov     ecx, 1001                   ; Control identifier of the first button
bpp:xor     ebx, ebx
    mov     edx, ecx                    ; Get start of column
    add     edx, 81                     ; Bottoming out value
    push    ecx
@@: push    ecx
    push    edx
    invoke  GetDlgItemInt, hWndw, ecx, 0, 0 ; Get Button data
    pop     edx
    pop     ecx
    add     ebx, eax                    ; Add the value
    add     ecx, 9                      ; Point to the next identifier
    cmp     ecx, edx                    ; Past the last item in the column?
    jb      @b
    cmp     ebx, 45                     ; Correct?
    jne     peb
    pop     ecx
    add     ecx, 1                      ; Point to next column
    cmp     ecx, 1010                   ; Testing 9 columns only
    jb      bpp
;   Probably, the sub-grids should be tested, also, but the above
;   seems to provide a correct evaluation because both axis' prove
;   correct. So we will assume the Game is won and disable all the
;   buttons to show that fact.
    invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_PUSHBUTTON, 1  ; Remove the Highlight
    mov     ebx, offset hTable          ; Table of Button Handles
    mov     ecx, 81                     ; 81 Buttons
@@: mov     eax, [ebx]                  ; Get handle
    mov     hWnd01, eax                 ; Store it in the common variable
    push    ecx
    invoke  GetWindowLong, hWnd01, GWL_STYLE
    test    eax, WS_DISABLED            ; Is this a disabled button?
    jnz     is
    invoke  ShowWindow, hWnd01, SW_HIDE
    invoke  ShowWindow, hWnd01, SW_SHOW
    invoke  GetWindowLong, hWnd01, GWL_STYLE    ; Get the current dwStyles for this button
    or      eax, WS_DISABLED                    ; Disable the button
    invoke  SetWindowLong, hWnd01, GWL_STYLE, eax
is: pop     ecx
    add     ebx, 4                      ; Handles are 4 bytes wide, point to the next one
    loop    @b
    invoke  EnableMenuItem, hMenu, IDM_RESTART, MF_BYCOMMAND or MF_GRAYED   ; Disable some
    invoke  EnableMenuItem, hMenu, IDM_SAVE, MF_BYCOMMAND or MF_GRAYED      ; of the Menu
    invoke  EnableMenuItem, hMenu, IDM_CHECK, MF_BYCOMMAND or MF_GRAYED     ; items until a
    invoke  EnableMenuItem, hMenu, IDM_ERRCHECK, MF_BYCOMMAND or MF_GRAYED  ; new Game is
    invoke  EnableMenuItem, hMenu, IDM_HINT, MF_BYCOMMAND or MF_GRAYED      ; started
    mov     eax, 1                      ; Report the win via a flag
    ret
;---------------------------------------
GameCheck endp

AbtDlgProc PROC hWind:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    .if uMsg == WM_INITDIALOG
      Invoke  SendMessage, hWind, WM_SETICON, 1, hIcon  ; Display an icon
      invoke  SendDlgItemMessage, hWind, IDC_TITLE_1, WM_SETFONT, hFont1, 0
      invoke  SendDlgItemMessage, hWind, IDC_EDT2, WM_SETFONT, hFont3, 0
      invoke  SetDlgItemText, hWind, IDC_EDT2, addr szNotes ; Display the default text
      invoke  GetDlgItem, hWind, IDC_EDT2   ; Get edit box handle
      invoke  SetFocus, eax                 ; Set focus to the edit box
    .elseif uMsg == WM_CLOSE
      invoke  EndDialog, hWind, NULL
    .elseif uMsg == WM_COMMAND
      mov     eax, wParam
      .if ax == IDC_CLOSE
        invoke  SendMessage, hWind, WM_CLOSE, NULL, NULL
      .elseif ax == IDC_NOTES1          ; 'In General' button
        invoke  SetDlgItemText, hWind, IDC_EDT2, NULL   ; Clear the window
        invoke  SendDlgItemMessage, hWind, IDC_EDT2, WM_SETFONT, hFont4, 0  ; using this font
        invoke  SetDlgItemText, hWind, IDC_EDT2, addr szInfo    ; Display the text
        invoke  GetDlgItem, hWind, IDC_NOTES1   ; Get button handle
        invoke  EnableWindow, eax, FALSE    ; Disable the button
        invoke  GetDlgItem, hWind, IDC_NOTES2   ; Get button handle
        invoke  EnableWindow, eax, TRUE     ; Enable the button
        invoke  GetDlgItem, hWind, IDC_EDT2 ; Get edit box handle
        invoke  SetFocus, eax               ; Set focus to the edit window
      .elseif ax == IDC_NOTES2          ; 'How To Play' button
        invoke  SetDlgItemText, hWind, IDC_EDT2, NULL   ; Display the text
        invoke  SendDlgItemMessage, hWind, IDC_EDT2, WM_SETFONT, hFont3, 0  ; using this font
        invoke  SetDlgItemText, hWind, IDC_EDT2, addr szNotes   ; Display the text
        invoke  GetDlgItem, hWind, IDC_NOTES2   ; Get button handle
        invoke  EnableWindow, eax, FALSE    ; Disable the button
        invoke  GetDlgItem, hWind, IDC_NOTES1   ; Get button handle
        invoke  EnableWindow, eax, TRUE     ; Enable the button
        invoke  GetDlgItem, hWind, IDC_EDT2   ; Get edit box handle
        invoke  SetFocus, eax
      .endif
    .else
      mov     eax, FALSE               ; Means there were problems of some sort
      ret
    .endif
    mov     eax, TRUE                  ; Means all went well
    ret
;---------------------------------------
AbtDlgProc endp

ShowHighLight proc hWndw:DWORD
;---------------------------------------
pb: invoke  Random, 81                  ; 81 buttons to choose from
    cmp     eax, 0                      ; Button #1?
    jne     @f
    sub     eax, 1                      ; Change to zero base to suit the table
@@: mov     ebx, offset hTable          ; Table contains all the button handles
    mov     hLocale, eax                ; Save the offset to the top left button
    shl     eax, 2                      ; Handles are 4 bytes wide
    add     ebx, eax                    ; Get the offset into the table
    mov     eax, [ebx]                  ; Get the handle
    mov     hWnd01, eax                 ; Default to save
    invoke  GetWindowLong, hWnd01, GWL_STYLE
    test    eax, WS_DISABLED            ; Is it a playable button?
    jnz     pb                          ; Start over if the button is not playable
    invoke  ShowWindow, hWnd01, SW_HIDE
    invoke  ShowWindow, hWnd01, SW_SHOW
    invoke  SendMessage, hWnd01, BM_SETSTYLE, BS_DEFPUSHBUTTON, 1   ; Outline the button
    ret
;---------------------------------------
ShowHighLight endp

SaveSettings proc
;---------------------------------------
    mov     ebx, offset szLevel
    add     ebx, 8
    invoke  WritePrivateProfileString, addr szSection1, addr szKey1, ebx, addr GameDir
    invoke  WritePrivateProfileString, addr szSection1, addr szKey2, addr szGame, addr GameDir
    ret
;---------------------------------------
SaveSettings endp

;---------------------------------------;
; Converts a Dec, Hex, Oct or Bin ASCII ;
; string to a 32 bit unsigned number.   ;
;---------------------------------------;
AsciiBase proc uses ecx ebx edx esi edi Input, Base
;---------------------------------------
    mov     esi, Input                  ; ASCIIZ string containing the numer to be converted
    xor     edi, edi
    invoke  lstrlen, Input              ; Get amount of characters
    xor     ecx, ecx
    .while (eax)
      .if byte ptr [esi+ecx] > 60h      ; Lowercase Alpha?
        sub     byte ptr [esi+ecx], 57h ; Convert to a number in the range of 10-16
      .elseif byte ptr [esi+ecx] > 40h  ; Uppercase Alpha?
        sub     byte ptr [esi+ecx], 37h ; Convert to a number in the range of 10-16
      .else
        xor     byte ptr [esi+ecx], 30h ; Convert to a number in the range of 0-9
      .endif
      dec     eax                       ; Continue until all have been converted
      inc     ecx                       ; Amount of characters now in ECX
    .endw
    mov     ebx, 1                      ; Multiplier
    mov     esi, Input                  ; Point to the number array
    add     esi, ecx                    ; Point to the least significant digit
    dec     esi                         ; which is here
    xor     edx, edx
    .while (ecx)
      mov     al, byte ptr [esi]        ; Get number conversion
      and     eax, 000000ffh            ; Mask the unneeded portion of EAX
      imul    eax, ebx                  ; Multiplty the number
      add     edi, eax                  ; Accumulate the result
      imul    ebx, Base                 ; Get next multiplier
      dec     esi                       ; Point to next digit
      dec     ecx                       ; Continue until all are processed
    .endw
    mov     eax, edi                    ; Copy the result to EAX for return value
    ret
;---------------------------------------
AsciiBase ENDP

StatusCheck proc uses ebx ecx edx edi esi hWndw:HWND
;---------------------------------------
    LOCAL   Count:BYTE
    LOCAL   hRepeat:BYTE

;   First we will get all the button values into a string for processing
    mov     ebx, offset szBoard         ; Buffer for button values
    mov     ecx, 1001                   ; First button identifier
again:
    xor     eax, eax
    push    ecx
    invoke  GetDlgItemInt, hWndw, ecx, 0, 0 ; Get Button data
    pop     ecx
    add     al, 30h                     ; Convert it to hex
    mov     [ebx], al                   ; Place it in the buffer
    add     ebx, 1                      ; Update the buffer pointer
    inc     ecx                         ; Point to next button identifier
    cmp     ecx, 1082                   ; Do it 81 times
    jb      again

;   Now, we check for duplicates in the Rows
    mov     byte ptr hReport, 0         ; Clear the error report flag
    mov     ebx, offset szBoard         ; Point to the array of values
    mov     szLocus[0], 31h             ; Initialize the possible warning message
next2:
    mov     byte ptr Count, 0           ; Clear the result counter
    mov     dl, 31h                     ; Start with one
    mov     ecx, 9                      ; 9 rows
next1:
    push    ecx
    push    ebx
    mov     ecx, 9                      ; 9 numbers per row
@@: cmp     byte ptr [ebx], dl          ; Test for a match
    jne     no
    inc     Count                       ; Count the match
    .if Count >= 2                      ; Error, if more than one match
      pushad
      mov     szString[0], dl           ; Number that will be addded to the error message
      mov     byte ptr hReport, 1       ; Chooses the type of report
      invoke  lstrcpy, addr szMessage, addr szRow   ; For Row
      invoke  Report                    ; Display the error message
      popad
    .endif
no: add     ebx, 1                      ; Next Character in the array
    loop    @b                          ; Do it 9 times per number
    add     dl, 1                       ; Next number to be tested
    mov     byte ptr Count, 0           ; Clear the match counter
    pop     ebx
    pop     ecx
    loop    next1                       ; 9 numbers to test (9 times as shown above)
    add     szLocus[0], 1               ; Update the warning message (Shows the Row)
    add     ebx, 9                      ; Move to next row (relatively speaking)
    cmp     byte ptr [ebx], 0           ; EOS?
    jne     next2                       ; Continue until all numbers have been tested
;--------------------------------------------------------------------------------
;   Now, we check for duplicates in the Columns
    mov     ebx, offset szBoard         ; Point to the array of values
    mov     esi, ebx                    ; Column pointer
    add     esi, 9                      ; Point to next column
    mov     szLocus[0], 31h             ; Initialize the possible warning message
next4:
    mov     byte ptr Count, 0           ; Clear the match counter
    mov     dl, 31h                     ; Start with one
    mov     ecx, 9                      ; 9 Columns to test
next3:
    push    ecx
    push    ebx
    mov     ecx, 9                      ; 9 Characters per column
@@: cmp     byte ptr [ebx], dl          ; Test for a match
    jne     no1
    inc     Count                       ; Count the match
    .if Count >= 2                      ; Error, if more than one match
      pushad
      mov     szString[0], dl           ; Number that will be addded to the error message
      mov     byte ptr hReport, 1       ; Chooses the type of report
      invoke  lstrcpy, addr szMessage, addr szColumn    ; For Column
      invoke  Report                    ; Display the error message
      popad
    .endif
no1:add     ebx, 9                      ; Update the Column pointer
    loop    @b                          ; Do it 9 times
    add     dl, 1                       ; Next number to be tested
    mov     byte ptr Count, 0           ; Clear the match counter
    pop     ebx
    pop     ecx
    loop    next3                       ; 9 numbers to test 9 times
    add     szLocus[0], 1               ; Update the warning message (Shows the Row)
    add     ebx, 1                      ; Next Column
    cmp     ebx, esi                    ; All 9 tested?
    jne     next4                       ; Continue until done
;--------------------------------------------------------------------------------
;   Now, we check for duplicates in the Sub-Grids
    mov     byte ptr Flag, 0            ; Clear the Triplet check flag
    mov     ebx, offset szBoard         ; Get the data buffer address
    mov     esi, ebx                    ; Make a copy of it
    xor     edi, edi
    xor     edx, edx
    mov     szLocus[0], 31h             ; Initialize the possible warning message
next6:
    mov     ecx, 9                      ; Nine numers to test (each cell is tested nine times
    mov     dl, 31h                     ; Initialize to numer one
    mov     byte ptr Count, 0           ; Clear the match counter
next5:
    push    ecx
    mov     ecx, 3                      ; 3 Grids wide
no2:cmp     byte ptr [ebx], dl          ; Look for a match (Grid relative - Column locus #1)
    jne     @f
    inc     Count                       ; Count it
@@: cmp     byte ptr [ebx+1], dl        ; Look for a match (Grid relative - Column locus #2)
    jne     @f
    inc     Count                       ; Count it
@@: cmp     byte ptr [ebx+2], dl        ; Look for a match (Grid relative - Column locus #3)
    jne     @f
    inc     Count                       ; Count it (an error is a value of 2 or more)
@@: .if Count >= 2                      ; Error, if more than one match
      pushad
      .if byte ptr hRepeat == 0         ; First display on this pass?
        mov     szString[0], dl         ; Number that will be addded to the error message
        mov     byte ptr hRepeat, 1     ; Avoid repeating the same message
        mov     byte ptr hReport, 1     ; Choose the type of report
        invoke  lstrcpy, addr szMessage, addr szSubGrid ; For Grid
        invoke  Report                    ; Display the error message
      .endif
      popad
    .endif
    add     ebx, 9                      ; Update the data buffer pointer
    loop    no2                         ; Do it 3 times (9 tests for each number)
    cmp     byte ptr Count, 2           ; Any duplicates?
    jb      @f
@@: mov     byte ptr Count, 0           ; Clear the match counter
    mov     byte ptr hRepeat, 0         ; Clear for next pass
    add     dl, 1                       ; Bump the test number (1-9 inclusive)
    mov     ebx, esi                    ; Restore the first position in the current Grid
    pop     ecx                         ; Restore the Number count
    loop    next5                       ; 3 Grids down
    mov     byte ptr Count, 0           ; Clear the match counter
    add     esi, 3                      ; Move right one Grid
    inc     Flag                        ; Traps for Grid #4 and Grid #7
    cmp     byte ptr Flag, 3            ; 3 (or 6) Grids have been tested if Flag==3
    jne     @f                          ; If not moving to Grid #4 or Grid #7
    mov     byte ptr Flag, 0            ; Clear the Trap Flag
    add     esi, 18                     ; Move to Grid #4 or #7
@@: mov     ebx, esi                    ; Update the position in the data buffer accordingly
    add     szLocus[0], 1               ; Bump the Grid Number used for the Report, if necessary
    add     edi, 1                      ; Bump the Grid Counter
    cmp     edi, 9                      ; 9 Grids to check
    jne     next6                       ; Repeat until all 9 are checked
    mov     byte ptr Flag, 0            ; MUST be zeroed on exit as it is used elsewhere
    mov     byte ptr hRepeat, 0         ; Clear the repeat counter
    .if byte ptr hReport == 0           ; If no warnings were issued ...
      invoke  lstrcpy, addr szReport, chr$("There are no duplication errors.")
      invoke  lstrcat, addr szReport, addr szCRLF
      invoke  lstrcat, addr szReport, addr szCRLF
      invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    .else                               ; Always end with the following
      mov     byte ptr hReport, 0       ; Clear the report flag
    .endif
    invoke  lstrcpy, addr szReport, chr$("      ----*****----")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    ret
;---------------------------------------
StatusCheck endp

Report proc
;---------------------------------------
;   Saving all registers is done because lstrcpy and lstrcat are sloppily written
;   For certain, ebx and ecx are destroyed, maybe others; so why take a chance
    pushad                              ; Save the Register values
    cmp     byte ptr hMessage, 1        ; Points to error message
    je      failed
    cmp     byte ptr hMessage, 2        ; Points to the end-game message
    je      winner
;   [szLocus] needs to be in the range of 31h - 39h
@@: invoke  lstrcpy, addr szReport, addr szError
    invoke  lstrcat, addr szReport, addr szMessage
    invoke  lstrcat, addr szReport, addr szLocus
    invoke  lstrcat, addr szReport, addr szInvolve
    invoke  lstrcat, addr szReport, addr szString
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
display:
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    popad                               ; Restore the Register values
    ret
failed:
    invoke  lstrcpy, addr szReport, chr$("Load Failure ....")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, chr$("There is no saved Game!")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, chr$("      ----*****----")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    jmp     display
winner:
    invoke  lstrcpy, addr szReport, chr$("Congratulations!! The Game is over and You have won!!")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, chr$("Press Ctrl + N to start a new Puzzle")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, chr$("      ----*****----")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  SendMessage, hWnd06, WM_SETTEXT, 0, NULL
    jmp     display
;---------------------------------------
Report endp

MakeWorkSheet proc hWndw, hMethod
;---------------------------------------
    local   hHandle:HWND
    local   bRead:DWORD
    local   temp_dw:DWORD
    LOCAL   Count:BYTE

    .if hMethod == 1
;     Request is for a blank WorkSheet
      mov     ecx, 81                   ; Puzzle has 81 locations
      mov     ebx, offset szBoard       ; Buffer for Puzzle data
      mov     al, 30h                   ; Fill will be Zeroes (they wont be visible)
ws1:  mov     [ebx], al                 ; Store it in the buffer
      add     ebx, 1                    ; Update the buffer pointer
      loop    ws1                       ; Fill the buffer
      mov     byte ptr [ebx], 0         ; Just to be on the safe side
    .elseif hMethod == 2
;     Request is for a WorkSheet with the Current Puzzle starting condition
      mov     ebx, offset szLevel       ; Get the current level
      add     ebx, 8                    ; from the display string
      xor     eax, eax                  ; Mask the unused parts
      mov     al, [ebx]                 ; Get the current level
      .if al == 31h                     ; If Level #1
        lea     esi, DataVEasy          ; Current data block
      .elseif al == 32h                 ; If Level #2
        lea     esi, DataEasy           ; Current data block
      .elseif al == 33h                 ; If Level #3
        lea     esi, DataMedium         ; Current data block
      .elseif al == 34h                 ; If Level #4
        lea     esi, DataHard           ; Current data block
      .else
        ret                             ; Logical, but should never happen
      .endif
      mov     ebx, hGame                ; Point to the current Puzzle data
      cmp     ebx, 0                    ; Puzzle #1?
      je      done                      ; Already poing to the correct offset?
@@:   add     esi, 81                   ; Add 81 bytes per Puzzle, keep updating the
      sub     ebx, 1                    ; buffer pointer until Puzzle is found
      je      done
      jmp     @b                        ; Continue until found
done: mov     edi, offset szBoard       ; Buffer for Puzzle data
      mov     ecx, 81                   ; Puzzle has 81 locations
ws2:  mov     al, [esi]                 ; Get a character
      cmp     al, 2Eh                   ; A Period?
      jne     @f                        ; If not a blank (that is what a Period represents)
      mov     al, 30h                   ; Zero - used to mark a blank
@@:   mov     [edi], al                 ; Store it in the scratch string
      inc     esi                       ; Update the buffer pointer
      inc     edi                       ; Update the string pointer
      loop    ws2                       ; Build the string
      mov     byte ptr [edi], 0         ; Just to be on the safe side
    .elseif hMethod == 3
;     Request is for a WorkSheet with the Current Puzzle condition
      mov     ebx, offset szBoard       ; Buffer for Puzzle data
      mov     ecx, 1001                 ; Control identifier of the first button
ws3:  xor     eax, eax
      push    ecx
      invoke  GetDlgItemInt, hWndw, ecx, 0, 0   ; Get button label
      pop     ecx
      add     al, 30h                   ; Convert it to hex
      cmp     al, 30h                   ; Is the Button blank?
      jne     @f                        ; If not blank, store the value
      mov     al, 30h                   ; Zero - used to mark a blank
@@:   mov     [ebx], al                 ; Store it in the buffer
      add     ebx, 1                    ; Update the buffer pointer
      inc     ecx
      cmp     ecx, 1082                 ; Control identifier of the last button is 1081
      jb      ws3
    .else
      invoke  MessageBox, NULL, chr$("Please email whoever claims to have written this Program and report you received this message."), chr$("Programming Error!!"), MB_OK
      ret                               ; Programming error, this should not happen
    .endif
;   Try to create a new html file
    invoke  CreateFile, addr WorkSheet, GENERIC_READ or GENERIC_WRITE, \
            0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, NULL
    mov     hHandle, eax                    ; Hanle to the opened file
    invoke  GetLastError                    ; Error will show if file exists
    .if( eax != ERROR_ALREADY_EXISTS )      ; File Needs to be Created or
      .if( eax == 0 )                       ; New File Created
        invoke  lstrcpy, addr WorkBuffer, addr szHeading
        .if hMethod != 1                    ; Blank WorkSheet should suppress Game and Level
          mov     ebx, offset szLevel       ; Current Level is found in this string
          add     ebx, 2                    ; Don't need the Comma and Space
          invoke  lstrcat, addr WorkBuffer, ebx
          invoke  lstrcat, addr WorkBuffer, chr$(" - Puzzle #")
          invoke  lstrcat, addr WorkBuffer, addr szGame
        .endif
        invoke  lstrcat, addr WorkBuffer, addr szHeading2
        invoke  lstrlen, addr WorkBuffer
        mov     temp_dw, eax                ; Length of of string is now in temp_dw
;       Write data to new file
        invoke  WriteFile, hHandle, addr WorkBuffer, temp_dw, addr bRead, NULL
      .else                                 ; Error opening file
        invoke  CloseHandle, hHandle
;       Display error opening file dialog
        invoke  MessageBox, NULL, addr WorkSheet, chr$("Error Opening File"), MB_OK
        ret
      .endif
    .else
      invoke  SetFilePointer, hHandle, 0, NULL, FILE_BEGIN
      invoke  SetEndOfFile, hHandle
      invoke  lstrcpy, addr WorkBuffer, addr szHeading
      .if hMethod != 1                    ; Blank WorkSheet should suppress Game and Level
        mov     ebx, offset szLevel       ; Current Level is found in this string
        add     ebx, 2                    ; Don't need the Comma and Space
        invoke  lstrcat, addr WorkBuffer, ebx
        invoke  lstrcat, addr WorkBuffer, chr$(" - Puzzle #")
        invoke  lstrcat, addr WorkBuffer, addr szGame
      .endif
      invoke  lstrcat, addr WorkBuffer, addr szHeading2
      invoke  lstrlen, addr WorkBuffer
      mov     temp_dw, eax                ; Length of of string is now in temp_dw
;     Write data to new file
      invoke  WriteFile, hHandle, addr WorkBuffer, temp_dw, addr bRead, NULL
    .endif
;   We're here if the file was opened successfully, now we write the rest of the stuff
    mov     ebx, offset szBoard           ; Data for the Current Puzzle
    xor     esi, esi
    mov     byte ptr Count, 9             ; Nine Grids
ws4:invoke  lstrcpy, addr WorkBuffer, addr szPrefix
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi]             ; Grid relative, Cell #1 of first Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite  ; Used to hide the zeroes
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack  ; Everything else, as normal
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi+1]             ; Grid relative, Cell #2 of first Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi+2]             ; Grid relative, Cell #3 of first Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szMiddle
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi+9]             ; Grid relative, Cell #1 of second Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi+10]             ; Grid relative, Cell #2 of second Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi+11]             ; Grid relative, Cell #3 of second Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szMiddle
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi+18]             ; Grid relative, Cell #1 of third Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi+19]             ; Grid relative, Cell #2 of third Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szLeftCell
    mov     al, [ebx+esi+20]             ; Grid relative, Cell #3 of third Row
    push    eax
    .if al == 30h
      invoke  lstrcat, addr WorkBuffer, addr szWhite
    .else
      invoke  lstrcat, addr WorkBuffer, addr szBlack
    .endif
    pop     eax
    mov     szCellData[0], al
    invoke  lstrcat, addr WorkBuffer, addr szCellData
    invoke  lstrcat, addr WorkBuffer, addr szFontEOF
    invoke  lstrcat, addr WorkBuffer, addr szRightCell
    invoke  lstrcat, addr WorkBuffer, addr szSuffix
    .if Count == 7 || Count == 4        ; Only want 3 Grids per Grid Row
      invoke  lstrcat, addr WorkBuffer, addr szTriplet  ; Start a new set of 3 Grids
      add     esi, 18                   ; Orient the Data pointer for the next set
    .endif
    invoke  lstrlen, addr WorkBuffer
    mov     temp_dw, eax                ; Length of of string is now in temp_dw
    invoke  SetFilePointer, hHandle, 0, NULL, FILE_END
    invoke  SetEndOfFile, hHandle
    invoke  WriteFile, hHandle, addr WorkBuffer, temp_dw, addr bRead, NULL
    add     ebx, 3                      ; Next Grid start location
    dec     Count                       ; Count the Grid
    jne     ws4                         ; Continue until there are 3 sets of 3
    invoke  SetFilePointer, hHandle, 0, NULL, FILE_END
    invoke  SetEndOfFile, hHandle
    invoke  lstrcpy, addr WorkBuffer, addr szEnding
    invoke  lstrlen, addr WorkBuffer
    mov     temp_dw, eax                ; Length of of string is now in temp_dw
    invoke  WriteFile, hHandle, addr WorkBuffer, temp_dw, addr bRead, NULL
    invoke  CloseHandle, hHandle        ; Close the file
    ret
;---------------------------------------
MakeWorkSheet endp

PossibilityCheck proc hWndw, Position
;---------------------------------------
    local   Column:DWORD
    local   Row:DWORD
    local   Grid:DWORD

    invoke  GetMenuState, hMenu, IDM_HELPER, MF_BYCOMMAND
    .if eax == MF_UNCHECKED             ; If this option is not turned on...
      ret                               ; quietly return to the Message Loop
    .endif
;   First, we locate the values of the X and Y axis' of the focale point
    mov     ecx, 0                      ; Start will Row #1, of course
@@: cmp     ecx, Position               ; The current focal point
    ja      @f                          ; Past the focal point?
    add     ecx, 9                      ; Next Row start position
    jmp     @b                          ; Search start of Row containing the focal point
@@: sub     ecx, 9                      ; Now we have the Row start position
    add     ecx, 1001                   ; Convert it into a Control Identifier
    mov     Row, ecx                    ; Save X axis coordinate
    mov     ecx, Position               ; The current focal point
@@: cmp     ecx, 9                      ; Searching in 6 Columns
    jb      @f                          ; Past the correct Column?
    sub     ecx, 9                      ; Now we have the Column start position
    jmp     @b                          ; Search start of Column containing the focal point
@@: mov     Column, ecx                 ; Save Y axis coordinate (still an index pointer)
;   Now, we locate which Grid the focale point is in. there are 3 sets of 3 Grids
;   We will start with the third set and search upwards untill we find the right set
    mov     ecx, 54                     ; Upper, left corner of Grid #7
@@: cmp     Position, ecx               ; Is the focal point in this set?
    jae     @f                          ; We are done if it is
    sub     ecx, 27                     ; Move up to the next set
    cmp     ecx, 0                      ; Are we at the top?
    jne     @b                          ; Continue until we get the right set
@@: add     ecx, 1001                   ; Convert it into a Control Identifier
    mov     Grid, ecx                   ; Save the Grid set pointer (it will be an offset)
;   Got the right 3 Grids now we need to narrow it to 1
    push    Column                      ; Save the Y axis coordinate or Column index pointer
@@: cmp     Column, 2                   ; In this Grid?
    jbe     @f                          ; Done, if it is
    add     Grid, 3                     ; Move to the next Grid
    sub     Column, 3                   ; Need a Grid relative value (3 Columns per Grid)
    jmp     @b                          ; Search until the right Grid is found
@@: pop     Column                      ; Restore Column index pointer
    add     Column, 1001                ; Now, we can convert it into a Control Identifier
;   Create the Possibility Mask
    invoke  lstrcpy, addr ShowString, chr$("0123456789")    ; The zero is just a placeholder
    mov     ecx, 9                      ; Nine numbers to mask
@@: xor     eax, eax                    ; Make sure only AL will have a value (for indexing)
    push    ecx                         ; Will get destroyed, otherwise
    invoke  GetDlgItemInt, hWndw, Row, 0, 0     ; Get button label
    pop     ecx                         ; Restore the counter
    add     Row, 1                      ; Move to the next location in the Row
    mov     ShowString[eax], 20h        ; Mask the label value
    loop    @b                          ; Do it 9 times
    mov     ecx, 9                      ; Nine numbers to mask
@@: xor     eax, eax                    ; Make sure only AL will have a value (for indexing)
    push    ecx                         ; Will get destroyed, otherwise
    invoke  GetDlgItemInt, hWndw, Column, 0, 0  ; Get button label
    pop     ecx                         ; Restore the counter
    add     Column, 9                   ; Move to the next location in the Column
    mov     ShowString[eax], 20h        ; Mask the label value
    loop    @b                          ; Do it 9 times
    mov     ecx, 3                      ; 3 sets of 3 numbers to mask
pc1:push    ecx                         ; Save the set counter
    push    Grid                        ; Save the Grid set pointer
    mov     ecx, 3                      ; Three numbers to mask
@@: push    ecx                         ; Save the counter
    xor     eax, eax                    ; Make sure only AL will have a value (for indexing)
    invoke  GetDlgItemInt, hWndw, Grid, 0, 0    ; Get button label
    pop     ecx                         ; Restore the counter
    add     Grid, 9                     ; Update the buffer pointer
    mov     ShowString[eax], 20h        ; Mask the label value
    loop    @b                          ; Do it 3 times (3 locations per Grid Row)
    pop     Grid                        ; Restore the Grid start location for Column indexing
    add     Grid, 1                     ; Move to the next Column
    pop     ecx                         ; Restore the counter
    loop    pc1                         ; Do it 3 times (3 locations per Grid Column)
;   Remove the leading zero that was put there to fix for indexing
    mov     ebx, offset ShowString      ; Possibility Mask
    add     ebx, 1                      ; Move past the zero
;   Show the resulting possibilities
    invoke  SendMessage, hWnd06, WM_SETTEXT, 0, ebx
    ret
;---------------------------------------
PossibilityCheck endp

Solver proc hWndw
;---------------------------------------
    local   col:BYTE
    local   row:BYTE

;   First we will get all the button
;   values into a string for processing
    mov     ebx, offset szBoard         ; Buffer for button values
    mov     ecx, 1001                   ; First button identifier
again:
    xor     eax, eax
    push    ecx
    invoke  GetDlgItemInt, hWndw, ecx, 0, 0 ; Get Button data
    pop     ecx
    add     al, 30h                     ; Convert it to hex
    mov     [ebx], al                   ; Place it in the buffer
    add     ebx, 1                      ; Update the buffer pointer
    inc     ecx                         ; Point to next button identifier
    cmp     ecx, 1082                   ; Do it 81 times
    jb      again
;   Make a copy of the szBoard to szSolution
    lea     esi, szBoard
    lea     edi, szSolution
    mov     ecx, 20
    rep     movsd
    movsb
    mov     col, 0                      ; Y = 0
    mov     row, 0                      ; X = 0, Start at top left corner
nextone:
    lea     edi, szSolution
    movzx   eax, row
    lea     eax, [eax*8+eax]            ; *9
    add     al, col                     ; => square #
    add     edi, eax
    mov     al, [edi]                   ; Get number in that square
    cmp     byte ptr [edi-82], 30h      ; Check against original grid
    jz      onemore                     ; Process that square if originally empty
godown:
;   Proceed to next square
    inc     col
    .if col > 8
      mov     col, 0
      inc     row
      .if row > 8
        jmp     done                    ; Puzzle solved
      .endif
    .endif
    jmp     nextone
onemore:
;   Increment the number in that square
    inc     al
    .if al > "9"
      mov     byte ptr [edi], 30h
@@:   dec     col                       ; Regress to previous square
      .if SIGN?
        mov     col, 8
        dec     row
        .if   SIGN?
;         No solution could be found, report error leave
          invoke  MessageBox, NULL, chr$("This Puzzle is no longer solvable!"), chr$("A(n) Error(s) have been found..."), MB_OK or MB_ICONERROR
          ret
        .endif
      .endif
      dec     edi
      cmp     byte ptr[edi-82], 30h     ; Check original grid
      jnz     @b                        ; Continue regression if it was not empty
      mov     al, [edi]
      jmp     onemore
    .endif
;   Check squares of row to the left of current square
    .if col != 0
      push    edi
      dec     edi
      movzx   ecx, col
      std
      repnz   scasb
      cld
      pop     edi
      jz      onemore                   ; If same number exists already
    .endif
;   Check squares of row to the right of current square
    .if col != 8
      push    edi
      inc     edi
      mov     ecx, 8
      sub     cl, col
      repnz   scasb
      pop     edi
      jz      onemore                   ;If same number exists already
    .endif
;   Check squares of column above current square
    .if row != 0
      movzx   ebx, row
      imul    ebx, 9
      neg     ebx
@@:   cmp     al, [edi+ebx]
      jz      onemore
      add     ebx, 9
      jnz     @b
    .endif
;   Check squares of column below current square
    .if row != 8
      mov     ebx, 8
      sub     bl, row
      imul    ebx, 9
@@:   cmp     al, [edi+ebx]
      jz      onemore
      sub     ebx, 9
      jnz     @b
    .endif
;   Determine the position of the square within its "box"
    push    eax
    mov     bl, 3
    movzx   eax, col
    div     bl
    mov     dl, ah                      ; Remainder is column position within box
    movzx   eax, row
    div     bl
    mov     dh, ah                      ; Remainder is row position within box
    pop     eax
;   Check the 4 remaining squares in the appropriate box
    .if dl == 0
      .if dh == 0
        cmp     al, [edi+10]
        jz      onemore
        cmp     al, [edi+11]
        jz      onemore
        cmp     al, [edi+19]
        jz      onemore
        cmp     al, [edi+20]
        jz      onemore
      .elseif dh == 1
        cmp     al, [edi+10]
        jz      onemore
        cmp     al, [edi+11]
        jz      onemore
        cmp     al, [edi-8]
        jz      onemore
        cmp     al, [edi-7]
        jz      onemore
      .else
        cmp     al, [edi-16]
        jz      onemore
        cmp     al, [edi-17]
        jz      onemore
        cmp     al, [edi-8]
        jz      onemore
        cmp     al, [edi-7]
        jz      onemore
      .endif
    .elseif dl == 1
      .if dh == 0
        cmp     al, [edi+10]
        jz      onemore
        cmp     al, [edi+8]
        jz      onemore
        cmp     al, [edi+19]
        jz      onemore
        cmp     al, [edi+17]
        jz      onemore
      .elseif dh == 1
        cmp     al, [edi+10]
        jz      onemore
        cmp     al, [edi+8]
        jz      onemore
        cmp     al, [edi-8]
        jz      onemore
        cmp     al, [edi-10]
        jz      onemore
      .else
        cmp     al, [edi-19]
        jz      onemore
        cmp     al, [edi-17]
        jz      onemore
        cmp     al, [edi-8]
        jz      onemore
        cmp     al, [edi-10]
        jz      onemore
      .endif
    .else
      .if dh == 0
        cmp     al, [edi+8]
        jz      onemore
        cmp     al, [edi+7]
        jz      onemore
        cmp     al, [edi+17]
        jz      onemore
        cmp     al, [edi+16]
        jz      onemore
      .elseif dh == 1
        cmp     al, [edi-10]
        jz      onemore
        cmp     al, [edi-11]
        jz      onemore
        cmp     al, [edi+8]
        jz      onemore
        cmp     al, [edi+7]
        jz      onemore
      .else
        cmp     al, [edi-10]
        jz      onemore
        cmp     al, [edi-11]
        jz      onemore
        cmp     al, [edi-19]
        jz      onemore
        cmp     al, [edi-20]
        jz      onemore
      .endif
    .endif
    mov   [edi],al                      ; The number is currently acceptable
    jmp   godown                        ; Go to the next square
done:
    invoke  lstrcpy, addr szReport, chr$("Success ...")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    ret
;---------------------------------------
Solver endp

ShowSolution proc
;---------------------------------------
    invoke  GetPrivateProfileString, addr szSection1, addr szKey8, chr$("0"), \
            addr szResult, 2, addr GameDir
    mov     al, szResult[0]             ; Get 'Show solution' flag
    .if al == 30h                       ; If this option is not turned on...
      jmp done                          ; Show 'Ready:' prompt and return to the Message Loop
    .endif
    pushad
    invoke  lstrcpy, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, chr$("     ")   ; Prefix for each line
    popad
    mov     ebx, offset szSolution      ; Point to the solution Buffer
    mov     ecx, 9                      ; Nine Rows
pb: push    ecx                         ; Save the current Row value
    mov     ecx, 9                      ; Nine Columns per Row
@@: mov     al, [ebx]                   ; Get Solution value
    inc     ebx                         ; Update the Buffer Pointer
    mov     szResult[0], al             ; Store Character in the String Buffer
    pushad
    invoke  lstrcat, addr szReport, addr szResult   ; Build the string
    popad
    pushad
    .if ecx == 4 || ecx == 7            ; If 3 or 6 Columns have been built
      invoke  lstrcat, addr szReport, chr$(" | ")   ; Store a divider
    .endif
    popad
    loop    @b                          ; Store 9 Columns and 2 Dividers
    pop     ecx
    pushad
    invoke  lstrcat, addr szReport, addr szCRLF ; Move to the next line
    popad
    pushad
    .if ecx == 4 || ecx == 7            ; If 3 or 6 Rows have been built
      invoke  lstrcat, addr szReport, chr$("     ---- ----- ----")  ; Store a divider
      invoke  lstrcat, addr szReport, addr szCRLF   ; Move to the next line
    .endif
    invoke  lstrcat, addr szReport, chr$("     ")   ; Store the prefix that starts each line
    popad
    dec     ecx                         ; Count the Row
    cmp     ecx, 0                      ; Done?
    jne     pb                          ; Store 9 Rows and 2 Dividers
    invoke  lstrcat, addr szReport, addr szCRLF ; Move to the next line
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
done:
    invoke  lstrcpy, addr szReport, chr$("Ready:")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    ret
;---------------------------------------
ShowSolution endp

ErrorCheck proc hWndw
;---------------------------------------
    mov     ebx, offset szBoard         ; Buffer for Puzzle data
    mov     ecx, 1001                   ; Control identifier of the first button
ec1:xor     eax, eax                    ; Prepare for AL = Character
    push    ecx                         ; Save the Control Identifier
    invoke  GetDlgItemInt, hWndw, ecx, 0, 0 ; Get button label
    pop     ecx                         ; Restore the Control Identifier
    add     al, 30h                     ; Convert it to hex
@@: mov     [ebx], al                   ; Store it in the buffer
    add     ebx, 1                      ; Update the buffer pointer
    inc     ecx                         ; Next button
    cmp     ecx, 1082                   ; Control identifier of the last button is 1081
    jb      ec1                         ; Get the value of all buttons into the buffer
    lea     esi, szBoard                ; Point to the current Board contents
    lea     edi, szSolution             ; Point to the Solution buffer
    xor     ebx, ebx                    ; Prepare for Row, Column assimilation
    mov     bh, 1                       ; Initialize the Row counter
    mov     ecx, 81                     ; 81 entries to check
ec2:add     bl, 1                       ; Bump the Column counter
    cmp     bl, 10                      ; 9 Columns per Row
    jb      ec3                         ; Jump if still in range
    add     bh, 1                       ; Bump the Row Counter
    mov     bl, 1                       ; Initialize to first Column
ec3:mov     al, [esi]                   ; Get Current Puzzle Board value at this offset
    mov     ah, [edi]                   ; Get value that should be stored there
    inc     esi                         ; Update the Board Buffer Pointer
    inc     edi                         ; Update the Solution Buffer Pointer
    cmp     al, 30h                     ; Is the Cell empty?
    je      @f                          ; Don't deal with it if it is empty
    cmp     al, ah                      ; Is the Cell Entry correct?
    jne     ec4                         ; Show error (with location info) and leave
@@: loop    ec2                         ; Check the entire Board
    cmp     HintFlag, 1                 ; Is this a call from ShowHint?
    jne     @f                          ; Show message if no
    mov     eax, 0                      ; Flag that there were no errors
    ret                                 ; Done
@@: invoke  lstrcpy, addr szReport, chr$("You are doing fine.")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    mov     eax, 0                      ; Clear the Error Flag
    ret
ec4:add     bl, 30h                     ; Convert Column value to ASCII
    add     bh, 30h                     ; Convert Row value to ASCII
    push    eax                         ; Save the invalid entry (its in AL)
    invoke  lstrcpy, addr szReport, chr$("An error has been found at Row ")
    mov     szResult[0], bh             ; Store Row in the String Buffer
    invoke  lstrcat, addr szReport, addr szResult
    invoke  lstrcat, addr szReport, chr$(", Column ")
    mov     szResult[0], bl             ; Store Column in the String Buffer
    invoke  lstrcat, addr szReport, addr szResult
    invoke  lstrcat, addr szReport, chr$(" involving the use of #")
    pop     eax                         ; Restore the Invalid entry
    mov     szResult[0], al             ; Store invalid entry in the String Buffer
    invoke  lstrcat, addr szReport, addr szResult
    invoke  lstrcat, addr szReport, chr$(".")
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  lstrcat, addr szReport, addr szCRLF
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    mov     eax, 1                      ; Set the Error flag
    ret
;---------------------------------------
ErrorCheck endp

ShowHint proc hWndw
;---------------------------------------
    local   Column:DWORD
    local   Row:DWORD

    mov     HintFlag, 1                 ; Suppress unwanted message (if no errors)
    invoke  ErrorCheck, hWndw           ; Check for errors
    mov     HintFlag, 0                 ; Allow all messages
    cmp     eax, 0                      ; 0 = No Errors
    je      @f                          ; Continue if the error check went well
    ret                                 ; A report has already been made so just return
@@: xor     eax, eax                    ; Make sure only AL will have a value (for indexing)
    mov     ebx, hLocale                ; Get the index into the Handle Table
    add     ebx, 1001                   ; Convert it into a Control Identifier
    push    ecx                         ; Will get destroyed, otherwise
    invoke  GetDlgItemInt, hWndw, ebx, 0, 0     ; Get button label
    pop     ecx                         ; Restore the counter
    add     al, 30h                     ; Convert it to hex
    cmp     al, 30h                     ; Is the Focale Point on an empty cell?
    je      @f                          ; If not, report error and leave
    invoke  lstrcpy, addr szReport, chr$("Please select an empty cell before asking for a Hint.")
    invoke  SendMessage, hWnd03, EM_REPLACESEL, TRUE, addr szReport
    ret
@@: mov     ecx, hLocale                ; Get the index to the Focal Point
    mov     eax, ecx                    ; Will be used to index into the Solution buffer
    add     ecx, 1001                   ; Convert it into a Control Identifier
    lea     esi, szSolution             ; Point to the Solution buffer
    add     esi, eax                    ; at this index (offset)
    mov     al, [esi]                   ; Get the Hint
;   Processing the Hint will be via WM_CHAR so that the Undo Buffer is updated correctly
    invoke  SendMessage, hWndw, WM_CHAR, eax, 0 ; Display the Hint
    xor     eax, eax                    ; Post processing of WM_CHAR expects this
    ret
;---------------------------------------
ShowHint endp

    end     start

;   The next few lines can be safely deleted,
;   I use them for test messages.
;   ---------------------------------------
    pushad
    mov     szResult[0], al       ; Store it in the String Buffer
    invoke  MessageBox, NULL, addr szResult, addr szResult, MB_OK
    mov     szResult[0], ah       ; Store it in the String Buffer
    invoke  MessageBox, NULL, addr szResult, addr szResult, MB_OK
    popad
;   ---------------------------------------

